<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Блок - Объявления
 */

class Blocks_Board_Block extends Guard_Block
{
	/**
	 * Отображает блок поиска, в виде блока
	 *
	 */
	public function searchblockAction()
	{
		//Подключаем скрипт автодополнения городов
		Element_Autocomplete::get("#form-search [name=region]","index.php","mod:'board',go:'aj_city'");
		Factory::styleCode('
			#form-search .text {
				width: 100%;
			}
		');
	}

	/**
	 * Отображает блок поиска горизонатльный
	 *
	 */
	public function searchhorizontalAction()
	{
		Element_Autocomplete::get("#board_region","index.php","mod:'board',go:'aj_city'");
	}
	
	/**
	 * Отображает последние объявления
	 *
	 */
	public function lastadsAction()
	{
		//Получаем параметры блока
		$Params = parent::getParams();

		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		//Ключ кэширования
		$cache_key = __METHOD__;
		$data = $Cache -> get($cache_key,$Params -> cache_time);
		
		if($data == FALSE)
		{
			//Вызываем модель новостной ленты
			$this -> view -> AdsAr = parent::getModel("Ad","Board") -> getAdByLimitUnlock(0,$Params -> count);
			$this -> view -> ad_length = 100;
			$this -> view -> Params = $Params;
			
			$data = $this -> getView();
			$Cache -> set($data,$cache_key);
		}
		$this -> setCacheView($data);
	}
	
	/**
	 * Отображает облако тегов рубрик по количеству в них объявлений
	 *
	 */
	public function cloudadAction()
	{
		//Получаем параметры блока
		$Params = parent::getParams();
		
		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		//Ключ кэширования
		$cache_key = __METHOD__;
		$data = $Cache -> get($cache_key,$Params -> cache_time);
		
		if($data == FALSE)
		{
			//количество объявлений в ркбриках
			$count_ad = 0;
			$this -> view -> cat_ar = array();
			//среднее кол-во рубрик
			$this -> view -> avg_ad = 0;
			$left_cat_ar = explode(",",Lng::_("left categoryes"));
			
			//Получаем данные всех категорий и формируем с них дерево
			$cat_ar = parent::getModel("Category") -> prepCategory("getCategory");
			//Получаем количество объявлений в категориях
			$cat_ad_ar = parent::getModel("Category") -> getCountAdInCategory();
			
			//Подсчитываем объявления в родительских категориях
			parent::getLib() -> getCountAdInCat($cat_ad_ar,0,$calc_cat_ar);
			
			if(isset($cat_ar[0]))
			{
				foreach ($cat_ar[0] as $parent_cat_id => $parent_cat_title)
				{
					foreach ($cat_ar[$parent_cat_id] as $cat_id => $cat_title)
					{
						if(in_array($cat_title,$left_cat_ar))
						{
							continue;
						}
						
						$ad_count = isset($calc_cat_ar[$parent_cat_id][$cat_id]) ? $calc_cat_ar[$parent_cat_id][$cat_id] : 0;
						$count_ad += $ad_count;
						if($ad_count)
						{
							$this -> view -> cat_ar[$cat_id] = $cat_title;
							$this -> view -> count_ad_ar[$cat_id] = $ad_count;
						}
					}
				}
				$count_cat = sizeof($this -> view -> cat_ar);
				if($count_cat)
				{
					$this -> view -> avg_ad = $count_ad/$count_cat;	
				}
				$data = $this -> getView();
				$Cache -> set($data,$cache_key);
			}
		}
		$this -> setCacheView($data);
	}
	
	/**
	 * Отображает блок ТОП объявлений (определяется по количеству просмотров того или иного объявления)
	 *
	 */
	public function topadAction()
	{
		//Получаем параметры блока
		$Params = parent::getParams();

		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		//Ключ кэширования
		$cache_key = __METHOD__;
		$data = $Cache -> get($cache_key,$Params -> cache_time);
		
		if($data == FALSE)
		{
			parent::setView('./blocks/board/views/lastads.phtml');
			//Вызываем модель новостной ленты
			$this -> view -> AdsAr = parent::getModel("Ad","Board") -> getListTopAdByLimitUnlock(0,$Params -> count);
			$this -> view -> ad_length = 100;
			$this -> view -> Params = $Params;
			
			$data = $this -> getView();
			$Cache -> set($data,$cache_key);
		}
		$this -> setCacheView($data);
	}
	
	/**
	 * Отображает блок из 5 VIP случайных объявлений
	 *
	 */
	public function viprandomadAction()
	{
		//Получаем параметры блока
		$Params = parent::getParams();

		//Вызываем модель новостной ленты
		$this -> view -> AdsAr = parent::getModel("Ad","Board") -> getListVipRandomAdByLimitUnlock(0,$Params -> count);
		$this -> view -> ad_length = 100;
		$this -> view -> Params = $Params;
	}
	
	/**
	 * Блок с фильром объявлений
	 *
	 */
	public function filterAction()
	{
		//Подключаем скрипты
		Factory::js('/scripts/modules/board/filter.js');
		Factory::styleCode('
			.mod_board-filter {
				margin: 0 auto;
			}
			.mod_board-filter .text, .mod_board-filter .select {
				width: 100%;
			}
			.mod_board-filter .field {

			}
			#mod_board-filter_cat_place {

			}
		');
		
		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		//Ключ кэширования
		$cache_key = __METHOD__;

		//Получаем данные выбранных рубрик и подрубрик
		$cat_sel_ar = Request::getGet('c','array',array());
		
		//Если данные не получены, значит поиск не был выолнен
		if(sizeof($cat_sel_ar) > 0)
		{
			$cat_sel_ar = array_map('intval',$cat_sel_ar);
			//Получаем массив из ID рубрик, данные которых нужно получить
			$cat_id_ar = array_flip($cat_sel_ar);
		}
		else
		{
			$cat_id_ar = array(0);
		}
		
		//Получаем данные родительской рубрики
		$cat_ar = parent::getModel('Category','Board') -> getCategoryByParentAr($cat_id_ar);

		//Получаем данные регионов с кэша
		$rg_ar = $Cache -> get($cache_key.'-city');
		if($rg_ar == FALSE)
		{
			//Получаем данные регионов
			$RAr_ = parent::getModel('City','City') -> getCityes();
			$rg_ar = array();
			foreach ($RAr_ as $RAr_)
			{
				$rg_ar[$RAr_ -> cat_id] = $RAr_ -> cat_title;
			}
			$rg_ar = array('Город') + $rg_ar;
			$Cache -> set($rg_ar,$cache_key.'-city');
		}
		
		$this -> view -> sr_text = Request::getGet('t','Security::filterFull',NULL);
		$this -> view -> sr_region_ar = $rg_ar;
		$this -> view -> sr_region_id = Request::getGet('r','int',NULL);
		
		$this -> view -> sr_cat_ar = $cat_ar;
		$this -> view -> sr_cat_sel_ar = $cat_sel_ar;
		$this -> view -> sorting_id_ar = $cat_id_ar;
		
	}
	
	/**
	 * Отображает блок подписки на почтовую рассылку объявлений
	 *
	 */
	public function subscribeAction()
	{
		Factory::styleCode('
			#form-subscribe .text {
				width: 100%;
				text-align: center;
			}
		');
	}
	
	/**
	 * Статистика
	 */
	public function statisticsAction()
	{
		$DB = Modules_Board_Models_Ad::instance();
		$ad_ar = $DB -> getCountArAdForDesktop();
		
		$this -> view -> all = $DB -> DB -> setQuery("SELECT `ad_id`
				FROM 
			`#__mod_board_ad`
				WHERE `ad_is_lock`='0'
			","Не удалось определить количество всех объявлений","getCount");
		
		$this -> view -> today = $ad_ar[1];
	}
}
