<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Компонент рейтинга
 */

class Components_Rating_Controller extends Guard_Base 
{	
	function __construct($group=null)
	{
		$this -> group 	= $group;
	}
	
	/**
	 * Отображаем рейтинг
	 *
	 */
	public function showRating($obj_id=0,$request=null,$is_add_rating=false)
	{
		$RatingData = $this -> getObjRatingById($obj_id);
		
		//Если можно добавлять рейтниг подключаем нужный скрпт
		if($is_add_rating)
		{
			Factory::js("/library/components/rating/js/add_rating.js");
		}
		
		//Передаем данные модели в вид
		$View = new View("./library/components/rating/views/list_rating.phtml");
		$View -> request = $request;
		$View -> rt_count_clicks = $RatingData -> rt_count_clicks;
		$View -> rt_count_ball = $RatingData -> rt_count_ball;
		$View -> star_title_ar = array(
			Lng::_('Очень плохо'), 
			Lng::_('Плохо'), 
			Lng::_('Нормально'), 
			Lng::_('Хорошо'), 
			Lng::_('Очень хорошо')
		);
		$View -> avg_ball = $RatingData -> avg_ball;
		$View -> obj_id = $obj_id;
		
		return $View -> getView(); 
	}
	
	/**
	 * Обновляем данные рейтинга БД
	 *
	 * @param int $obj_id id объекта
	 * @param int $rating рейтинг
	 */
	public function updateRatingById($obj_id=0,$rating=0)
	{
		//Получаем данные модели
		$ModRating = $this -> getModel();

		//Проверяем, существования рейтинга объекта в БД
		if($ModRating -> isExistsId($obj_id))
		{
			$ModRating -> updateRatingById($obj_id,$rating);
		}
		else
		{
			$ModRating -> addRatingById($obj_id,$rating);
		}
	}
	
	/**
	 * Возвращает средне количество балов объекта
	 *
	 * @param int $obj_id id объекта
	 * @return int
	 */
	private function getObjRatingById($obj_id=0)
	{
		//Получаем данные модели
		$ModRating = $this -> getModel();
		$RatingData = $ModRating -> getRatingById($obj_id);
		
		//Проверяем, голосова ли раньше за объяление или нет
		try
		{
			CheckData::existsDataObject($RatingData);
		}
		//Если нет, устанавливаем данные по умолчанию
		catch (Exception_CheckData $e)
		{
			$RatingData = new stdClass();
			$RatingData -> avg_ball = 0;
			$RatingData -> rt_count_ball = 0;
			$RatingData -> rt_count_clicks = 0;
		}
		
		//Определяем количество желтых звездочек
		if($RatingData -> rt_count_ball)
		{
			$RatingData -> avg_ball = (int)($RatingData -> rt_count_ball/$RatingData -> rt_count_clicks);
		}
		
		return $RatingData;
	}
	
	/**
	 * Отображает срденее количетсо балов в виде JSON объекта
	 *
	 * @param int $obj_id
	 */
	public function showJSONRatingById($obj_id=0)
	{
		die(json_encode($this -> getObjRatingById($obj_id)));
	}
	
	/**
	 * Возвращает модель 
	 *
	 * @return object
	 */
	public function getModel()
	{
		static $Model;
		
		if(!$Model)
		{
			$Model = new Components_Rating_Models_Rating($this -> group);
		}
		
		return $Model;
	}
}