<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс платежной системы СМС биллинг SMSOnline
 */

class Pays_SMSOnline_Pay
{
	/**
	 * Название платежной системы
	 *
	 * @var string
	 */
	public $name = "Билилнговая система SMSOnline";
	
	/**
	 * Краткое название платежной системы
	 *
	 * @var string
	 */
	public $name_short = "SMSOnline";
	
	/**
	 * Код платежной системы
	 *
	 * @var string
	 */
	public $code = "SMSOnline";
	
	/**
	 * Ссылка на сайт
	 *
	 * @var string
	 */
	public $site = "http://smsonline.ru";
	
	/**
	 * Страница с дополнительной информацией по SMS сообщениям
	 *
	 * @var string
	 */
	public $site_sms_info = "http://num.smsonline.ru";
	
	/**
	 * Описание
	 *
	 * @var string
	 */
	public $description = "СМС Онлайн - Ваш универсальный SMS-провайдер!";

	/**
	 * Путь к логотипу платежной системы
	 *
	 * @var string
	 */
	public $path_logo = "/library/pays/smsonline/images/logo.png";
	
	/**
	 * Объект дополнительных полей
	 *
	 * @var object
	 */
	public $FormItem = null;
	
	/**
	 * Объект дополнительных текстовых надписей на форме
	 *
	 * @var object
	 */
	public $FormLabel = null;
	
	/**
	 * Action формы (передается в вид)
	 *
	 * @var string
	 */
	public $form_action = null;
	
	/**
	 * Объект данных для внуттренних работ в классе
	 *
	 * @var object
	 */
	public $SmsData = null;
	
	/**
	 * Тексты связанные с СМС сообщениями (передается в вид)
	 *
	 * @var object
	 */
	public $PageSms = null;
	
	public function __construct()
	{
		$this -> SmsData = new stdClass();
	}
	
	/**
	 * Проверяем достоверность полученных данных
	 *
	 */
	public function checkSuccess()
	{
		//Формируем подпись
		$md5 = md5($this -> SmsData -> password.
				   $this -> SmsData -> tid.
				   $this -> SmsData -> sn.
				   $this -> SmsData -> op.
				   $this -> SmsData -> phone.
				   $this -> SmsData -> pref.
				   $this -> SmsData -> txt);
		
		if($this -> SmsData -> md5 == $md5)
		{
			return true;
		}
		return false;
	}
	
	/**
	 * Воозвращает описание данных в виде массива
	 *
	 * @param string $doc_str 
	 */
	public static function getDescriptionObj($doc_str = NULL)
	{
		$data_ar = array(
			'pref' => array('title' => Lng::_('Префикс')),
			'txt' => array('title' => Lng::_('Текст сообщения')),
			'tid' => array('title' => Lng::_('Уникальный код транзакции')),
			'cn' => array('title' => Lng::_('Двухбуквенный код страны')),
			'op' => array('title' => Lng::_('Оператор связи')),
			'phone' => array('title' => Lng::_('Номер телефона абонента')),
			'sn' => array('title' => Lng::_('Короткий номер')),
			'test' => array('title' => Lng::_('Тип сообщения <small>тестовое/не тестовое</small>')),
			'repeat' => array('title' => Lng::_('Номер повторного запроса к скрипту')),
			'rtime' => array('title' => Lng::_('Время получения SMS <small>в формате timestamp</small>')),
			'opn' => array('title' => Lng::_('Уникальный числовой код <small>оператора связи</small>')),
			'mpref' => array('title' => Lng::_('Общий префикс страны')),
			'tg' => array('title' => Lng::_('Тарифная группа')),
			'cost' => array('title' => Lng::_('Стоимость SMS <small>для абонента (рубли)</small>')),
			'zcost' => array('title' => Lng::_('Стоимость SMS <small>для абонента (USD)</small>')),
			'rate' => array('title' => Lng::_('Текущий курс <small>USD/RUR</small>')),
			'pay' => array('title' => Lng::_('Ваши отчисления <small>в рублях РФ за SMS</small>')),
			'zpay' => array('title' => Lng::_('Ваши отчисления <small>в долларах USD за SMS</small>')),
			'md5' => array('title' => Lng::_('md5-hash функции проверки <small>подлинности запроса</small>')),
			'mod' => array('title' => Lng::_('Платежный модуль')),
			'go' => array('title' => Lng::_('Страница обработки данных')),
			'zrate' => array('title' => 'zrate'),
			'_PAY_COOMENT' => array('title' => Lng::_('Комментарий')),
		);
		
		//Парсим данные
@		$doc_ar = unserialize($doc_str);
		
		if(sizeof($doc_ar))
		{
			foreach($doc_ar as $key => $val)
			{
				$data_ar[$key]['value'] = $val;
			}
		}
		
		return $data_ar;
	}
}