<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс системный, работы с SimpleXMLElement
 */

class XML
{
	/**
	 * Объект SimpleXMLElement
	 *
	 * @var object
	 */
	private static $SimpleXML;
	
	/**
	 * Файл xml
	 *
	 * @var string
	 */
	private static $file;

	function __construct($file)
	{
		return $this -> getObj($file);
	}
	
	/**
	 * Возвращает SimpleXMLElement объект
	 *
	 * @param string $file путь к XML файлу или сам файл
	 * @param bool $is_path определяет, является ли $file путем к файлу
	 * @return object
	 */
	public static function &getObj($file,$is_path=true)
	{
		self::$file = $file;
		//Значит это файл
		if(!$is_path)
		{
			if(!@self::$SimpleXML = new SimpleXMLElement($file))
			{
				throw new Exception_Default(Lng::_('Не удалось распознать описание данных'));
			}
			return self::$SimpleXML;
		}
		//Значит считываем файл по указанному пути
		if(is_file(self::$file))
		{
			$xml_doc = file_get_contents(self::$file);
			if(!@self::$SimpleXML = new SimpleXMLElement($xml_doc))
			{
				throw new Exception_Default(Lng::_('Не удалось распознать описание данных'));
			}
		}
		else 
		{
			throw new Exception_Default(Lng::_('Не удалось получить описание данных'));
		}
		return self::$SimpleXML;
	}
	
	/**
	 * Возвращает объект SimpleXMLElement
	 *
	 * @return object
	 */
	public function getSimpleXML()
	{
		return self::$SimpleXML;
	}
	
	/**
	 * Устанавливает свойство
	 *
	 * @param string $name
	 * @param string $data
	 */
	public static function __set($name,$data)
	{
		self::$SimpleXML -> $name = $data;
	}

	/**
	 * Возвращает свойство
	 *
	 * @param string $name
	 * @return mixed
	 */
	public static function __get($name)
	{ 
		return self::$SimpleXML -> $name;
	}
	
	/**
	 * Сохраняет XML файл
	 *
	 */
	public static function save()
	{
		if(is_object(self::$SimpleXML))
		{
			if(!file_put_contents(self::$file, self::$SimpleXML -> asXML()))
			{
				throw new Exception_Default(Lng::_('Не удалось сохранить данные'));
			}
			self::clean();
		}
	}
	
	/**
	 * Сохраняем XML файл предварительно импортировав в DOM объект
	 *
	 */
	public static function saveAsDom()
	{
		if(is_object(self::$SimpleXML))
		{
			$Doc = new DOMDocument('1.0'); 
			$Doc -> preserveWhiteSpace = false;
			$Doc -> loadXML(self::$SimpleXML -> asXML());
			$Doc -> formatOutput = true; 
			
			if(!file_put_contents(self::$file, $Doc -> saveXML()))
			{
				throw new Exception_Default(Lng::_('Не удалось сохранить данные'));
			}
			self::clean();
		}
	}
	
	/**
	 * Очещает содержимое объекта
	 *
	 */
	public static function clean()
	{
		self::$SimpleXML = self::$file = NULL;
	}
}