<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Разбивка по странично
 */
 
class BreakPage
{
	/**
	 * Количество ссылок на страницу
	 *
	 * @var unknown_type
	 */
	private static $amount_ref = 20;
	
	/**
	 * Заголовок ссылки 
	 *
	 * @var string
	 */
	public static $link_title = "";
	
	/**
	 * Использовать дружественный URL
	 *
	 * @var bool
	 */
	public static $is_url = true;
	
	/**
	 * Возвращает номер текущей страницы
	 *
	 * @param string $pabe_name имя GET переменной
	 * @return int
	 */
	public static function getPageNum($pabe_name="page")
	{
		//Первоначальная установка днных
		$page = Request::getGet("page","int",1);
		
		return  $page == 0 ? 1 : $page;
	}
	
	/**
	 * Добавляет к заголовку страницы номер страницы
	 *
	 */
	public static function addTitlePageNum()
	{
		$page = self::getPageNum();
		if($page > 1)
		{
			Site::addSkinVar('title_pagination',", стр. ".$page);
		}
	}
	
	/**
	 * Разбивка по странично
	 *
	 * @param int $count_res количество записей
	 * @param int $list_on_page количество записей на страницу
	 * @param int $page номер страницы
	 * @param string $js_func вызываемая JavaScript  ф-я при клике на номере страницы
	 * @param string $is_long если предполагается слишком длинная пагинаци, возможна насильное укорочение 1,2,3....100,101
	 * @return string
	 */
	public static function getPages($count_res = 0, $list_on_page = 0, $page = 0, $js_func = NULL, $is_long = TRUE)
	{
		if($count_res <= $list_on_page)
		{
			return NULL;
		}
		
		$c = "<div align=\"center\">";
		if($is_long)
		{
			$c .= self::getPageLong($count_res,$list_on_page,$page,$js_func);
		}
		else
		{
			$c .= self::getPageSmall($count_res,$list_on_page,$page,$js_func);
		}
		$c .= "</div>";
		
		return $c;
	}
	
	/**
	 * Длинна разбивка по транично
	 *
	 * @param int $count_res количество записей
	 * @param int $list_on_page количество записей на страницу
	 * @param int $page номер страницы
	 * @param string $js_func вызываемая JavaScript  ф-я при клике на номере страницы
	 * @return string
	 */
	private static function getPageLong($count_res=0,$list_on_page=0,$page=0,$js_func=null)
	{
		//Определяем $js_func ссылка или функция
		$is_link = false;
		if(strstr($js_func,"="))
		{
			$is_link = TRUE;
		}
		
		$all_pages = ceil($count_res/$list_on_page);
		$page = $page - 1;
		
		$c = "";
		for($i = 0; $i < $all_pages; $i++)
		{
			if($is_link)
			{
				$c .= "<a ".($page== $i ? "style=\"text-decoration:none\"" : " href=\"".self::url($js_func.($i+1),self::$link_title)."\"")." title=\"".Lng::_('Перейти к странице')." ".($i+1)."\">";
			}
			else
			{
				$c .= "<a ".($page== $i ? "style=\"text-decoration:none\"" : " class=\"icon\" style=\"text-decoration:underline\" onclick=\"".$js_func."('".($i+1)."')\"")." title=\"".Lng::_('Перейти к странице')." ".($i+1)."\">";
			}
			$c .= $i+1;
			$c .= "</a> ";
			if(($i % self::$amount_ref) == 0 && $i != 0)
			{
				$c .= "<br>";
			}
		}
		
		return $c;
	}
	
	
	/**
	 * Короткая разбивка по транично (1,2,3....100,101)
	 *
	 * @param int $count_res количество записей
	 * @param int $list_on_page количество записей на страницу
	 * @param int $page номер страницы
	 * @param string $js_func вызываемая JavaScript  ф-я при клике на номере страницы
	 * @return string
	 */
	private static function getPageSmall($count_res=0,$list_on_page=0,$page=0,$js_func=null)
	{
		$all_pages = ceil($count_res/$list_on_page);
		
		if($all_pages <= 15)
		{
			return self::getPageLong($count_res,$list_on_page,$page,$js_func);
		}

		//Определяем $js_func ссылка или функция
		$is_link = false;
		if(strstr($js_func,"="))
		{
			$is_link = true;
		}
		
		$start_i = $page - 8;
		$end_i = $page + 7;
		
		if($start_i <= 0)
		{
			$end_i += $start_i * (-1);
			$start_i = 0;
		}
		
		if($end_i >= $all_pages)
		{
			$start_i -= $end_i - $all_pages;
			$end_i = $all_pages;
		}
		
		$c = "";
		if($page > 3)
		{
			if($is_link)
			{
				$c .= "<a href=\"".self::url($js_func.($page-1),self::$link_title)."\" >....</a> ";
			}
			else
			{
				$c .= "<a href=\"#_\" onclick=\"".$js_func."('".($page-1)."')\" >....</a> ";
			}
		}
		$page = $page - 1;
		for($i = $start_i; $i < $end_i; $i++)
		{
			if($is_link)
			{
				$c .= "<a ".($page == $i ? "style=\"text-decoration:none\"" : " href=\"".self::url($js_func.($i+1),self::$link_title)."\"")." title=\"".Lng::_('Перейти к странице')." ".($i+1)."\">";
			}
			else
			{
				$c .= "<a ".($page == $i ? "style=\"text-decoration:none\"" : " class=\"icon\" style=\"text-decoration:underline\" onclick=\"".$js_func."('".($i+1)."')\"")." title=\"".Lng::_('Перейти к странице')." ".($i+1)."\">";
			}
			$c .= $i+1;
			$c .= "</a> ";
		}
		if($end_i < $all_pages)
		{
			if($is_link)
			{
				$c .= "<a href=\"".self::url($js_func.($page+2),self::$link_title)."\" title=\"".Lng::_('Перейти к странице')." ".($page+2)."\">....</a>";
			}
			else
			{
				$c .= " <a href=\"#_\" onclick=\"".$js_func."('".($page+2)."')\" >....</a>";
			}			
		}
		
		return $c;
	}
	
	/**
	 * Формирует URL
	 *
	 * @param string $link
	 * @param string $link_title
	 * @return string
	 */
	private static function url($link = NULL, $link_title = NULL)
	{
		if(self::$is_url == true)
		{
			return URL::_($link,$link_title);
		}
		return $link;
	}
}