<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс элемента Autocomplete, для автодополнения  
 */

class Element_Autocomplete
{
	/**
	 * Подключает скрипт автодополнения
	 *
	 * @param string $element элемент к которому применяется автодополнение (обычно указывается элемнета)
	 * @param string $base_file базоввый файл index.php или admin.php
	 * @param string $url путь к скрипту (в виде key:"val",)
	 * @param string $params дополнительные параметры (в виде key:"val",), если не указан, берется параметр по умолчанию
	 */
	public static  function get($element = NULL, $base_file = NULL, $url = NULL, $params = FALSE)
	{
		Factory::style('/scripts/jquery/autocomplete/jquery.autocomplete.css');
		Factory::js('/scripts/jquery/autocomplete/jquery.autocomplete.js');
		
		$script = "$(\"".$element."\").autocomplete(\"".$base_file."\", {";
		$script .= $url ? "extraParams:{".$url."}," : "";
		if($params)
		{
			$script .= $params;
		}
		else
		{
			$script .= "
				delay:10,
				minChars:2,
				matchSubset:1,
				autoFill:true,
				matchContains:1,
				cacheLength:10,
				selectFirst:true,
				maxItemsToShow:10";
		}
		$script .= "});";
				
		Factory::jqCode($script);
	}
}