<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс интерфейс вызовов других классов  
 */

class Factory
{
	/**
	 * Массив путей к JavaScript файлам
	 *
	 * @var string
	 */
	static private $js_ar = array();
	
	/**
	 * Массив путей к файлам стилей
	 *
	 * @var string
	 */
	static private $ccs_ar = array();
	
	/**
	 * Массив вызванных элементов
	 */
	static private $call_methods_ar = array();
	
	/**
	 * Устанавливает в вид js файл
	 *
	 * @param string $path
	 */
	public static function js($path = NULL)
	{
		if(in_array($path, self::$js_ar) == FALSE)
		{
			self::$js_ar[] = $path;
			Site::addSkinVar("script","<script type=\"text/javascript\" src=\"".$path."\"></script>\n");
		}
	}

	/**
	 * Создает JavaScript код
	 *
	 * @param string $code
	 */
	public static function jsCode($script_code = NULL)
	{
		Site::addSkinVar("script_code", "\n".$script_code."\n");		
	}
	
	/**
	 * Создает jQuery код
	 *
	 * @param string $jquery_code
	 */
	public static function jqCode($jquery_code = NULL)
	{
		Site::addSkinVar("jquery_code", "\n".$jquery_code."\n");		
	}
	
	/**
	 * Устанавливает в вид файл стилей
	 *
	 * @param string $path
	 */
	public static function style($path = NULL)
	{
		if(in_array($path,self::$ccs_ar) == FALSE)
		{
			self::$ccs_ar[] = $path;
			Site::addSkinVar("style", "<link href=\"".$path."\" type=\"text/css\" rel=\"stylesheet\">\n");
		}
	}
	
	/**
	 * Устанавливает style код
	 *
	 * @param string $code
	 */
	public static function styleCode($code = NULL)
	{
		Site::addSkinVar("style_code", "\n".$code."\n");		
	}
	
	/**
	 * Подлкючает элемент zebra
	 *
	 * @param string $element элемент к которому будет применено действие
	 */
	public static function zebra($element = '.tableRoller')
	{
		if(in_array(__FUNCTION__,self::$call_methods_ar)){return true;}
		self::$call_methods_ar[] = __FUNCTION__;

		self::js('/scripts/jquery/jquery.zebra.js');
		self::jqCode("
		$(\"".$element."\").zebra(
		{
			classOdd: 'tr_darker',
			classHover: 'selected'
		});");
	}
	
	/**
	 * Подключаем плагин fancybox
	 *
	 * @param string $element элемент к которому будет применен плагин
	 */
	public static function fancyBox($element = 'a.photo')
	{
		if(in_array(__FUNCTION__,self::$call_methods_ar)){return true;}
		self::$call_methods_ar[] = __FUNCTION__;
		
		self::style('/scripts/jquery/fancybox/jquery.fancybox.css');
		self::js('/scripts/jquery/fancybox/jquery.fancybox.js');

		self::jqCode("$(\"".$element."\").fancybox();\n");		
	}
	
	/**
	 * Возвращает ответ Ajax`а
	 *
	 * @param string|array $str
	 */
	public static function answerAjax($str = NULL)
	{
		if(is_array($str))
		{
			die(json_encode($str));
		}
		die($str);
	}
	
	/**
	 * Возвращает базовую модель Guard_Model
	 *
	 * @return object
	 */
	public static function getModel()
	{
		static $Model;
		
		if($Model == FALSE)
		{
			$Model = new Guard_Model();
		}
		
		return $Model;
	}
}