<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Базовый класс блоков
 */
 
class Guard_Block extends Guard_Base 
{
	/**
	 * Вызывает шаблон вида
	 *
	 * @param string $view_file путь к шаблону вида
	 */
	public function callView()
	{
		parent::_callView("./blocks/".$this -> controller."/views/".$this -> action.".phtml");
	}
	
	 /**
	  * Формирует вертикальное меню
	  *
	  * @param array $UrlData массив пунктов меню
	  * @param string $separate разделитель ссылок
	  * @return string
	  */
	 protected function simpleMenu($UrlData = array(), $separate = NULL)
	 {
		$c = '';
		$i = 0;
		foreach($UrlData -> url as $Url)
		{
			if(!isset($Url['link']))
			{
				$c .= "<div class=\"skin-block_group_title\">".$Url['title']."</div>";
				continue;
			}
			if(CheckAccess::privileges(User::get('role'), $Url['privileges']))
			{
				$link = '';
				if(isset($Url['is_external']))
				{
					$link = $Url['link'];
				}
				else
				{
					$link = URL::_($Url['link'],$Url['title']);
				}
				
				$c .= "<a href=\"".$link."\" ";
				if(isset($Url['rel']))
				{
					$c .= "rel=\"nofollow\" ";
				}
				if(isset($Url['target']))
				{
					$c .= "target=\"".$Url['target']."\" ";
				}
				if(isset($Url['class']))
				{
					$c .= "class=\"".$Url['class']."\" ";
				}
				$c .= "class=\"".( !$i ? "skin-block_item_first" : "" )."\">".$Url['title']."</a>";
				$c .= $separate;
				$i++;
				if(isset($Url['separate']))
				{
					$c .= "<div class=\"r-separate\"></div>";
				}
				$link = '';
			}
		}
		return $c;
	 }
}