<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Базовый контроллер
 */

class Guard_Controller extends Guard_Base 
{
	/**
	 * Конструктор
	 *
	 */
	public function __construct()
	{
		//Если пользователь не админ, значит устанавливаем мета-теги
		if(User::isCPanel() == FALSE)
		{
			$this -> setMetaTags(Request::getGet('mod'), Request::getGet('go'));
		}
	}
	
	/**
	 * Вызывает шаблон вида
	 *
	 * @param string $view_file путь к шаблону вида
	 */
	public function callView()
	{
		parent::_callView("./modules/".$this -> controller."/views/".$this -> base_file.$this -> sub_controller."/".$this -> action.".phtml");
	}
	
	/**
	 * Возвращает шаблон
	 *
	 * @param strint $template название шаблона
	 * @param string $module маодуль к которому относится паттерн
	 * @return object|null
	 */
	protected function getTemplate($template = NULL, $module = NULL)
	{
		if($template && $module)
		{
			$tfile = "./modules/".strtolower($module)."/templates/".$template.".phtml";
		}
		else
		{
			$tfile = "./modules/".$this -> controller."/templates/".$template.".phtml";
		}
		if(is_file($tfile))
		{
			return new View($tfile);
		}
		return null;
	}
	
	/**
	 * Делает редирект
	 *
	 * @param string $code код
	 * @param string $url адес
	 * @param bool $is_surl применять ЧПУ при редиректе или нет
	 */
	protected function redirect($msg = NULL, $url = NULL, $is_surl = TRUE)
	{
		$_SESSION['MESSAGE'] = $msg;
		
		$redirect_url = $url ? $url : $this -> base_file.".php?mod=".$this -> controller.$this -> sub_controller."&go=".$this -> action;
		if($is_surl)
		{
			$redirect_url = URL::_($redirect_url);
		}

		URL::redirect($redirect_url);
	}
	
	/**
	 * Устанавливает сообщение
	 *
	 * @param string $msg код
	 */
	protected function setMessage($msg = NULL)
	{
		$_SESSION['MESSAGE'] = $msg;
	}
	
	/**
	 * Отображает сообщение
	 *
	 */
	public function showMessage()
	{
		if(isset($_SESSION['MESSAGE']) == TRUE)
		{
			$msg_ar = explode(':', $_SESSION['MESSAGE']);
			unset($_SESSION['MESSAGE']);

			Site::addSkinVar('message', Site::getMessage($msg_ar[1], $msg_ar[0]));
		}
	}
	
	/********************************************************************************************************************/
	/************************************************* PRIVATE METHODS **************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Устанавливаем мета-теги в шаблон
	 *
	 * @param string $mod модуль
	 * @param string $go действие
	 */
	private function setMetaTags($mod = NULL, $go = NULL)
	{
		if(is_file("./files/db/models/".$mod."/metatags.xml") == FALSE)
		{
			return TRUE;
		}
		
		$Model = XML::getObj("./files/db/models/".$mod."/metatags.xml");
		$MetaTasg = $Model -> xpath("/data/page[@name='$go']");
		
		if(isset($MetaTasg[0] -> keywords))
		{
			Site::setSkinVar("keywords",(string)$MetaTasg[0] -> keywords);
		}
		if(isset($MetaTasg[0] -> description))
		{
			Site::setSkinVar("description",(string)$MetaTasg[0] -> description);
		}
	}
}