<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Базовая модель
 */

class Guard_Model
{
	/**
	 * Название группы категории
	 *
	 * @var string
	 */
	protected $group;
	
	/**
	 * Объект класса БД
	 *
	 * @var object
	 */
	public $DB;
	
	/**
	 * Конструктор класса
	 *
	 */
	function __construct()
	{
		$this -> DB = Registry::get('DB',new stdClass());
	}
	
	/**
	 * Возвращает данные по указанному полю и значению
	 *
	 * @param string $table
	 * @param string $row_key
	 * @param int|string $row_value
	 * @param string $msg
	 * @return object
	 */
	public function getDataById($table=null,$row_key=null,$row_value=0,$msg=null)
	{
		$sql = "SELECT *  
			FROM 
		`#__".$table."`
			WHERE
		`".$row_key."`='".$row_value."'";

		return $this -> DB -> setQuery($sql,$msg,true);
	}
	
	/**
	 * Возвращает все данные таблицы
	 *
	 * @param string $table
	 * @param string $row_sav
	 * @param string $order_by
	 * @param string $msg
	 * @return array
	 */
	public function getAllData($table=null,$row_sav=null,$order_by=null,$msg=null)
	{
		$sql = "SELECT *  
				FROM 
			`#__".$table."` ";
		if($order_by)
		{
			$sql .= "ORDER BY ".$order_by;
		}

		$result =  $this -> DB -> setQuery($sql,$msg);
		
		$AllData = array();
		while($Data = $this -> DB -> getObject($result))
		{
			$AllData[$Data -> $row_sav] = $Data;
		}

		return $AllData;
	}
	
	/**
	 * Возвращает количество данных в таблице
	 *
	 * @param string $table таблица
	 * @param string $row_select столбец данные которого мы получаем
	 * @param string $msg сообщение в случае ошибки
	 * @return int количество данных в таблице
	 */
	public function getCountData($table=null,$row_select=null,$msg=null)
	{
		$sql = "SELECT `".$row_select."` 
				FROM 
			`#__".$table."`";

		return $this -> DB -> setQuery($sql,$msg,"getCount");
	}
	
	/**
	 * Обновляем данные
	 *
	 * @param string $table
	 * @param string $id_key
	 * @param int $id_value
	 * @param string $row_key
	 * @param int|string $row_value
	 * @param unknown_type $msg
	 */
	public function updateRowById($table=null,$id_key=null,$id_value=null,$row_key=null,$row_value=0,$msg=null)
	{
		$sql = "UPDATE 
			`#__".$table."`
				SET
			`".$row_key."`='".$row_value."'
				WHERE 
			`".$id_key."`='".$id_value."'";
		
		$this -> DB -> setQuery($sql,$msg);
	}

	/**
	 * Обновляем данные некоторых полей
	 *
	 * @param string $table
	 * @param string $id_key
	 * @param int $id_value
	 * @param array $row_ar
	 * @param string $msg
	 */
	public function updateSomeRowById($table=null,$id_key=null,$id_value=null,$row_ar=array(),$msg=null)
	{
		$sql = "UPDATE 
			`#__".$table."`
				SET ";
		foreach($row_ar as $row_key => $row_value)
		{
			$sql .= "`".$row_key."`='".$row_value."', ";
		}
		$sql = substr($sql,0,-2);
		$sql .= " WHERE 
			`".$id_key."`='".$id_value."'";
		
		$this -> DB -> setQuery($sql,$msg);
	}

	/**
	 * Удаляет запись с таблицы
	 *
	 * @param string $table
	 * @param string $row_key
	 * @param int|string $row_value
	 * @param string $msg
	 * @return bool
	 */
	public function deleteDataById($table=null,$row_key=null,$row_value=0,$msg=null)
	{
		$sql = "DELETE `#__".$table."` 
				FROM 
			`#__".$table."` 
				WHERE 
			`".$row_key."`='".$row_value."'";

		return $this -> DB -> setQuery($sql,$msg);
	}
	
	/**
	 * Формирует массив данных по полученным данным с БД по SQL зпросу
	 *
	 * @param string $sql запрос к БД
	 * @param $row_sav $row_sav поле в БД, который будет использоваться в качестве ключа для сохраниения  даных в массив
	 * @param $row_sav $msg сообщение при ошибке
	 * @return array
	 */
	protected function sqlToArray($sql=null,$row_sav=null,$msg=null)
	{
		$result = $this -> DB -> setQuery($sql,$msg);
		
		$DataAr = array();
		while($Data = $this -> DB -> getObject($result))
		{
			$DataAr[$Data -> $row_sav] = $Data;
		}

		return $DataAr;
	}

	/**
	 * Возвращет последний созданный индекс в БД
	 *
	 */
	public function getLastId()
	{
		return $this -> DB -> getLastId();
	}
	
	/**
	 * Устанавливает группу
	 *
	 * @param string $group
	 */
	public function setGroup($group=null)
	{
		$this -> group = $group;
	}
	
	/**
	 * Начало трансакции
	 *
	 * @return bool
	 */
	public function transactionStart()
	{
		return $this -> DB -> setQuery("START TRANSACTION");
	}

	/**
	 * Фиксация трансакции
	 *
	 * @return bool
	 */
	public function transactionCommit()
	{
		return $this -> DB -> setQuery("COMMIT");
	}
	
	/**
	 * Откат трансакции
	 *
	 * @return bool
	 */
	public function transactionRollback()
	{
		return $this -> DB -> setQuery("ROLLBACK");
	}

}