<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Языковый класс
 */

class Lng
{
	/**
	 * Массив с файлами, которые были открыты
	 *
	 * @var array
	 */
	private static $file_ar = array();

	/**
	 * Массив переводов
	 *
	 * @var array
	 */
	private static $lng_ar = array();
	
	/**
	 * Устанавливает языковый файл
	 *
	 * @param string $lng
	 */
	public static function setLng($path_lng = NULL)
	{
		$path_lng = './library/lng/'.self::curLng().'/'.$path_lng.'.php';
		
		if(in_array($path_lng,self::$file_ar) == FALSE && is_file($path_lng) == TRUE)
		{
			//Устанавливаем файл в массив
			self::$file_ar[] = $path_lng;

			//Сохраняем массив переводов
			self::$lng_ar = array_merge(self::$lng_ar, include_once($path_lng));
		}
	}
	
	/**
	 * Возвращает текущий язык
	 *
	 * @return string текщий язык
	 */
	public static function curLng()
	{
		static $lng;
		
		if(!$lng)
		{
			$lng = (string)Registry::get('Config') -> site -> language;
		}
		return $lng;
	}
	
	/**
	 * Возвращает перевод
	 *
	 * @param string $str
	 * @return string
	 */
	public static function _($str = NULL)
	{
		$str_ = strtoupper($str);
		if(isset(self::$lng_ar[$str_]))
		{
			return self::$lng_ar[$str_];
		}
		return $str;
//		return '<span style="color: red">'.$str.'</span>';
	}
}