<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс сохраняющий данные в лог
 */

class Log
{
	/**
	 * Заголовок сообщения об ошибке 404
	 *
	 */
	const TITLE_440 = '440 Страница не найдена';
	const FILE_440 = '404.log';

	/**
	 * Заголовок сообщения об ошибке
	 *
	 */
	const TITLE_500 = 'Ошибка';
	const FILE_500 = '500.log';
	const FILE_EXCEPTION = 'exception.log';
	
	/**
	 * Заголовок сообщения об предупреждении
	 *
	 */
	const TITLE_MESSAGE = 'Предупреждение';
	const FILE_MESSAGE = 'message.log';
	
	/**
	 * Заголовок сообщения об ограничении доступа
	 *
	 */
	const TITLE_PRIVILEGES = 'Доступ ограничен';
	const FILE_PRIVILEGES = 'privileges.log';

	/**
	 * Заголовок сообщения об ограничении доступа
	 *
	 */
	const TITLE_AJAX = 'Переход по Ajax ссылке';
	const FILE_AJAX = 'ajax.log';
	
	/**
	 * Заголовок сообщения об ошибке работы БД
	 *
	 */
	const TITLE_DB = 'Ошибка работы базы данных';
	const FILE_DB = 'db.log';
	
	/**
	 * Добавляет данные в лог файл
	 *
	 * @param object $e Exception
	 * @param string $comment комментарий к записи
	 */
	public static function add($e, $comment = NULL, $file = self::FILE_EXCEPTION)
	{
		File::write("./files/.logs/".$file, self::createLogInfo($e, $comment),FILE_APPEND,true);
	}
	
	/********************************************************************************************************************/
	/************************************************* PRIVATE METHODS **************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Создает лог-файл
	 *
	 * @param string $path_to_file путь к файлу
	 */
	private static function createLogFile($path_to_file=null)
	{
		if(!is_file($path_to_file))
		{
			File::write($path_to_file,"<?php die('<html><body bgcolor=\"#FFFFFF\"><H1>Access denied</H1><HR></body></html>'); ?>\n\n",null,true);
		}
	}
	
	/**
	 * Создает информацию лог файла
	 *
	 * @param object $e Exception
	 * @param string $comment комментарий
	 * @return string
	 */
	private static function createLogInfo($e, $comment = NULL)
	{
		$txt  = "COMMENT: ".$comment."\n";
		$txt .= "DATA: ".date("Y.m.d H:i:s")."\n";
		$txt .= "IP: ".User::getIp()."\n";
		$txt .= "OS: ".User::getOS()."\n";
		$txt .= "BROWSER: ".User::getBrowser()."\n";
		$txt .= "URL: ".Registry::get('Config') -> site -> host.$_SERVER['REQUEST_URI']."\n";
		$txt .= "REFERER: ".(isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '')."\n";
		if(User::isAuth() == TRUE)
		{
			$txt .= "USER: \n\tId: ".User::get('id')."\n\tEmail: ".User::get('email')."\n\tName: ".User::get('name')." \n";
		}
		if(is_object($e) == TRUE)
		{
			$txt .= "ФАЙЛ: ".$e -> getFile()."\n";
			$txt .= "СТРОКА: ".$e -> getLine()."\n";
			$txt .= "КОД: ".$e -> getCode()."\n";
			$txt .= "СООБЩЕНИЕ: ".$e -> getMessage()."\n";
			$txt .= "TRACE: \n".$e -> getTraceAsString()."\n";
		}
		$txt .= "--------------------------------------------------------------------------------------------------------\n\n";

		return $txt;
	}
}