<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель работы с категориями
 */
 
class Models_Category  extends Guard_Model 
{
	function __construct($group = NULL)
	{
		parent::__construct();
		$this -> group = $group;
	}
	
	/**
	 * Возвращает данные категории по ее id
	 *
	 * @param int $category_id id категории
	 * @return object
	 */
	public function getDataById($category_id=0)
	{
		$sql = "SELECT * 
				FROM 
			`#__sys_category` 
				WHERE 
			`cat_id`='".((int)$category_id)."' 
				AND 
			`cat_group`='".$this -> group."'";

		return $this -> DB -> setQuery($sql,"Не удалось получить данные категории",true);
	}
	
	
	/**
	 * Возвращает данные категории по ее названию
	 *
	 * @param string $category_title
	 * @return object
	 */
	public function getDataByTitle($category_title=null)
	{
		$sql = "SELECT *
				FROM 
			`#__sys_category` 
				WHERE 
			`cat_title`='".mysql_real_escape_string($category_title)."' 
				AND 
			`cat_group`='".$this -> group."'";

		return parent::sqlToArray($sql, 'cat_id', "Не удалось получить данные категории");
	}
	
	/**
	 * Возвращает список рубрик
	 *
	 * @param array $car_ar
	 * @return array
	 */
	public function getCategoryByAr($car_ar=array())
	{
		$sql = "SELECT `cat_id`, `cat_title`   
				FROM
			`#__sys_category` 
				WHERE 
			`cat_id` IN (".join(",",array_map("intval",$car_ar)).") 
				AND 
			`cat_group`='".$this -> group."' 
				ORDER BY 
			 `cat_order`, `cat_title` ASC";
		
		return parent::sqlToArray($sql,"cat_id","Не удалось получить рубрики");
	}
	
	/**
	 * Выполняет поиск данных по указанному полю
	 *
	 * @param string $row
	 * @param string $value
	 * @return array
	 */
	public function searchDataBy($row = NULL, $value = NULL)
	{
		$sql = "SELECT *
				FROM 
			`#__sys_category` 
				WHERE 
			`$row` LIKE '".$value."' 
				AND 
			`cat_group`='".$this -> group."'
				ORDER BY `cat_order`, `cat_title`";

		return parent::sqlToArray($sql, 'cat_id', 'Во время поиска данных возникла ошибка');
	}
	
	/**
	 * Возвращает список данных категорий
	 *
	 * @return array
	 */
	public function getListData()
	{
		$sql = "SELECT *
				FROM 
			`#__sys_category` 
				WHERE 
			`cat_group`='".$this -> group."'
				ORDER BY 
			`cat_order`, `cat_title` ASC";

		return parent::sqlToArray($sql, 'cat_id', 'Не удалось получить данные категорий');
	}
	
	/**
	 * Возвращает количество данных в таблице
	 *
	 * @param string $table таблица
	 * @param string $row_select столбец данные которого мы получаем
	 * @param string $msg сообщение в случае ошибки
	 * @return int количество данных в таблице
	 */
	public function getCountData($table = NULL, $row_select = NULL)
	{
		$sql = "SELECT `".$row_select."` 
			FROM 
		`#__".$table."` 
			WHERE 
		`cat_group`='".$this -> group."'";

		return $this -> DB -> setQuery($sql,"Не удалось определить количество категорий","getCount"); 
	}
		
/**
	 * Создает категорию

	 * @param type $cat_parent_id
	 * @param type $cat_title
	 * @param type $cat_meta_title
	 * @param type $cat_meta_keywords
	 * @param type $cat_meta_description
	 * @param type $cat_desctiption
	 * @param type $cat_ads_top
	 * @param type $cat_ads_middle
	 * @param type $cat_ads_bottom
	 * @param type $cat_order

	 */
	public function insertData($cat_parent_id, $cat_title, $cat_meta_title, $cat_meta_keywords, $cat_meta_description, $cat_desctiption, $cat_ads_top, $cat_ads_middle, $cat_ads_bottom, $cat_order)
	{
		$sql = "INSERT INTO `#__sys_category`
			(
			`cat_parent_id`,
			`cat_title`,
			`cat_meta_title`,
			`cat_meta_keywords`,
			`cat_meta_description`,
			`cat_desctiption`,
			`cat_ads_top`,
			`cat_ads_middle`,
			`cat_ads_bottom`,
			`cat_order`,
			`cat_group`
			)
				VALUES
			('".intval($cat_parent_id)."', 
			'".mysql_real_escape_string($cat_title)."',
			'".mysql_real_escape_string($cat_meta_title)."',
			'".mysql_real_escape_string($cat_meta_keywords)."',
			'".mysql_real_escape_string($cat_meta_description)."',
			'".mysql_real_escape_string($cat_desctiption)."',
			'".mysql_real_escape_string($cat_ads_top)."',
			'".mysql_real_escape_string($cat_ads_middle)."',
			'".mysql_real_escape_string($cat_ads_bottom)."',
			'".intval($cat_order)."',
			'".$this -> group."')";
		
		$this -> DB -> setQuery($sql,"Во время создания категории возникла ошибка");
	}
	

	/**
	 * Создает категорию (C проверкой)
	 * @param type $cat_parent_id
	 * @param type $cat_title
	 * @param type $cat_meta_title
	 * @param type $cat_meta_keywords
	 * @param type $cat_meta_description
	 * @param type $cat_desctiption
	 * @param type $cat_ads_top
	 * @param type $cat_ads_middle
	 * @param type $cat_ads_bottom



	 * @param type $cat_order
	 * @throws Exception_CheckData
	 */
	public function insertDataCategory($cat_parent_id, $cat_title, $cat_meta_title, $cat_meta_keywords, $cat_meta_description, $cat_desctiption, $cat_ads_top, $cat_ads_middle, $cat_ads_bottom, $cat_order)
	{
		if($cat_parent_id)
		{
			if(!$this -> isExistsCategory($cat_parent_id))
			{
				throw new Exception_CheckData(Lng::_('Выбранная Вами родительская категория не существует'));
			}
		}
		//Создаем категорию
		$this -> insertData($cat_parent_id, $cat_title, $cat_meta_title, $cat_meta_keywords, $cat_meta_description, $cat_desctiption, $cat_ads_top, $cat_ads_middle, $cat_ads_bottom, $cat_order);
	}
	
	/**
	 * Обновляет данные в БД по указанному $cat_id
	 * @param type $cat_id

	 * @param type $cat_parent_id
	 * @param type $cat_title
	 * @param type $cat_meta_title
	 * @param type $cat_meta_keywords
	 * @param type $cat_meta_description
	 * @param type $cat_desctiption
	 * @param type $cat_ads_top


	 * @param type $cat_ads_middle
	 * @param type $cat_ads_bottom
	 * @param type $cat_order
	 */
	public function updateData($cat_id, $cat_parent_id, $cat_title, $cat_meta_title, $cat_meta_keywords, $cat_meta_description, $cat_desctiption, $cat_ads_top, $cat_ads_middle, $cat_ads_bottom, $cat_order)
	{
		$sql = "UPDATE 
			`#__sys_category` 
				SET
			`cat_parent_id`='".intval($cat_parent_id)."',
			`cat_title`='".mysql_real_escape_string($cat_title)."', 
			`cat_meta_title`='".mysql_real_escape_string($cat_meta_title)."', 
			`cat_meta_keywords`='".mysql_real_escape_string($cat_meta_keywords)."', 
			`cat_meta_description`='".mysql_real_escape_string($cat_meta_description)."', 
			`cat_desctiption`='".mysql_real_escape_string($cat_desctiption)."', 
			`cat_ads_top`='".mysql_real_escape_string($cat_ads_top)."', 
			`cat_ads_middle`='".mysql_real_escape_string($cat_ads_middle)."', 
			`cat_ads_bottom`='".mysql_real_escape_string($cat_ads_bottom)."', 
			`cat_order`='".intval($cat_order)."' 
				WHERE
			`cat_id`='".intval($cat_id)."' 
				AND 
			`cat_group`='".$this -> group."'";
		
		$this -> DB -> setQuery($sql,"Не удлось обновить данные категории");
	}

	/**
	 * Обновляет данные категории (C проверкой)

	 * @param type $cat_id
	 * @param type $cat_parent_id
	 * @param type $cat_title
	 * @param type $cat_meta_title
	 * @param type $cat_meta_keywords
	 * @param type $cat_meta_description
	 * @param type $cat_desctiption
	 * @param type $cat_ads_top
	 * @param type $cat_ads_middle
	 * @param type $cat_ads_bottom
	 * @param type $cat_order
	 * @throws Exception_CheckData

	 */
	public function updateDataCategory($cat_id, $cat_parent_id, $cat_title, $cat_meta_title, $cat_meta_keywords, $cat_meta_description, $cat_desctiption, $cat_ads_top, $cat_ads_middle, $cat_ads_bottom, $cat_order)
	{
		if($cat_parent_id)
		{
			if(!$this -> isExistsCategory($cat_parent_id))
			{
				throw new Exception_CheckData(Lng::_('Выбранная Вами родительская категория не существует'));
			}
			if($cat_id == $cat_parent_id)
			{
				throw new Exception_CheckData(Lng::_('Запрещено прикреплять категорию саму к себе в подчинение'));
			}
			$this -> isCategoryChild(
				$this -> prepCategory($this -> getListData()),
				$cat_id,
				$cat_parent_id
			);
		}
		//Обновляем данные категории
		$this -> updateData($cat_id, $cat_parent_id, $cat_title, $cat_meta_title, $cat_meta_keywords, $cat_meta_description, $cat_desctiption, $cat_ads_top, $cat_ads_middle, $cat_ads_bottom, $cat_order);
	}
	
	/**
	 * Удаляет запись по id категории
	 *
	 * @param int $category_id id удаляемой категории
	 */
	public function deleteById($category_id=0)
	{
		$sql = "DELETE `#__sys_category`
				FROM 
			`#__sys_category` 
				WHERE 
			`cat_id`='".((int)$category_id)."'
				AND 
			`cat_group`='".$this -> group."'";
		
		$this -> DB -> setQuery($sql,"Не удалось удалить категорию");
	}
	
	/**
	 * Удаляет данные по id категории (C проверкой)
	 *
	 * @param int $category_id id категории
	 */
	public function deleteByIdCategory($category_id=0)
	{
		$category_ar = $this -> prepCategory($this -> getListData());
		if(isset($category_ar[$category_id]))
		{
			throw new Exception_CheckData(Lng::_('Удаляемая категория не должна сдержать дочерние категории'));
		}
		//Удаляем категорию
		$this -> deleteById($category_id);
	}
	
	/**
	 * Проверяет существование категории
	 *
	 * @param int $category_id id категории
	 * @return bool
	 */
	public function isExistsCategory($category_id=0)
	{
		$CategoryData = $this -> getDataById($category_id);

		$count = 1;
		try
		{
			CheckData::existsDataObject($CategoryData);
		}
		catch (Exception_CheckData $e)
		{
			$count = 0;
		}

		return $count;
	}
	
	
	/**
	 * Проверяет является ли категории дочерней по отношению к текущей
	 *
	 * @param array $tree_ar массив дерева
	 * @param int $start_id id "стартовой" категории
	 * @param int $parent_id id родительской категории
	 */
	private function isCategoryChild($tree_ar=array(),$start_id=0,$parent_id=0)
	{
		if(isset($tree_ar[$start_id]))
		{
			foreach($tree_ar[$start_id] as $category_id => $title)
			{
				if($category_id == $parent_id)
				{
					throw new Exception_CheckData(Lng::_('Запрещено прикреплять родительскую категорию, в подчинение к своей дочерней'));
				}
				if(isset($tree_ar[$start_id][$category_id]))
				{
					$new_data_ar = self::isCategoryChild($tree_ar,$category_id,$parent_id);
				}
			}
		}
	}
	
	/**
	 * Обновляет сортировку категории
	 *
	 * @param int $cat_id id рубрики
	 * @param int $order порядковый номер категории
	 */
	public function updateOrder($category_id=0,$order=0)
	{
		$sql = "UPDATE `#__sys_category`
				SET 
			`cat_order`='".((int)$order)."'
				WHERE 
			`cat_id`='".((int)$category_id)."'
				AND 
			`cat_group`='".$this -> group."'";
		
		$this -> DB -> setQuery($sql,"Не удалось обновить порядковый номер категории");
	}
	
	/**
	 * Формирует массив-дерево категорий
	 *
	 * @param object|string $CategoryAr массив объектов или вызываемый метод
	 * @return array
	 */
	public function prepCategory($CategoryAr=null)
	{
		if(is_string($CategoryAr) && method_exists($this,$CategoryAr))
		{
			$CategoryAr = $this -> $CategoryAr();
		}
		$category_ar = array();
		foreach($CategoryAr as $Category)
		{
			$category_ar[$Category -> cat_parent_id][$Category -> cat_id] = $Category -> cat_title;
		}
		
		return $category_ar;
	}
}