<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель работы с изображениями
 */
 
class Models_Images  extends Guard_Model 
{
	/**
	 * Возвращает объект
	 *
	 * @return object
	 */
	public static function instance()
	{
		static $Instance;
		
		if(!is_object($Instance))
		{
			$Instance = new self;
		}
		return $Instance;
	}
	
	/**
	 * Возвращает данные изображения по его ID
	 *
	 * @param int $im_id
	 * @return array
	 */
	public function getImagesById($im_id = 0)
	{
		return parent::getDataById('sys_images','im_id',$im_id,'Во время получения данных изображения возникла ошибка');
	}
	
	/**
	 * Возвращает список изображений по ID объекта
	 *
	 * @param int $obj_id
	 * @param string $im_group
	 * @return array
	 */
	public function getListImagesByObjId($obj_id = 0, $im_group = NULL)
	{
		$sql = "SELECT *  
				FROM 
			`#__sys_images` 
				WHERE 
			`obj_id`='".((int)$obj_id)."' 
				AND 
			`im_group`='".$im_group."' 
				ORDER BY 
			`im_order` ASC";

		return parent::sqlToArray($sql,'im_id','Во время получения данных изображений возникла ошибка');
	}

	/**
	 * Возвращает данные изображений по массиву объектов
	 *
	 * @param array $obj_ar массив данных объектов
	 * @param string $im_group группа
	 * @return array
	 */
	public function getListImagesByObjArId($obj_ar = array(), $im_group = NULL)
	{
		$sql = "SELECT *  
				FROM 
			`#__sys_images` 
				WHERE 
			`obj_id` IN (".join(',', array_map('intval',$obj_ar)).") 
				AND 
			`im_group`='".$im_group."' 
				ORDER BY 
			`im_order` ASC";

		return parent::sqlToArray($sql,'im_id','Во время получения данных изображений возникла ошибка');
	}
	
	/**
	 * Определяем количество изображений объекта
	 *
	 * @param int $obj_id
	 * @param string $im_group
	 * @return int
	 */
	public function getCountImageByObjId($obj_id = 0, $im_group = NULL)
	{
		$sql = "SELECT *  
				FROM 
			`#__sys_images` 
				WHERE 
			`obj_id`='".((int)$obj_id)."' 
				AND 
			`im_group`='".$im_group."'";
		
		return $this -> DB -> setQuery($sql,'Не удалось определить количество изображений',"getCount");
	}
	
	/**
	 * Создаем изображение
	 *
	 * @param int $obj_id ID изображения
	 * @param string $im_img имя файла
	 * @param int $im_order порядковый номер файла
	 * @param string $im_group группа к которой относится изображение
	 */
	public function addImage($obj_id = 0, $im_img = NULL, $im_order = 0, $im_group = NULL)
	{
		$sql = "INSERT INTO `#__sys_images`
			(`obj_id`,`im_img`,`im_order`,`im_group`)
				VALUES
			('".((int)$obj_id)."', 
			'".mysql_real_escape_string($im_img)."',
			'".mysql_real_escape_string($im_order)."',
			'".$im_group."')";
		
		$this -> DB -> setQuery($sql,"Во время сохранения изображения возникла ошибка");
	}

	/**
	 * Удаляем все изображения объекта
	 *
	 * @param int $obj_id
	 * @param string $im_group
	 */
	public function deleteByObjId($obj_id = 0, $im_group = NULL)
	{
		$sql = "DELETE `#__sys_images`
				FROM 
			`#__sys_images` 
				WHERE 
			`obj_id`='".((int)$obj_id)."'
				AND 
			`im_group`='".$im_group."'";
		
		$this -> DB -> setQuery($sql,"Во время удаления данных изображений возникла ошибка");
	}

	/**
	 * Удаляем данные изображений по массиву объектов
	 *
	 * @param array $obj_ar
	 * @param string $im_group
	 */
	public function deleteByObjArId($obj_ar = array(), $im_group = NULL)
	{
		$sql = "DELETE `#__sys_images`
				FROM 
			`#__sys_images` 
				WHERE 
			`obj_id` IN (".join(',', array_map('intval',$obj_ar)).") 
				AND 
			`im_group`='".$im_group."'";
		
		$this -> DB -> setQuery($sql,"Во время удаления данных изображений возникла ошибка");
	}
	
	/**
	 * Удаляем изображение
	 *
	 * @param int $im_id
	 * @param int $obj_id
	 */
	public function deleteByIdObjId($im_id = 0, $obj_id = 0)
	{
		$sql = "DELETE `#__sys_images`
				FROM 
			`#__sys_images` 
				WHERE
			`im_id`='".((int)$im_id)."'
				AND 
			`obj_id`='".((int)$obj_id)."'";
		
		$this -> DB -> setQuery($sql,"Во время удаления данных изображения возникла ошибка");
	}
	
	/**
	 * Удаляем изображение по ID изображения
	 *
	 * @param int $im_id
	 */
	public function deleteById($im_id = 0)
	{
		parent::deleteDataById('sys_images','im_id',((int)$im_id),'Во время удаления данных изображения возникла ошибка');
	}
}