<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель работы с мета-тегами
 */
 
class Models_Pays  extends Guard_Model 
{
	function __construct($group=null)
	{
		parent::__construct();
		$this -> group = $group;
	}

	
	/**
	 * Возвращает данные платежа
	 *
	 * @param int $py_id id платежа
	 * @return object
	 */
	public function getDataById($py_id=0)
	{
		$sql = "SELECT *   
				FROM 
			`#__sys_pays` 
				WHERE 
			`py_id`='".((int)$py_id)."' 
				AND 
			`py_group`='".$this -> group."'";
		
		return $this -> DB -> setQuery($sql,"Во время получения данных платежа возникла ошибка",true);
	}

	/**
	 * Возвращает ID объекта
	 *
	 * @param int $py_id
	 * @return object
	 */
	public function getParentIdById($py_id)
	{
		$sql = "SELECT `py_parent_id`   
				FROM 
			`#__sys_pays` 
				WHERE 
			`py_id`='".((int)$py_id)."' 
				AND 
			`py_group`='".$this -> group."'";
		
		return $this -> DB -> setQuery($sql,"Во время получения данных платежа возникла ошибка",true);
	}
	
	
	/**
	 * Возвращает платежи с учетом лимита и группы
	 *
	 * @param int $ls
	 * @param int $lf
	 * @return array
	 */
	public function getDataLimit($ls=0,$lf=-1)
	{
		$sql = "SELECT `py_id`, `py_code`, `py_title`, `py_status`, `py_date_start`, `py_date_end`, `py_parent_id`  
				FROM 
			`#__sys_pays` 
				WHERE 
			`py_group`='".$this -> group."'
				ORDER BY 
			`py_date_start` DESC 
				LIMIT ".$ls.",".$lf;
		
		//Поучаем ресурс
		$result = $this -> DB -> setQuery($sql,"Во время получения данных платежей возникла ошибка");
		
		$DataAr = array();
		while($Data = $this -> DB -> getObject($result))
		{
			$DataAr[$Data -> py_id] = $Data;
		}

		return $DataAr;
	}
	
	
	/**
	 * Возвращает количество платежей группы
	 *
	 * @return int
	 */
	public function getCountData()
	{
		$sql = "SELECT `py_id`
				FROM 
			`#__sys_pays`
				WHERE 
			`py_group`='".$this -> group."'";
		
		return $this -> DB -> setQuery($sql,"Не удалось определить количество всех платежей","getCount");
	}
	

	/**
	 * Сохраняет данные платежа
	 *
	 * @param unknown_type $py_code
	 * @param unknown_type $py_title
	 * @param unknown_type $py_description
	 * @param unknown_type $py_amount
	 * @param unknown_type $py_operations
	 * @param unknown_type $py_status
	 * @param unknown_type $py_date_start
	 * @param unknown_type $py_date_end
	 * @param unknown_type $py_parent_id
	 */
	public function insertData($py_code=null,$py_title=null,$py_description=null,$py_amount=0,$py_operations=null,$py_status=0,$py_date_start=null,$py_date_end=null,$py_parent_id=0)
	{
		$sql = "INSERT INTO `#__sys_pays`
			(`py_code`,`py_title`,`py_description`,`py_amount`,`py_operations`,`py_status`,`py_date_start`,`py_date_end`,`py_parent_id`,`py_group`)
				VALUES
			('".mysql_real_escape_string($py_code)."', 
			'".mysql_real_escape_string($py_title)."', 
			'".mysql_real_escape_string($py_description)."',  
			'".mysql_real_escape_string($py_amount)."', 
			'".mysql_real_escape_string($py_operations)."', 
			'".((int)$py_status)."', 
			'".$py_date_start."', 
			'".$py_date_end."', 
			'".((int)$py_parent_id)."',
			'".$this -> group."');";

		$this -> DB -> setQuery($sql,"Во время сохранения платежа возникла ошибка");
	}
	
	/**
	 * Обновляет данные платежа
	 *
	 * @param int $py_id
	 * @param string $py_description
	 * @param int $py_status
	 * @param string $py_date_end
	 */
	public function updateData($py_id=0,$py_description=null,$py_status=null,$py_date_end=null)
	{
		$sql = "UPDATE 
			`#__sys_pays` 
				SET
			`py_description`='".mysql_real_escape_string($py_description)."', 
			`py_status`='".((int)$py_status)."', 
			`py_date_end`='".($py_date_end)."' 
				WHERE
			`py_id`='".((int)$py_id)."' 
				AND 
			`py_group`='".$this -> group."'";
		
		$this -> DB -> setQuery($sql,"Во время обновления данных мета-тегов возникла ошибка");
	}

	/**
	 * Удаляем данные платежа
	 *
	 * @param int $py_id id платежа
	 */
	public function deletePayById($py_id=0)
	{
		$sql = "DELETE `#__sys_pays`
				FROM 
			`#__sys_pays` 
				WHERE 
			`py_id`='".((int)$py_id)."'
				AND 
			`py_group`='".$this -> group."'";
		
		$this -> DB -> setQuery($sql,"Во время удаления данных платежа возникла ошибка");
	}
}