<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс содания RSS ленты
 */

class RSSCreator
{
	/**
	 * Содержит массив базовых параметров ленты
	 *
	 * @var array
	 */
	private $rssdoc_ar = array();
	/**
	 * Содержит массив новостей
	 *
	 * @var array
	 */
	private $rssitems_ar = array();
	
	/**
	 * Устанавливает базовые параметры ленты
	 *
	 * @param string $title заголовок
	 * @param string $link ссылка
	 * @param string $description описание
	 * @param string $lastBuildDate дата создания
	 */
	function __construct($title=null,$link=null,$description=null,$lastBuildDate=null)
	{
		$this -> rssdos_ar['title'] = $title;
		$this -> rssdos_ar['link'] = $link;
		$this -> rssdos_ar['description'] = $description;
		$this -> rssdos_ar['lastBuildDate'] = !$lastBuildDate ? date("r") : $lastBuildDate;
	}
	
	/**
	 * Устанавливает данные новости
	 *
	 * @param string $title заголовок
	 * @param string $link ссылка
	 * @param string $description описание
	 */
	public function setItem($title=null,$link=null,$description=null)
	{
		$this -> rssitems_ar[] = array(
			'title' => $title,
			'link' => $link,
			'description' => $description,
			);
	}
	
	/**
	 * Выполняет трансляцию некторых символов для корректного вывода ленты
	 *
	 * @param string $text
	 * @return string
	 */
	private function translate($text)
	 {
	    return Str::transToUNICODE($text);
	 }
	
	/**
	 * Возвращает созданную RSS ленту
	 *
	 * @return string
	 */
	public function getRss()
	{
		$rss  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		$rss .= "	<rss version=\"2.0\">";
		$rss .= "		<channel>";
		$rss .= "			<title><![CDATA[".$this -> rssdos_ar['title']."]]></title>";
		$rss .= "			<link><![CDATA[".$this -> rssdos_ar['link']."]]></link>";
		$rss .= "			<description><![CDATA[".$this -> rssdos_ar['description']."]]></description>";
		$rss .= "			<lastBuildDate><![CDATA[".$this -> rssdos_ar['lastBuildDate']."]]></lastBuildDate>";
		if(sizeof($this -> rssitems_ar))
		{
			foreach($this -> rssitems_ar as $item_ar)
			{
				$rss .= "		<item>";
				$rss .= "			<title><![CDATA[".$item_ar['title']."]]></title>";
				$rss .= "			<link><![CDATA[".$item_ar['link']."]]></link>";
				$rss .= "			<description><![CDATA[".$item_ar['description']."]]></description>";
				$rss .= "			<guid><![CDATA[".$item_ar['link']."]]></guid>";
				$rss .= "		</item>";
			}
		}
		$rss .= "		</channel>";
		$rss .= "	</rss>";
		
		return $rss;
	}
	
	/**
	 * Отображает RSS ленту
	 *
	 */
	public function showRss()
	{
	 	/*header("Expires: Mon, 26 Jul 1997 00:00:00 GMT");
	   	header("Pragma: no-cache");
		//ob_start();
		//header("Content-Length: ".ob_get_length());
		header("Last-Modified: ". date("D, d M Y H:i:s")." GMT");
		header("Content-Type: text/xml; charset=UTF-8");
		echo $this -> getRss();
		//ob_end_flush();
		exit;*/
		
		header("content-type: application/rss+xml");
//		header("Content-Type: application/xml");
		echo $this -> getRss();
		exit;
	}
	
}

/*
<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0">
	<channel>
		<title>Моя лента новостей</title>
		<link>http://www.моя_лента.ru</link>
		<description>Самый лучший блог на свете</description>
		<lastBuildDate>Sat, 30 Dec 2006 00:00:00 +0300</lastBuildDate>
		<item>
			<title>С Новым Годом!</title>
			<link>http://www.моя_лента.ru/new1.html</link>
			<description>Поздравляем всех читателей с Новым Годом</description>
		</item>
	</channel>
</rss>
*/