<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс формирования sitemap.xml файла
 */

class Sitemap
{

	/**
	 * Формирует url блок файла
	 *
	 * @param string $loc
	 * @param string $lastmod
	 * @param string $changefreq
	 * @param double $priority
	 * @return string
	 */
	public static function formedUrlBlock($loc=false,$lastmod=false,$changefreq=false,$priority=false)
	{
		$c  = "\t<url>\n";
		$c .= "\t\t<loc>".Str::transToUNICODE($loc)."</loc>\n";
		
			if($lastmod)
			{
		 		$c .= "\t\t<lastmod>".$lastmod."</lastmod>\n";
			}
		 	if($changefreq)
		 	{
				$c .="\t\t<changefreq>".$changefreq."</changefreq>\n";
		 	}
		 	if($priority)
		 	{
				$c .="\t\t<priority>".$priority."</priority>\n";
		 	}
		$c .="\t</url>\n";
		
		return $c;
	}
}