<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс трансляции url
 */

class URL
{
	/**
	 * Устанавливает URL для трансляции в ЧПУ, только для пользователя
	 *
	 * @param string $url 
	 * @param string $title
	 */
	public static function _($url = NULL, $title = FALSE)
	{
		if(User::isCPanel() == FALSE)
		{
			$url = URL::trans($url, $title);
		}
		
		return '/'.$url;
	}

	/**
	 * Устанавливает URL для трансляции в ЧПУ, как для пользователя, так и для админа
	 *
	 * @param string $url 
	 * @param string $title
	 */
	public static function trans($url = NULL, $title = FALSE)
	{
		$url = strtr($url,array(
			"index.php?" => "",
			".php?" => ".php/",
			"="		=> "-",
			"&"		=> "/",
			"mod="	=> "",
			"go="	=> ""
		));
		if($title)
		{
			//Удаляем все символы кроме букв и цифр
			$title = preg_replace("/[^a-z0-9]/i", "-", Str::transRuToEn($title));
			//Удаляем все тере которые больше одного
			$title = preg_replace("/-{2,}/", "-", $title);
			//Удаляем тере в конце URL
			/*$url .= ",".preg_replace("/-$/", "", $title);*/
		}
		
		
		if($url != "") {
			$url .= ".html";
		}
		else {
			$url .= "";
		}
		return $url;
	}
	
	/**
	 * Вызывает роутер метод
	 *
	 * @param strings $url
	 */
	public static function callRouter($url = NULL)
	{
		$url_ar = URL::parseUrl($url);
		if(sizeof($url_ar) > 0)
		{
			$_REQUEST = $_GET = $url_ar;
		}
	}
	
	/**
	 * Возвращает полную ссылку
	 *
	 * @param string $url
	 * @param string $title
	 * @return string
	 */
	public static function site($url = NULL, $title = NULL)
	{
		return Registry::get('Config') -> site -> host.URL::_($url, $title);
	}
	
	
	
	/**
	 * Возвращает хост сайта
	 *
	 * @return string
	 */
	public static function getHost()
	{
		static $host;
		
		if($host == FALSE)
		{
			$host = (string) Registry::get('Config') -> site -> host;
		}
		return $host;
	}
	
	/**
	 * Выполняет перенаправление странички (т.е. редирект)
	 *
	 * @param string $url url странички
	 */
	public static function redirect($url = NULL)
	{
		if(substr($url, 0, 1) != '/')
		{
			$url = '/'.$url;
		}
		
		header('location: '.URL::getHost().$url);
		exit;
	}
	
	/**
	 * Выполняет парсинг URL, преобразовывает его в ассоциативный массив
	 *
	 * @param string $url
	 * @return array
	 */
	public static function parseUrl($url = NULL)
	{
		$url_ar = array();
		$is_get = FALSE;
		
		if(preg_match("#^/(admin|index)\.php#i", $url) == FALSE)
		{
			preg_match("#^(.*).html#i", $url, $a1);
			if(isset($a1[1]))
			{
				$a1[2] = $a1[1];
			}
		}
		else
		{
			preg_match("#^/(admin|index)\.php(.*).html#i", $url, $a1);
		}

		if(isset($a1[2]))
		{
			$is_get = TRUE;
			preg_match_all("#/([\w_\.-]*),?#i",$a1[2],$a);
			//Определяем заголовок страницы, и если нужно сохраняем его
			preg_match("#,(.*)\.html#i", $a1[2], $t);
			if(isset($t[1]))
			{
				$url_ar["#title"] = $t[1]; 
			}
			if(sizeof($a[1]))
			{
				$_SERVER['QUERY_STRING'] = $url;
				
				$index_ar = array("mod","go");
				$parms_ar = $a[1];
				
				//Фильтруем имя модуля (удаляем все кроме букв, цифр и точки)
				if(isset($parms_ar[0]))
				{
					$parms_ar[0] = preg_replace('|[^a-z0-9\.]|i','',$parms_ar[0]);
				}
				//Фильтруем имя метода (удаляем все кроме букв и цифр)
				if(isset($parms_ar[1]))
				{				
					$parms_ar[1] = preg_replace('|[^a-z0-9_\-]|i','',$parms_ar[1]);
				}
				
				$count_parms = sizeof($parms_ar);
				//количество методов и экшенов, недолжно превышать двух
				$count_ma = 1;
				for($i = 0; $i < $count_parms; $i++)
				{
					$prm_ar = explode("-",$parms_ar[$i]);
					$count_prm = sizeof($prm_ar);
					
					//Учитываем только первых два параметра (для модуля и экшена)
					if($count_prm == 1 && $count_ma <= 2)
					{
@						$url_ar[$index_ar[$i]] = $prm_ar[0];
						$count_ma++;
					}
					if($count_prm == 2)
					{
						$url_ar[$prm_ar[0]] = $prm_ar[1];					
					}
				}
			}
		}
		
		if($is_get == TRUE)
		{
			//Удаляем первый элемент GET массива, остальные если есть объеденим с $url_ar
			//при этом, $url_ar, имеет больший приоритет чем $_get
			$_get = $_GET;
			array_shift($_get);
			
			$url_ar = array_merge($_get, $url_ar);
		}
		
		return $url_ar ;
	}
}