<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс работы с шаблонами
 */

class View
{
	/**
	 * Путь к файлу скина
	 *
	 * @var string
	 */
	private $path;
	
	function __construct($path=null)
	{
		$this -> path = $path;
	}
	
	/**
	 * Устанавливает свойство в скин
	 *
	 * @param string $name имя
	 * @param mixed $value содержимое
	 */
	function __set($name,$value)
	{
		$this -> $name = $value;
	}
	
	/**
	 * Возвращает содержимое вида
	 *
	 * @param string $path путь к файлу вида
	 * @param array $data_ar массив данных
	 * @param string $ext расширение
	 * @return string
	 */
	public static function get($path = NULL, $data_ar = array(), $ext = 'phtml')
	{
		if(is_array($data_ar) == TRUE)
		{
			extract($data_ar, EXTR_SKIP);
		}

		ob_start();

		try
		{
			include $path.'.'.$ext;
		}
		catch (Exception $e)
		{
			ob_end_clean();

			throw $e;
		}

		return ob_get_clean();
	}
	
	/**
	 * Подключает файл
	 *
	 * @param string $file
	 * @return string
	 */
	public static function load($file = NULL)
	{
		return include($file);
	}
	
	/**
	 * Возвращает содержимое шаблон
	 *
	 * @param sting $file файл скиниа
	 */
	public function getView()
	{
		ob_start();
		if(!@include($this -> path))
		{
			ob_end_clean();
			throw new Exception_Default(Lng::_('Не найден шаблон оформления'));
		}
		$output = ob_get_contents();
		ob_end_clean();
		
		return $output;
	}
	
	/**
	 * Отображает шаблон
	 */
	public function display()
	{
		if(!@include_once($this -> path))
		{
			throw new Exception_Default('Не найден шаблон оформления');
		}
		exit;
	}
	
	/**
	 * Добавляем данные в вид
	 *
	 * @param object|array $data данные
	 */
	public function addToView($data = array())
	{
		foreach($data as $name => $value)
		{
			$this -> $name = $value;
		}
	}
}