<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Класс системный, работы с DOMDocument
 */

class XMLDocument
{
	/**
	 * Объект XMLDocument
	 *
	 * @var object
	 */
	private static $DOM;
	
	/**
	 * Файл xml
	 *
	 * @var string
	 */
	private static $file;

	/**
	 * Устанавливает путь к XML файлу и создает объект
	 *
	 * @param string $file путь к XML файлу или сам файл
	 * @param bool $is_path определяет, является ли $file путем к файлу
	 * @return object
	 */
	public static function setObj($file,$is_path=true)
	{
		self::$file = $file;
		
		self::$DOM = new DOMDocument('1.0','utf-8');
		if($is_path)
		{
			self::$DOM -> load(self::$file);
		}
		else
		{
			self::$DOM -> loadXML(self::$file);
		}
		
		return self::$DOM;
	}
	
	/**
	 * Устанавливает данные 
	 *
	 * @param string $path дом путь к элементу
	 * @param string $value содержимое
	 */
	public static function setData($path=null,$value=null)
	{
		$XPath = new DOMXPath(self::$DOM);
		$Entries = $XPath -> query($path);
		foreach($Entries as $entry)
		{
			$entry -> firstChild -> nodeValue = $value.(!is_numeric($value) && !$value ? " " : "");
		}
	}
	
	/**
	 * Сохраняет xml файл
	 *
	 */
	public static function save()
	{
		if(is_object(self::$DOM))
		{
			if(!file_put_contents(self::$file, self::$DOM -> saveXML()) )
			{
				throw new Exception_Default(Lng::_('Не удалось сохранить данные'));
			}
			self::$DOM = null;
		}
	}
	
	/**
	 * Возвращает XML документ
	 *
	 * @return string
	 */
	public static function saveXML()
	{
		return self::$DOM -> saveXML();
	}
}