<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Blocks", для админа
 */

class Modules_Blocks_Controllers_Admin extends Guard_Controller
{
	/**
	 * Отображает таблицу со списком блоков
	 *
	 */
	public function indexAction()
	{
		//--> Формируем вид
		Factory::zebra();
		$this -> view -> block_path_ar = glob("./files/db/models/blocks/*.html");
	}
	
	/**
	 * Редактируем блок
	 *
	 */
	public function editAction()
	{
		$bl_name = Request::getGet("name");

		if(preg_match('/^[\w\-_]+$/i', $bl_name) == FALSE)
		{
			parent::redirect(Lng::_("FALSE:Не правильный формат блока"),"admin.php?mod=blocks");
		}
		
		if(Request::isPost())
		{
			if(parent::getModel("Blocks","Blocks") -> updateBlockByName($bl_name,Request::getPost("bl_content")))
			{
				parent::redirect(Lng::_("TRUE:Данные блока сохранены"),"admin.php?mod=blocks&go=edit&name=".$bl_name);	
			}
			parent::redirect(Lng::_("FALSE:Во время сохранения данных возникла ошибка"),"admin.php?mod=blocks&go=edit&name=".$bl_name);
		}
		
		//Получаем данные блока
		$bl_content = parent::getModel("Blocks","Blocks") -> getBlockByName($bl_name);
		
		//Проверяем, получили ли мы данные
		if($bl_name == FALSE)
		{
			throw new Exception_Message(Lng::_('Выбранный вами блок отсутствует'),1);
		}
		
		//--> Формируем вид
		Element_Wysiwyg::get(array(
			'id' => '#bl_content'
		));
		
		$this -> view -> bl_name	= $bl_name;
		$this -> view -> bl_content = $bl_content;
	}
}