<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, объявления", для админа
 */

class Modules_Board_Controllers_AdminAd extends Modules_Board_Controllers_Admin
{
	/**
	 * Отображаем список объявлений
	 *
	 */
	public function indexAction()
	{
		//Количество объявлений выводящееся на страницу
		$ad_on_page = 30;
		
		//Установка данных
		$cat_id = Request::getGet("cat_id","int");
		$ad_is_lock = FALSE;
		if(isset($_GET['ad_is_lock']))
		{
			$ad_is_lock = Request::getGet("ad_is_lock","int");
			
			if($ad_is_lock == 1)
			{
				setcookie('modBoard_ad_is_lock','1');
			}
			else
			{
				setcookie('modBoard_ad_is_lock','',-1,'/');
				$_COOKIE['modBoard_ad_is_lock'] = 0;
			}
		}
		if(isset($_COOKIE['modBoard_ad_is_lock']))
		{
			$ad_is_lock = $_COOKIE['modBoard_ad_is_lock'];
		}
		
		//Определяем номер текущей страницы
		$page = BreakPage::getPageNum();
		
		//Получаем данные категорий
		$this -> view -> category_ar = Category::createTree(parent::getModel("Category") -> prepCategory("getCategory"));
		
		if($cat_id > 0)
		{
			$cat_ar = parent::getModel("Category") -> getCategoryById($cat_id);
			
			$this -> view -> cat_title = Lng::_('Список объявлений категории')." \"".$cat_ar -> cat_title."\"";
			$this -> view -> Ads = parent::getModel("Ad") -> getAdByCatIdLimit($cat_id, (($page-1)*$ad_on_page), $ad_on_page, $ad_is_lock);
			$this -> view -> cat_id = $cat_id;
			$count_ad = parent::getModel("Ad") -> getCountAdByCatId($cat_id, $ad_is_lock);
		}
		else
		{
			$this -> view -> cat_title = Lng::_('Список объявлений');
			$this -> view -> Ads = parent::getModel("Ad") -> getAdByLimit((($page-1) * $ad_on_page), $ad_on_page, $ad_is_lock);
			$this -> view -> cat_id = 0;
			$this -> view -> ad_is_lock = $ad_is_lock;
			$count_ad = parent::getModel("Ad") -> getCountAd($ad_is_lock);
		}
		
		//Вызываем подсказку
		Element_Tooltip::get("span.skin-tooltip");
		
		Factory::zebra();
		$this -> view -> count_ad_links = 0;
		$this -> view -> breakpage = BreakPage::getPages($count_ad,$ad_on_page,$page,"admin.php?mod=board.ad&cat_id=".$cat_id."&page=");
	}
	
	/**
	 * Редактирует объявление
	 *
	 */
	public function editAction()
	{
		$ad_id = Request::getGet("ad_id","int");
		
		if(Request::isPost())
		{
			try
			{
				//Проверяем полученные данные
				parent::getLib() -> checkAdData(parent::getModel("Category"),array(
					'check_captcha' => FALSE
				));
				
				//Выполняем валидацию загружаемым файлам
				$ad_fotos_ar = parent::getLib() -> validateFotos();
				
				//Если указан сайт, то проверяем наличие "http://"
				if($_POST['ad_site'])
				{
					$_POST['ad_site'] = Str::http($_POST['ad_site']);
				}

				//Указываем даты окончания действия услуг
				$ad_vip_date 	= Request::getPost("ad_vip_date","string",0);
				$ad_style_date 	= Request::getPost("ad_style_date","string",0);
				$ad_style_ar	= Request::getPost("ad_style","array",array());
				$ad_topin_date 	= Request::getPost("ad_topin_date","string",0);
				$add_row_ar = array(
					'ad_vip_date' 	=> $ad_vip_date && Str::strlen($ad_vip_date) == 10 ? Str::convertDateToTimestamp($ad_vip_date) : 0,
					'ad_style' 		=> join('',$ad_style_ar),
					'ad_style_date' => $ad_style_date && Str::strlen($ad_style_date) == 10 && sizeof($ad_style_ar) > 0 ? Str::convertDateToTimestamp($ad_style_date) : 0,
					'ad_topin_date' => $ad_topin_date && Str::strlen($ad_topin_date) == 10 ? Str::convertDateToTimestamp($ad_topin_date) : 0,
					'ad_sum' => floatval($_POST['ad_sum']),
					'ad_meta_title' => Request::getPost("ad_meta_title")
				);

				//Обновляем объявление
				parent::getModel("Ad") -> updateAd(
					$ad_id,
					$_POST['ad_name'],
					$_POST['ad_email'],
					$_POST['ad_phone'],
					$_POST['ad_site'],
					$_POST['ad_title'],
					$_POST['ad_text'],
					$_POST['ad_region_id'],
					$_POST['cat_id'],
					$_POST['ad_is_lock'],
					$_POST['ad_keep'],
					$add_row_ar
				);
				
				if((isset($_FILES['ad_foto']) && $_FILES['ad_foto']['size']) || sizeof($ad_fotos_ar) > 0)
				{
					Site::setTimeLimit(0);
					
					//Создаем каталог дат
					$img_date_dir = parent::getLib() -> createImgPath(Modules_Board_Controllers_Index::PATH_DIR_NORMAL);
					
					//Если загрузили фотографию
					if(isset($_FILES['ad_foto']) && $_FILES['ad_foto']['size'])
					{
						try
						{
							//Загружаем и сохраняем фото
							parent::getLib() -> uploadAndSaveMainFoto(
								parent::getModel("Ad"), 
								$ad_id, 
								$img_date_dir
							);
						}
						
						catch (Exception $e)
						{
							parent::redirect(Lng::_("TRUE:Объявление сохранено, но изображение загрузить не удалось. Проверьте, подходит ли изображение к загрузке"),"admin.php?mod=board.ad&go=edit&ad_id=".$ad_id);
						}
					}
					
					//Загружаем дополнительные изображения
					if(sizeof($ad_fotos_ar) > 0)
					{
						//Расчитываем, сколько изображений можно еще загрузить
						$allow_uploads = Modules_Board_Controllers_Index::IMAGES_UPLOADED_COUNT ;
						$allow_uploads--;
						parent::getLib() -> uploadAndSaveAddFoto($ad_id, $ad_fotos_ar, $img_date_dir, $allow_uploads);
					}
				}

				parent::getLib("Mail")->adminWarnsAd(parent::getTemplate("mail.admin_warns_ad"), $_POST['ad_name'],
					$_POST['ad_email'], $_POST['ad_title'], $ad_code);

				parent::redirect(Lng::_("TRUE:Объявление отредактировано"),"admin.php?mod=board.ad&go=edit&ad_id=".$ad_id);
			}
			catch (Exception_CheckData $e)
			{
				parent::setMessage($e -> getMessage());
			}
		}
		
		//Подключаем скрипт автодополнения городов
		Factory::jsCode('var sys_images_count = '. Modules_Board_Controllers_Index::IMAGES_UPLOADED_COUNT);
		Factory::js('/scripts/modules/board/img.js');
		//Подключаем галерею
		Factory::fancyBox('a.ad_foto');
		Element_Datepicker::get('.field-date');
		
		//Подключаем скрипт маски номеров телефона
		Factory::js('/scripts/jquery/jquery.maskedinput.js');
				
		//Получаем данные объявления
		$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
		try
		{
			CheckData::existsDataObject($Ad);
		}
		catch (Exception $e)
		{
			throw new Exception_440(Lng::_('Выбранное Вами объявление отсутствует'));
		}
		
		//Работ со стилями
		if($Ad -> ad_style)
		{
			$this -> view -> style_ar = explode(";",$Ad -> ad_style);
			unset($this -> view -> style_ar[sizeof($this -> view -> style_ar)-1]);
		}
		$this -> view -> Ad = $Ad;
		//Получаем список городов
		$this -> view -> city_ar = parent::getModel('city','city') -> getListCityes();
		$this -> view -> ad_us_time = $Ad -> ad_keep - time();
		$this -> view -> category_ar = Category::createTree(parent::getModel("Category") -> prepCategory("getCategory"));
		//Получаем данные доп. изображений
		$this -> view -> ImagesAr = Models_Images::instance() -> getListImagesByObjId($ad_id, Modules_Board_Controllers_Index::GROUP_IMG);
	}
	
	/**
	 * Отображает объявление
	 *
	 */
	public function viewAction()
	{	
		$ad_id = Request::getGet("ad_id","int");

		//Получаем данные объявления
		$DataView = parent::getLib("Data") -> getViewAdActionData(
			parent::getModel("Ad"),
			parent::getModel("Category"),
			$ad_id
		);
		$this -> view -> Ad 		= $DataView -> Ad;
		$this -> view -> ad_keep 	= $DataView -> ad_keep; 
		$this -> view -> path_way 	= $DataView -> path_way;
		//Получаем данные доп. изображений
		$this -> view -> ImagesAr 	= Models_Images::instance() -> getListImagesByObjId($ad_id, Modules_Board_Controllers_Index::GROUP_IMG);
	}
	
	/**
	 * Отображает форму для удаления старыч объявлений
	 *
	 */
	public function oldadAction()
	{
		//Sets
		$DB = Factory::getModel() -> DB;
		$page = BreakPage::getPageNum();
		$ad_ar = array();
		
		if(Request::isPost() == TRUE)
		{
			$ad_ar = Request::getPost("ad_ar","array",array());
		}
		else if(isset($_GET['all']) == TRUE)
		{
			$Result = $DB -> setQuery("
				SELECT `ad_id`
					FROM 
				`#__mod_board_ad` 
					WHERE 
				`ad_keep`<".time(), 
				'Не удалось получить ID старых объявлений'
			);
			
			while($Data = $DB -> getObject($Result))
			{
				$ad_ar[$Data -> ad_id] = $Data -> ad_id;
			}
		}
		
		if(sizeof($ad_ar) > 0)
		{
			Site::setTimeLimit(0);

			//Фильтрация данных
			$ad_ar = array_map('intval', $ad_ar);

			//Получили данные объявлений
			$AdAr = parent::getModel("Ad","Board") -> getFotoAdByArId($ad_ar);
			//Получаем данные доп. фотографий
			$ImAr = Models_Images::instance() -> getListImagesByObjArId($ad_ar, Modules_Board_Controllers_Index::GROUP_IMG);

			//Удаляем доп. фотографии
			foreach($ImAr as $Im)
			{
				Modules_Board_Models_Ad::deleteImg($Im -> im_img);
			}

			//Удаляем доп. изображения с БД
			Models_Images::instance() -> deleteByObjArId($ad_ar, Modules_Board_Controllers_Index::GROUP_IMG);

			if(isset($_GET['imgs']))
			{
				parent::redirect(Lng::_("TRUE:Дополнительные изображения удалены"),'admin.php?mod=board.ad&go=oldad&page='.$page);
			}

			//Удаляем фотографии объявлений
			foreach($AdAr as $Ad)
			{
				if($Ad -> ad_foto)
				{
					Modules_Board_Models_Ad::deleteImg($Ad -> ad_foto);
				}	
			}

			//Если нужно, удаляем только изображения
			if(isset($_GET['img']))
			{
				//Устанавливаем изображениям объявлений NULL
				Factory::getModel() -> DB -> setQuery('
					UPDATE 
						`#__mod_board_ad` 
					SET 
						`ad_foto` = NULL
					WHERE 
						`ad_id` IN ('.join(',', $ad_ar).')', 
					'Не удалось обновить данные фотографий в БД'
				);

				parent::redirect(Lng::_("TRUE:Изображения удалены"),'admin.php?mod=board.ad&go=oldad&page='.$page);
			}

			//Удаляем старые объявления
			parent::getModel("Ad","Board") -> deleteAdByAdAr($ad_ar);
			//Удаляем рейтинг объявлений
			parent::getComponent("Rating",$this -> com_group_rating) -> getModel() -> deleteRatingByAr($ad_ar);
			parent::redirect(Lng::_("TRUE:Объявления удалены"),'admin.php?mod=board.ad&go=oldad&page='.$page);
		}
		
		//Определяем количество старых объявлений в БД
		$Result = $DB -> setQuery('
			SELECT COUNT(`ad_id`) AS `count_ad`
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`ad_keep`<'.time().'', 
			'Не удалось определить количество старых объявлений'
		);
		$Data = $DB -> getObject($Result);
		
		//Количество объявлений выводящееся на страницу
		$ad_on_page = 30;
		
		
		//--> Формируем вид
		Factory::zebra();
		Factory::js('/scripts/js/table.checked.js');
		//Получаем старые объявления
		$this -> view -> AdAr = parent::getModel("Ad") -> getOldAd(($page-1) * $ad_on_page, $ad_on_page);
		$this -> view -> count_ad = $Data -> count_ad;
		$this -> view -> page = $page;
		$this -> view -> breakpage = BreakPage::getPages($Data -> count_ad,$ad_on_page,$page,"admin.php?mod=board.ad&go=oldad&page=");
	}
	
	/**
	 * Удаляем фотографию объявления
	 *
	 */
	public function deletefotoAction()
	{
		$ad_id = Request::getGet("ad_id","int",0);
		$im_id = Request::getGet("im_id","int",0);
		
		//Удаляем доп. фотографию
		if($im_id > 0)
		{
			parent::getLib("Data") -> deleteAddFoto($im_id, $ad_id);
		}
		//Удаляем основную офотографию
		else
		{
			parent::getLib("Data") -> deleteFotoAdAction(parent::getModel("Ad"),$ad_id);
		}
		parent::redirect(Lng::_("TRUE:Фото объявления удалено"),"admin.php?mod=board.ad&go=edit&ad_id=".$ad_id);
	}
	
	/**
	 * Удаляет объявление
	 *
	 */
	public function deleteAction()
	{

		$ad_id = Request::getGet("ad_id","int",0);
		
		//Получаем данные объявления
		$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
		//Передаем данные в шаблон письма и отправляем его
		parent::getLib("Mail") -> adminDeleteAd(parent::getTemplate("mail.user_admin_delete_ad"), $Ad -> ad_name, $Ad -> ad_email, $Ad -> ad_title, $Ad -> ad_text, $Ad -> ad_code);
		
		//Удаляем доп. фотографии
		parent::getLib("Data") -> deleteAddFotos($ad_id);
		
		//Удаляем объявление
		parent::getLib("Data") -> deleteAdAction(parent::getModel("Ad"),parent::getComponent("Rating",$this -> com_group_rating),$ad_id);
		
		parent::redirect(Lng::_("TRUE:Объявление удалено"),"admin.php?mod=board.ad");
	}
	
	/**
	 * Блокирует/разблокирует объявление
	 *
	 */
	public function lockAction()
	{
		parent::getModel("Ad") -> updateAdLockedById($_GET['ad_id'],$_GET['lock']);
		if($_GET['lock'] == 1)
		{
			parent::redirect(Lng::_("TRUE:Объявление скрыто"),"admin.php?mod=board.ad");
		}
		else
		{	
			//получаем айди объявления
			$ad_id = Request::getGet("ad_id","int",0);
		
			//Получаем данные объявления
			$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
			//Передаем данные в шаблон письма и отправляем его
			parent::getLib("Mail") -> adminPublicateAd(parent::getTemplate("mail.user_admin_publicate_ad"), $Ad -> ad_name, $Ad -> ad_email, $Ad -> ad_title, $Ad -> ad_text, $Ad -> ad_code);
			
			parent::redirect(Lng::_("TRUE:Объявление опубликовано"),"admin.php?mod=board.ad");

		}
		
		if($_GET['lock'] == 0)
		{

		}
	}
	
	/**
	 * Экспорт объявлений
	 *
	 */
	public function exportAction()
	{
		if(Request::isPost())
		{
			try
			{
				Site::setTimeLimit(0);
				
				//Получаем данные всех объявлений
				$AdsAr = parent::getModel('Ad') -> getListAllAd();
				switch (Request::getPost("format","string"))
				{
					case'xml':
						$data_export = parent::getLib('Migration','Board') -> exportXML($AdsAr);
						$file_name = 'export_ad.xml';
					break;
					case'csv':
					default:
						$data_export = parent::getLib('Migration','Board') -> exportCSV($AdsAr);
						$file_name = 'export_ad.csv';
					break;
				}
				//Выдаем на загрузку экспортируемые данные
				UploadFile::loadContentAsFile($data_export, $file_name);
			}
			catch (Exception $e)
			{
				parent::redirect(Lng::_("FALSE:При экспорте данных возникла ошибка"),"admin.php?mod=board.ad&go=export");
			}
		}
	}
	
	/**
	 * Импорт объявлений
	 *
	 */
	public function importAction()
	{
		if(Request::isPost())
		{
			try
			{
				//Проверка наличия выбора пользователей
				if(Request::getPost('us_ar','bool',FALSE) == FALSE)
				{
					parent::redirect(Lng::_("FALSE:Выберете пользователя(ей) от имени которого будут опубликованы объявления"),"admin.php?mod=board.ad&go=import");
				}
				//Проверка наличия выбора рубрик
				if(Request::getPost('cat_id','bool',FALSE) == FALSE)
				{
					parent::redirect(Lng::_("FALSE:Выберете рубрику в которую будут импортированы данные"),"admin.php?mod=board.ad&go=import");
				}
				//Проверяем наличие загрузки файла			
				if(Request::isFileUpload('file_import') == FALSE)
				{
					parent::redirect(Lng::_("FALSE:Выберете файл для импорта"),"admin.php?mod=board.ad&go=import");
				}
				//Выполняем валидацию загруженного файла
				try
				{
					$Validate = new UploadFile($_FILES['file_import']);
					$Validate -> setFileExtensions(array('xml','csv','xls'));
					$Validate -> setFileByte(0,3072);
					$Validate -> validate();
				}
				catch (Exception $e)
				{
					throw new Exception_CheckData($e -> getMessage());
				}
				
				Site::setTimeLimit(0);
				
				//Установка данных
				$data_import_ar = array();
				
				switch (Request::getExtensionFileUpload('file_import'))
				{
					case 'xml':
						$data_import_ar = parent::getLib('Migration','Board') -> importXML($_FILES['file_import']['tmp_name']);
					break;
					case 'csv':
						$data_import_ar = parent::getLib('Migration','Board') -> importCSV($_FILES['file_import']['tmp_name']);
					break;
					case 'xls':
						$data_import_ar = parent::getLib('Migration','Board') -> importXLS($_FILES['file_import']['tmp_name']);
					break;
				}
				
				//Добавляем данные в БД
				if(sizeof($data_import_ar) == 0)
				{
					parent::redirect(Lng::_("FALSE:Данные для импорта отсутствуют. Проверте содержимое файла."),"admin.php?mod=board.ad&go=import");
				}

				//Импортируем данные
				parent::getModel("Ad") -> importAd(
					$data_import_ar, 
					Request::getPost('is_ad_id','bool'), 
					Request::getPost('is_region_id','bool'), 
					Request::getPost('is_vip','bool'), 
					Request::getPost('is_style','bool'), 
					Request::getPost('cat_id','intval'), 
					Request::getPost('us_ar','array')
				);

				parent::redirect(Lng::_("TRUE:Данные импортированы"),"admin.php?mod=board.ad&go=import");
			}
			catch(Exception_CheckData $e)
			{
				throw $e;
			}
		}
		
		Element_Tooltip::get('.skin-tooltip');
		
		//--> Формируем вид
		//Получаем данные рубрик / под рубрик
		$this -> view -> category_ar = Category::createTree(parent::getModel("Category") -> prepCategory("getCategory"));
		//Получаем данные пользователей
		$this -> view -> UsersAr = parent::getModel("Users","Users") -> getAllUsers();
	}

	/**
	 * Форма смены даты подачи и срока действия объявлений
	 *
	 */
	public function dateAction()
	{	
		//Получаем объект базы даннх
		$DB = Factory::getModel() -> DB;
		
		if(isset($_POST['ad_date']))
		{
			if($_POST['ad_date'] == FALSE)
			{
				parent::redirect(Lng::_("FALSE:Укажите дату"));
			}
			$DB -> setQuery('UPDATE `#__mod_board_ad` SET `ad_date`="'.intval(Str::convertDateToTimestamp(Request::getPost('ad_date'))).'"', 'Не удалось обновить дату подачи объявления');
			parent::redirect(Lng::_("TRUE:Дата обновлена"));
		}
		
		if(isset($_POST['ad_keep']))
		{
			if($_POST['ad_keep'] == FALSE)
			{
				parent::redirect(Lng::_("FALSE:Укажите дату"));
			}
			
			$DB -> setQuery('UPDATE `#__mod_board_ad` SET `ad_keep`="'.intval(Str::convertDateToTimestamp(Request::getPost('ad_keep'))).'"', 'Не удалось обновить дату срока действия объявления');
			parent::redirect(Lng::_("TRUE:Дата обновлена"));
		}
				
		Element_Datepicker::get('.field-date');
	}
}