<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, рубрики", для админа
 */

class Modules_Board_Controllers_AdminCategory extends Modules_Board_Controllers_Admin
{
	/**
	 * Отображает список рубрик
	 *
	 */
	public function indexAction()
	{
		//--> Формируем вид
		Factory::zebra();
		//Получаем рубрики объявлений
		$this -> view -> CategoryData = $CategoryData = parent::getModel("Category") -> getCategory();
		//Формируем массив дерева рубрик (понадобиться для определения родительский рубрик)
		$this -> view -> tree_cat_ar = $tree_cat_ar = parent::getModel("Category") -> prepCategory($CategoryData);
		$this -> view -> category_ar = Category::createTree($tree_cat_ar,0,0,"<sup>L</sup> ");
		$this -> view -> count_ar	 =  parent::getModel("Ad") -> getCountsAd();
	}
	
	/**
	 * Добавляет категорию объявлений
	 *
	 */
	public function addAction()
	{
		if(Request::isPost() == TRUE)
		{
			try
			{






				//Создаем категорию объявлений
				parent::getModel("Category") -> insertDataCategory(
					Request::getPost("parent_id","int"), 
					strip_tags(Request::getPost("cat_title")),
					strip_tags(Request::getPost("cat_meta_title")),
					strip_tags(Request::getPost("cat_meta_keywords")), 
					strip_tags(Request::getPost("cat_meta_description")), 
					Request::getPost("cat_desctiption"), 
					Request::getPost("cat_ads_top"), 
					Request::getPost("cat_ads_middle"), 
					Request::getPost("cat_ads_bottom"), 
					Request::getPost("cat_order","int")
				);

				//Получаем id только что созданнй категории
				$last_cat_id = parent::getModel("Category") -> getLastId();
				if($last_cat_id > 0)
				{
					//Если загрузили фотографию		
					if(Request::isFileUpload('cat_foto') == TRUE)

					{
						try
						{
							//Загружаем фотографию
							$this -> _uploadFile($last_cat_id);
							
							parent::redirect(Lng::_("TRUE:Рубрика создана"),"admin.php?mod=board.category&go=add&cat_id=".$parent_id);
						}
						catch (Exception $e)
						{
							Log::add($e, 'Во время загрузки фотографии к рубрики возникла ошибка');
							Site::setSkinVar("message",Site::getMessage('<p>'.Lng::_('Рубрика сохранена, но изображение загрузить не удалось.<br>Возможная причина:').'</p>'.$e -> getMessage(),1));
						}
					}
					else
					{
						parent::redirect(Lng::_("TRUE:Рубрика создана"),"admin.php?mod=board.category&go=add&cat_id=".$parent_id);
					}
				}
			}
			catch(Exception_CheckData $e)
			{
				throw new Exception_Message($e -> getMessage(),1);
			}
		}
		
		//View
		Element_Wysiwyg::get(array(
			'id' => '#cat_desctiption',
		));
		$this -> view -> page_title 	= Lng::_('Создание рубрики');
		$this -> view -> form_action 	= "admin.php?mod=board.category&go=add";
		$this -> view -> category_ar 	= Category::createTree(parent::getModel("Category") -> prepCategory("getCategory"),0,5);
		if(isset($_GET['cat_id']))
		{
			$this -> view -> cat_parent_id = (int)$_GET['cat_id'];
		}
	}

	
	/**
	 * Редактирует категорию объявлений
	 *
	 */
	public function editAction()
	{
		//Установка данных
		$cat_id = Request::getGet("cat_id","int");
		parent::setView('./modules/board/views/admin.category/add.phtml');
		
		if(Request::isPost() == TRUE)
		{
			try
			{
				//Обновляем данные рубрики
				parent::getModel("Category") -> updateDataCategory(
					$cat_id,
					Request::getPost("parent_id","int"), 
					strip_tags(Request::getPost("cat_title")),
					strip_tags(Request::getPost("cat_meta_title")),
					strip_tags(Request::getPost("cat_meta_keywords")), 
					strip_tags(Request::getPost("cat_meta_description")), 
					Request::getPost("cat_desctiption"), 
					Request::getPost("cat_ads_top"), 
					Request::getPost("cat_ads_middle"), 
					Request::getPost("cat_ads_bottom"), 
					Request::getPost("cat_order","int")
				);
				
				//Если загрузили фотографию		
				if(isset($_FILES['cat_foto']['size']) && $_FILES['cat_foto']['size'])
				{
					try
					{
						//Загружаем фотографию
						$this -> _uploadFile($cat_id);
						parent::redirect(Lng::_("TRUE:Рубрика отредактирована"),"admin.php?mod=board.category&go=edit&cat_id=".$cat_id);
					}
					catch (Exception $e)
					{
						Log::add($e, 'Во время загрузки фотографии к рубрики возникла ошибка');
						Site::setSkinVar("message",Site::getMessage('<p>'.Lng::_('Рубрика обновлена, но изображение загрузить не удалось.<br>Возможная причина:').'</p>'.$e -> getMessage(),1));
					}
				}
				else
				{
					parent::redirect(Lng::_("TRUE:Рубрика отредактирована"),"admin.php?mod=board.category&go=edit&cat_id=".$cat_id);
				}
			}
			catch(Exception_CheckData $e)
			{
				throw new Exception_Message($e -> getMessage(),1);
			}
		}
		
		//View
		Element_Wysiwyg::get(array(
			'id' => '#cat_desctiption',
		));

		Factory::fancyBox('a.cat_foto');
		$CatData = parent::getModel("Category") -> getCategoryById($cat_id);

		$this -> view -> page_title 	= Lng::_('Редактирование рубрики').' "'.$CatData -> cat_title.'"';
		$this -> view -> form_action 	= "admin.php?mod=board.category&go=edit&cat_id=".$CatData -> cat_id;







		$this -> view -> category_ar 	= Category::createTree(parent::getModel("Category") -> prepCategory("getCategory"),0,5);
		$this -> view -> addToView($CatData);
		$this -> view -> cat_foto 		= is_file(Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL.$CatData -> cat_id.".png") ? Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL.$CatData -> cat_id.".png" : "";		
	}
	
	/**
	 * Сортирует дочерние рубрикив
	 *
	 */
	public function sortAction()
	{
		if(Request::isPost() == TRUE)
		{
			//Получаем строку с сортировкой рубрик
			$cat_order = Request::getPost("cat_order","string");
			//Формируем массив
			$cat_order_ar = explode("|",$cat_order);
			unset($cat_order_ar[sizeof($cat_order_ar)-1]);
			//Обновляем данные сортировки рубрик
			foreach ($cat_order_ar as $order => $cat_id)
			{
				parent::getModel("Category") -> updateCategoryOrdersById($cat_id,$order);
			}
			parent::redirect(Lng::_("TRUE:Сортировка обновлена"),"admin.php?mod=board.category&go=sort&cat_parent_id=".Request::getGet("cat_parent_id","int"));
		}
		
		//Подключаем сортировку
		Element_Sortable::get("ul.jquery-sortable");
		
		//Получаем ID рубрики
		$this -> view -> cat_parent_id = Request::getGet("cat_parent_id","int",0);
		//Получаем данные дочерних рубрик
		$this -> view -> category_ar = parent::getModel("Category") -> getCategoryByParentAr(array($this -> view -> cat_parent_id));
	}
	
	/**
	 * Удаляет категорию объявлений
	 *
	 */
	public function deleteAction()
	{
		try
		{
			$cat_id = Request::getGet("cat_id","int");
			
			//Удаляем фото категории
			$this -> _deletefotocatAction();
			//Удаляем данные категории с БД
			parent::getModel("Category") -> deleteCategoryById($cat_id);
		}
		catch(Exception_CheckData $e)
		{
			throw new Exception_Message($e -> getMessage(),1);
		}
		parent::redirect(Lng::_("TRUE:Рубрика удалена"),"admin.php?mod=board.category");
	}
	
	/**
	 * Удаляет фотографию категории
	 *
	 */
	public function deletefotoAction()
	{
		$this -> _deletefotocatAction();
		parent::redirect(Lng::_("TRUE:Фото категории удалено"),"admin.php?mod=board.category&go=edit&cat_id=".$_GET['cat_id']);
	}
	
	
	/********************************************************************************************************************/
	/************************************************* PRIVATE METHODS **************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Удаляет фотографию рубрики
	 *
	 */
	private function _deletefotocatAction()
	{
		$_GET['cat_id'] = (int) $_GET['cat_id'];
		if(is_file(Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL.$_GET['cat_id'].".png"))
		{
			File::deleteFile(Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL.$_GET['cat_id'].".png");
		}
	}
	
	/**
	 * Загружает изображение
	 *
	 */
	private function _uploadFile($cat_id = 0)
	{
		//Загружаем изображение
		$UploadFile = new UploadFile($_FILES['cat_foto']);
		$UploadFile -> setFileName($cat_id.'.');
		$UploadFile -> setFileExtensions(Modules_Board_Controllers_Index::$upload_cat_extensions_ar);
		$UploadFile -> setFileByte(0, Modules_Board_Controllers_Index::UPLOAD_CAT_MAX_SIZE);
		$UploadFile -> setFilePx(1600, 1600);
		$UploadFile -> setFilePath(Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL);
		$foto = $UploadFile -> upload();
		
		//Уменьшаем изображение
    	$Image = Helper_Image::factory(Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL.$foto);
	   	if($Image -> width > Modules_Board_Controllers_Index::IMG_CAT_RESIZE)
    	{
    		$Image -> resize(Modules_Board_Controllers_Index::IMG_CAT_RESIZE, Modules_Board_Controllers_Index::IMG_CAT_RESIZE);
    	}
    	$Image -> save(Modules_Board_Controllers_Index::PATH_CAT_DIR_NORMAL.$foto);
    	
    	return $foto;
	}
}