<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, Pay", для админа
 */

class Modules_Board_Controllers_AdminPay extends Modules_Board_Controllers_Admin
{
	/**
	 * Отображаем список с платежами
	 *
	 */
	public function indexAction()
	{
		//Количество объявлений выводящееся на страницу
		$pays_on_page = 30;
		
		//Подключаем подсказки
		Element_Tooltip::get(".skin-tooltip");
		Factory::zebra();
		
		//Определяем номер текущей страницы
		$this -> view -> page = $page = BreakPage::getPageNum();
		
		//Устанавливаем данные платежей
		$this -> view -> PaysAr = parent::getModel("Pays") -> getPaysLimit((($page-1)*$pays_on_page),$pays_on_page);
		
		//Делаем разбивку по странично
		$this -> view -> breakpage = BreakPage::getPages(parent::getModel("Pays") -> getCountPays(),$pays_on_page,$page,"admin.php?mod=board.pay&page=",FALSE);
	}
	
	/**
	 * Просматриваем платеж
	 *
	 */
	public function viewAction()
	{
		//Получаем данные платежа
		$this -> view -> Pay = parent::getModel("Pays") -> getPayById(Request::getGet("py_id","int"));
		
		try
		{
			//Проверяем наличие данных в объекте
			CheckData::existsDataObject($this -> view -> Pay);
		}
		catch (Exception $e)
		{
			throw new Exception_Message(Lng::_('Выбранный Вами платеж отсутствует'),1);
		}
		
		//Получаем данные объявления
		$this -> view -> Ad = parent::getModel("Ad") -> getAdById($this -> view -> Pay -> py_parent_id);
		
		//Формируем название класса платежной системы
		$pay_class_name = "Pays_".$this -> view -> Pay -> py_code."_Pay";
		//Вызываем класс платежной системы
		$Pay = new $pay_class_name();
		$this -> view -> pay_addit_ar = $Pay -> getDescriptionObj($this -> view -> Pay -> py_description);
	}
	
	/**
	 * Изменение статуса платежа
	 *
	 */
	public function statusAction()
	{
		$py_status = Request::getGet("status","int",0);
		try
		{
			//-TS->
			parent::getModel("Pays") -> transactionStart();
			
			//Получаем данные платежа
			$PayData = parent::getModel("Pays") -> getPayById(Request::getGet("py_id","int",0));
			//Получаем настройки модуля
			$XMLSett = parent::getModel("Settings") -> getConfig();
			
			//Обновляем данные платежа
			parent::getModel("Pays") -> updatePayStatus($PayData -> py_id,$py_status);
			
			//Формируем данные для сохранения
			if($PayData -> py_operations == "vip")
			{
				$row_ar['ad_vip_date'] = $py_status == 1 ? (time() + ($XMLSett -> terms -> vip -> day * Str::DATE_DAY)) : 0;
			}
			else if($PayData -> py_operations == 'style')
			{
				if($py_status == 1)
				{
					$row_ar['ad_style_date'] = time() + ($XMLSett -> terms -> style -> day * Str::DATE_DAY);
					$row_ar['ad_style'] = mysql_real_escape_string((string)$XMLSett -> terms -> style -> style);
				}
				else
				{
					$row_ar['ad_style_date'] = 0;
					$row_ar['ad_style'] = "";
				}
			}
			else
			{
				if($py_status == 1)
				{
					$row_ar['ad_topin_date'] = time() + $XMLSett -> terms -> topin -> day * Str::DATE_DAY;
				}
				else
				{
					$row_ar['ad_topin_date'] = 0;
				}
			}
			//Обновляем данные объявления
			parent::getModel("Ad") -> updatePayRowById($PayData -> py_parent_id,$row_ar);
			
			//-TC->
			parent::getModel("Pays") -> transactionCommit();
		}
		catch (Exception $e)
		{
			//-TR->
			parent::getModel("Pays") -> transactionRollback();
			parent::redirect(Lng::_("FALSE:Во время изменения статуса платежа возникла ошибка"),"admin.php?mod=board.pay");
		}
		parent::redirect(Lng::_("TRUE:Статус платежа успешно изменен"),"admin.php?mod=board.pay");
	}
	
	/**
	 * Удаляем платеж
	 *
	 */
	public function deleteAction()
	{
		//Удаляем платеж
		parent::getModel("Pays") -> deletePayById(Request::getGet("py_id","int"));
		parent::redirect(Lng::_("TRUE:Платеж успешно удален"),"admin.php?mod=board.pay");
	}
}