<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений", для админа
 */

class Modules_Board_Controllers_Admin extends Guard_Controller
{
	
	/**
	 * Имя группы рейтинга для компонента рейтинга
	 *
	 * @var string
	 */
	protected $com_group_rating = 'board_ad';
	
	/**
	 * Отображаем список объявлений
	 *
	 */
	public function indexAction()
	{
		URL::redirect("/admin.php?mod=board.ad");	
	}
	
	/*===============================================================================================*/
	/*============================  ПРАВИЛА ПУБЛИКАЦИИ ОБЪЯВЛЕНИЙ  ==================================*/
	/*===============================================================================================*/
	
	/**
	 * Редактируем правила публикации объявлений на сайте
	 *
	 */
	public function ruleAction()
	{
		if(Request::isPost())
		{
			parent::getModel() -> setTextRule(Request::getPost("text"));
			parent::redirect(Lng::_("TRUE:Правила публикации объявлений сохранены"));
		}
		
		Element_Wysiwyg::get(array(
			'id' => '#text'
		));
		$this -> view -> rule = parent::getModel() -> getTextRule();
	}
	
	/*===============================================================================================*/
	/*============================  ПРАВИЛА ПУБЛИКАЦИИ ОБЪЯВЛЕНИЙ  ==================================*/
	/*===============================================================================================*/
	
	/**
	 * Платыные услуги
	 *
	 */
	public function paysAction()
	{
		if(Request::isPost())
		{
			parent::getModel() -> setTextPays(Request::getPost("text"));
			parent::redirect(Lng::_("TRUE:Страница сохранена"));
		}
		
		Element_Wysiwyg::get(array(
			'id' => '#text'
		));
		$this -> view -> pay = parent::getModel() -> getTextPays();
	}
	
	/*===============================================================================================*/
	/*===================================  НАСТРОЙКИ САЙТА  =========================================*/
	/*===============================================================================================*/
	
	public function settingsAction()
	{
		if(Request::isPost())
		{
			//Обновляем данные настроек
			parent::getModel("Settings") -> setConfig(Request::post());
			
			parent::redirect(Lng::_("TRUE:Настройки сохранены"));
		}
		
		//Получаем данные настроек
		$Data = parent::getModel("Settings") -> getConfig();
		
		$this -> view -> Data = $Data; 
		
		//Работа со стилями
		if($Data -> terms -> style -> style)
		{
			$this -> view -> style_ar = explode(";",$Data -> terms -> style -> style);
			unset($this -> view -> style_ar[sizeof($this -> view -> style_ar)-1]);
		}
	}
	
	/**
	 * Очистка кэша
	 *
	 */
	public function cachAction()
	{
		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		
		switch (Request::getGet("delete"))
		{
			case 'topin':
				$Cache -> remove('Modules_Board_Libs_Catch::getTopinAdAr', Modules_Board_Controllers_Index::CATCH_GROUP);
			break;
			case 'rss':
				$Cache -> clean(Services_RssBoard_Service::CATCH_GROUP);
			break;
			case 'cat':
				$Cache -> remove('Modules_Board_Libs_Catch::getCatAr', Modules_Board_Controllers_Index::CATCH_GROUP);
				$Cache -> remove('Modules_Board_Libs_Catch::getCountAdInCategory', Modules_Board_Controllers_Index::CATCH_GROUP);
			break;
		}
		parent::redirect(Lng::_("TRUE:Кэш удален"),"admin.php?mod=board&go=settings");
	}
}