<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, статистика", для админа
 */

class Modules_Board_Controllers_AdminStatistics extends Modules_Board_Controllers_Admin
{
	/**
	 * Количество секунд в месяце
	 *
	 * @var int
	 */
	private $day_month = 2678400;
	/**
	 * Отображает диаграму популярности категорий за все время
	 *
	 */
	public function indexAction()
	{
		//Подключаем нужные библиотеки
		include_once("./library/open_flash_chart/open_flash_chart_object.php");
		
		$this -> view -> output = open_flash_chart_object_str(700, 500, "admin.php?mod=board.statistics&go=fl_datacat" ,false,"./library/open_flash_chart/");
	}
	
	/**
	 * Формирует данные для диаграмы популярности рубрик
	 *
	 */
	public function fl_datacatAction()
	{
		//Подключаем библиотеки
		include_once("./library/open_flash_chart/open-flash-chart.php");
		
		//Первоночальная установка данных
		$x_labels_ar = array();
		$x_data_ar = array();
		$max_count_ad = 0;
		
		//Получаем данные всех категорий и формируем с них дерево
		$cat_ar = parent::getModel("Category") -> prepCategory("getCategory");
		//Получаем количество объявлений в категориях
		$cat_ad_ar = parent::getModel("Category") -> getCountAdInCategory();
		
		//Подсчитываем объявления в родительских категориях
		parent::getLib() -> getCountAdInCat($cat_ad_ar,0,$calc_cat_ar);
		
		foreach ($cat_ar[0] as $parent_cat_id => $parent_cat_title)
		{
			$count_ad = isset($calc_cat_ar[0][$parent_cat_id]) ? $calc_cat_ar[0][$parent_cat_id] : 0;
			if($count_ad > $max_count_ad)
			{
				$max_count_ad = $count_ad;
			}
			$x_labels_ar[$parent_cat_id] = $parent_cat_title;
			$x_data_ar[$parent_cat_id] = $count_ad;
		}
		
		$g = new graph();
		
		//Устанавливаем данные		
		$g -> set_data($x_data_ar);
		//Строим гистограмму, указываем для нее - прозрачность, цвет, подпись, размер шрифта для подписи 
		$g -> bar( 80, '#C0504D', Lng::_('Рубрики'), 10 );
		
		//Подписи по оси Х. Их количество должно быть равно количеству массива data_sets 
		$g -> set_x_labels($x_labels_ar);

		//Цвет, размер шрифта, шаг вывода подписей по оси Х
		$g -> set_x_label_style(9,'#000000',0,1);
		
		//and tick every second value:
		$g -> set_x_axis_steps(1);

		//Максимальная высота по оси Y
		$g -> set_y_max($max_count_ad);
		//Минимальная высота по оси Y
		$g -> set_y_min(0);
		//Количество делений по оси Y
		$g -> y_label_steps($max_count_ad);
		
		//Подпись, размер шрифта и цвет легенды по оси Х
		$g -> set_x_legend(Lng::_('Рубрики'), 12, '#C0504D' );
	
		//Подсказка
		$g -> set_tool_tip( '#x_label# - #val# '.Lng::_('шт.') );
		
		echo $g -> render();
		exit;
	}
	
	/**
	 * Отображает график размещения объявлений
	 *
	 */
	public function countadAction()
	{
		Element_Datepicker::get("#fdata, #tdata");

		//Получаем данные
		$fdata = $this -> view -> fdata = Request::getPost("fdata","string",Str::dateD(time() - $this -> day_month));
		$tdata = $this -> view -> tdata = Request::getPost("tdata","string",Str::dateD());
		
		//Подключаем нужные библиотеки
		include_once("./library/open_flash_chart/open_flash_chart_object.php");
		
		$this -> view -> output = open_flash_chart_object_str(700, 500, "admin.php?mod=board.statistics&go=fl_datacountad&fdata=".$fdata."&tdata".$tdata ,false,"./library/open_flash_chart/");
	}
	
	/**
	 * Формирует данные для графика размещения объявлений
	 *
	 */
	public function fl_datacountadAction()
	{
		//Подключаем библиотеки
		include_once("./library/open_flash_chart/open-flash-chart.php");
		
		//Первоначальная установка данных
		$fdata = Request::getGet("fdata","string",Str::dateD(time() - $this -> day_month));
		$tdata = Request::getGet("tdata","string",Str::dateD());
		
		//Конвертирует дату в Timestamp
		$fdata_t = Str::convertDateToTimestamp($fdata,".",0,0,0);
		$tdata_t = Str::convertDateToTimestamp($tdata,".",23,59,59);
		
		//Получаем данные объявлений
		$AdAr = parent::getModel("Ad","Board") -> getIdAdByFDateTDate($fdata_t,$tdata_t);
		
		$data_ar = array();
		$max_ad = 0;
		//Формируем массив с датами со значением 0
		for($i = $fdata_t; $tdata_t > $i; $i+=Str::DATE_DAY)
		{
			$data_ar[Str::dateD($i)] = 0;
		}
		
		foreach ($AdAr as $Ad)
		{
			if(!isset($data_ar[Str::dateD($Ad -> ad_date)]))
			{
				$data_ar[Str::dateD($Ad -> ad_date)] = 0;
			}
			$data_ar[Str::dateD($Ad -> ad_date)]++;
		}
		
		//Определяем максимальное количество объявлений
		if (sizeof($data_ar))
		{
			$data_ar_ = $data_ar;
			rsort($data_ar_);
			$max_ad = reset($data_ar_);	
		}
		
		$xl_step = 0;
		$count_label = sizeof($data_ar);
		if($count_label >= 90)
		{
			$xl_step = 10;
		}
		else if($count_label >= 75)
		{
			$xl_step = 9;
		}
		else if($count_label >= 60)
		{
			$xl_step = 8;
		}
		else if($count_label >= 45)
		{
			$xl_step = 7;
		}
		else if($count_label >= 30)
		{
			$xl_step = 6;
		}
		else if($count_label >= 25)
		{
			$xl_step = 3;
		}
		else if($count_label >= 10)
		{
			$xl_step = 2;
		}
		else
		{
			$xl_step = 1;
		}
		$g = new graph();
		//Устанавливаем данные		
		$g -> set_data($data_ar);

		//Строим график. Параметры - толщена линии, размер точки, цвет линии, подпись, размер шрифта для подписи
		$g->line_dot(2,4,'#C0504D', Lng::_('Объявления'),10);
		
		//Подписи по оси Х. Их количество должно быть равно количеству массива data_sets 
		$g -> set_x_labels(array_keys($data_ar));

		//Цвет, размер шрифта, шаг вывода подписей по оси Х
		$g -> set_x_label_style(9,'#000000',0,$xl_step);
		
		//and tick every second value:
		$g -> set_x_axis_steps(1);

		//Максимальная высота по оси Y
		$g -> set_y_max($max_ad);
		//Минимальная высота по оси Y
		$g -> set_y_min(0);
		//Количество делений по оси Y
		$g -> y_label_steps($max_ad);
		
		//Подпись, размер шрифта и цвет легенды по оси Х
		$g -> set_x_legend(Lng::_('Даты'), 12, '#C0504D');
		
		//Подсказка
		$g -> set_tool_tip( '#x_label# - #val# '.Lng::_('шт.') );
		
		echo $g -> render();
		exit;
	}
}