<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, подписчики", для админа
 */

class Modules_Board_Controllers_AdminSubscribe extends Modules_Board_Controllers_Admin
{
	/**
	 * Отображает список подписчиков
	 *
	 */
	public function indexAction()
	{
		//Количество подписчиков на страницу		
		$sb_on_page = 100;
		
		//Определяем номер текущей страницы
		$page = BreakPage::getPageNum();
		
		//Получаем список подписчиков
		$this -> view -> SbAr = parent::getModel("Subscribe") -> getSubscribeByLimit((($page-1)*$sb_on_page),$sb_on_page);
		//Определяем количество подписчиков
		$count_sb = parent::getModel("Subscribe") -> getCountSubscribe();
		
		Factory::zebra();
		//Получаем разбивку по странично
		$this -> view -> breakpage = BreakPage::getPages($count_sb,$sb_on_page,$page,"admin.php?mod=board.subscribe&page=",false);
	}
	
	/**
	 * Отображаем форму рассылки объявлений
	 *
	 */
	public function subscribeAction()
	{
		//Подключаем элемент Datepicker
		Element_Datepicker::get("#data_from");
	}
	
	/**
	 * Делаем рассылку объявлений
	 *
	 */
	public function aj_sendadAction()
	{
		CheckData::isAjax();
		
		try
		{
			Site::setTimeLimit(0);
			
			//|-->Первоначальная установка данных
			//Получаем конфигурационные данные
			$Config =& Registry::get("Config");
			//Конвертируем дату в требуемую
			$time = Str::convertDateToTimestamp(Request::getPost("data_from"),".",0,0,0);
			$mails = ''; 
			$subject = Lng::_('Рассылка объявлений с сайта').' "'.$Config -> site -> title.'"';
	
			//Получаем подписчиков
			$SbAr = parent::getModel("Subscribe") -> getListSubscriberByActive(1);
	
			//В том случае, если подписчики отсутствуют, рассылку не делаем
			if(sizeof($SbAr) == 0)
			{
				Factory::answerAjax(array(
					"message" => Lng::_('Подписчики для рассылки отсутствуют')
				));
			}
			//Получаем объявления
			$AdAr = parent::getModel("Ad") -> getAdByDateLt($time);
			//В том случае, если подписчики отсутствуют, рассылку не делаем
			if(sizeof($AdAr) == 0)
			{
				Factory::answerAjax(array(
					"message" => Lng::_('Объявления для рассылки отсутствуют')
				));
			}

			//Создаем тело письма со списка объявлений
			$Phtml = parent::getTemplate("mail.subscribe_last_ad");
			$Phtml -> site_host = $Config -> site -> host;
			$Phtml -> AdAr = $AdAr;
			//Получаем тело сообщения
			$body = $Phtml -> getView();
			
			foreach($SbAr as $Sb)
			{
				$mails .= $Sb -> sb_email."<br>";
				
				$signature = '
				<p>
					'.Lng::_('Чтобы отписаться от рассылки, перейдите по ссылке').
					' "'.Helper_HTML::anchor($Config -> site -> host.'/index.php?mod=board&go=unsubscribe&sb_id='.$Sb -> sb_id, Lng::_('отписаться от расслки')).'"
				</p>';
				
				if(Mail::sendMail(NULL, $Config -> emails -> noreply, NULL, $Sb -> sb_email, $subject, $body.$signature) == FALSE)
				{
					Factory::answerAjax(array(
						'error' => '<span class="important">'.Lng::_('Во время рассылки объявлений кроном, возникла ошибка').'</span>'
					));
				}
			}
		}
		catch (Exception $e)
		{
			Factory::answerAjax(array(
				'error' => '<span class="important">'.$e -> getMessage().'</span>'
			));
		}
		
		//Делаем запись в лог о работе крона
		File::write("./files/.logs/cron-mod_board-subscribe.log",Str::dateDTS()." [".Lng::_('отослано ')."- ".sizeof($SbAr)." (".sizeof($AdAr)." ".Lng::_('объявл.').") ".Lng::_('объявлений')."] \n",FILE_APPEND);
				
		Factory::answerAjax(array(
			'message' => "<b>".Lng::_('Отправлено')." ".sizeof($SbAr)." ".Lng::_('писем')." (".sizeof($AdAr)." ".Lng::_('объявл.')."),<br>".Lng::_('за период с')." ".Request::getPost("data_from")." ".Lng::_('по')." ".Str::dateD()."</b><div align=\"left\">$mails</div>"
		));
	}
	
	/**
	 * Возобновляет/преостонавливает подписку
	 *
	 */
	public function activeAction()
	{
		parent::getModel("Subscribe") -> updateSbActiveById($_GET['sb_id'],$_GET['active']);
		parent::redirect(Request::getGet("active","bool",false) ? Lng::_("TRUE:Подписка включена") : Lng::_("TRUE:Подписка выключена") ,"admin.php?mod=board.subscribe");	
	}
	
	/**
	 * Удаляет подписчика с БД
	 *
	 */
	public function deleteAction()
	{
		//Удаляем подписку
		parent::getModel("Subscribe") -> deteteSubscribeById($_GET['sb_id']);
		parent::redirect(Lng::_("TRUE:Подписчик успешно удален"),"admin.php?mod=board.subscribe");
	}
}