<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, Ad", для гостя
 */

class Modules_Board_Controllers_IndexAd extends Modules_Board_Controllers_Index
{
	/***********************************************************************************************************************************/
	/************************************************** ПИШЕМ ПИСЬМО АВТОРУ ОБЪЯВЛЕНИЯ *************************************************/
	/***********************************************************************************************************************************/
	
	/**
	 * Отображаем форму отправки почтового сообщения подателю объявления
	 *
	 */
	public function aj_form_mailAction()
	{
		$this -> view -> form_action = "index.php?mod=board.ad&go=aj_sendmail&ad_id=".Request::getGet("ad_id","int");
		if(CheckData::isAjax(FALSE) == FALSE)
		{
			Element_Thickbox::get();
			Factory::js('/scripts/modules/board/ad.js');
			Site::addSkinVar('title',"Написать письмо автору");
		}
		else
		{
			die(parent::getView());
		}
	}

	/**
	 * Отправляем письмо
	 *
	 */
	public function aj_sendmailAction()
	{
		CheckData::isAjax();
		
		//Первоначальная утановка данных		
		$ml_name = Request::getPost("ml_name");
		$ml_email = Request::getPost("ml_email");
		
		//Получаем данные объявления
		$AdData = parent::getModel("Ad") -> getAdById(Request::getGet("ad_id","int"));
		
		//Проверяем правильность КАПЧИ
		if(!CheckData::captcha(Request::getPost("check_access")))
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Не правильно введен защитный код')
			));
		}
		//Проверяем правильность формата EMAIL
		try
		{
			CheckData::email($ml_email);
		}
		catch (Exception_CheckData $e)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('E-mail введен в не правильном формате')
			));
		}
		
		//Получаем конфигруационные данные
		$Config =& Registry::get("Config");
		
		//Отправляем письмо пользователю разместивщему объявление
		$this -> view -> ml_name 		= $ml_name;
		$this -> view -> ml_email 		= $ml_email;
		$this -> view -> ml_text 		= nl2br(strip_tags(Request::getPost("ml_text")));
		$this -> view -> page_url 		= $Config -> site -> host.'/index.php?mod=board&go=ad&ad_id='.$AdData -> ad_id;
		$this -> view -> ad_title 		= $AdData -> ad_title;
		$this -> view -> site_host 		= (string)$Config -> site -> host;
		$this -> view -> site_title		= (string)$Config -> site -> title;
		
		$subject = Lng::_('Объявление')." \"".$AdData -> ad_title."\", ".Lng::_('с сайта')." - \"".$Config -> site -> title."\"";
		
		if(Mail::sendMail($ml_name,$ml_email,$AdData -> ad_name,$AdData -> ad_email,$subject,parent::getView()) == FALSE)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Во время отправки сообщения возникла ошибка, свяжитесь с администратором сайта для ее устранения')
			));
		}
		Factory::answerAjax(array(
			"msg" => Lng::_('Письмо отправлено')
		));
	}
	
	
	/***********************************************************************************************************************************/
	/****************************************************** ОТПРАВКА ССЫЛКИ ДРУГУ ******************************************************/
	/***********************************************************************************************************************************/
	
	/**
	 * Отображаем форму "отправить ссылку другу"
	 *
	 */
	public function aj_form_sendlinkAction()
	{
		$this -> view -> form_action = "index.php?mod=board.ad&go=aj_sendlink&ad_id=".Request::getGet("ad_id","int");
		$this -> view -> link = URL::site("index.php?mod=board&go=ad&ad_id=".Request::getGet("ad_id","int"));
		if(CheckData::isAjax(FALSE) == FALSE)
		{
			Element_Thickbox::get();
			Factory::js('/scripts/modules/board/ad.js');
			Site::addSkinVar('title',"Отправить ссылку другу");
		}
		else
		{
			die(parent::getView());
		}
	}
	
	/**
	 * Отправляем ссылку другу
	 *
	 */
	public function aj_sendlinkAction()
	{
		CheckData::isAjax();
		
		//Проверяем данные формы
		if(!CheckData::captcha(Request::getPost("check_access")))
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Не правильно введен защитный код')
			));
		}
		$sl_text = Request::getPost("sl_text","string",false);
		if(!$sl_text)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Введите содержимое письма')
			));
		}
		
		//Получаем конфигруационные данные
		$Config =& Registry::get("Config");
		
		//Тема письма
		$subject = Lng::_('С сайта')." - \"".$Config -> site -> title."\", ".Lng::_('Вам выслана ссылка на объявление');
		
		//Содержимое письма
		$this -> view -> site_host 	= (string)$Config -> site -> host;
		$this -> view -> site_title	= (string)$Config -> site -> title;
		$this -> view -> sl_text	= nl2br(strip_tags($sl_text));
		$this -> view -> from_name 	= $from_name 	= Request::getPost("from_name");
		$this -> view -> from_email = $from_email 	= Request::getPost("from_email");
		$this -> view -> to_name 	= $to_name 		= Request::getPost("to_name");
		$this -> view -> to_mail 	= $to_mail 		= Request::getPost("to_mail");
		
		if(Mail::sendMail($from_name,$from_email,$to_name,$to_mail,$subject,parent::getView()) == FALSE)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Во время отправки письма возникла ошибка, попытайтесь отправить письмо еще раз, проверьте введенные данные')
			));
		}
		
		Factory::answerAjax(array(
			"msg" => Lng::_('Письмо отправлено')
		));
	}
	
	/***********************************************************************************************************************************/
	/********************************************************* ОТПРАВКА ЖАЛОБЫ *********************************************************/
	/***********************************************************************************************************************************/
	
	/**
	 * Отображает форму жалования на объявление
	 *
	 */
	public function aj_form_complainAction()
	{
		$this -> view -> form_action = "index.php?mod=board.ad&go=aj_sendcomplain&ad_id=".Request::getGet("ad_id","int");
		if(CheckData::isAjax(FALSE) == FALSE)
		{
			Element_Thickbox::get();
			Factory::js('/scripts/modules/board/ad.js');
			Site::addSkinVar('title',"Пожаловаться на объявление");
		}
		else
		{
			die(parent::getView());
		}
	}

	/**
	 * Отправляем жалобу администратору
	 *
	 */
	public function aj_sendcomplainAction()
	{
		CheckData::isAjax();
		
		//Проверяем данные формы
		if(!CheckData::captcha(Request::getPost("check_access")))
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Не правильно введен защитный код')
			));
		}
		$cp_text = Request::getPost("cp_text","string",false);
		if(!$cp_text)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Введите жалобу')
			));
		}
		
		try
		{
			//Получаем данные объявления
			$AdData = parent::getModel("Ad") -> getAdById(Request::getGet("ad_id","int",0));
		}
		catch (Exception $e)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Во время отправки жалобы возникла ошибка, попытайтесь отправить жалобу еще раз')
			));
		}
		
		//Получаем конфигруационные данные
		$Config =& Registry::get("Config");
		
		//Тема письма
		$subject = Lng::_('С сайта')." - \"".$Config -> site -> title."\", ".Lng::_('поступила жалоба на объявление')." - \"".$AdData -> ad_title."\"";
		
		//Содержимое письма
		$this -> view -> site_host 	= (string)$Config -> site -> host;
		$this -> view -> site_title	= (string)$Config -> site -> title;
		$this -> view -> ad_title	= $AdData -> ad_title;
		$this -> view -> ad_id		= $AdData -> ad_id;
		$this -> view -> cp_text	= nl2br(strip_tags($cp_text));
		$this -> view -> data		= Str::dateDTS();
		
		if(Mail::sendMail(NULL,$Config -> emails -> noreply,$Config -> contacts -> admin,$Config -> contacts -> email,$subject,parent::getView()) == FALSE)
		{
			Factory::answerAjax(array(
				"error" => Lng::_('Во время отправки жалобы возникла ошибка, попытайтесь отправить жалобу еще раз')
			));
		}
		
		Factory::answerAjax(array(
			"msg" => Lng::_('Жалоба отправлена')
		));
	}
	
	
	/***********************************************************************************************************************************/
	/************************************************************* РАЗНОЕ **************************************************************/
	/***********************************************************************************************************************************/
	
	/**
	 * Сохраняет рейтинг объявления
	 *
	 */
	public function aj_ratingAction()
	{
		CheckData::isAjax();
		
		$obj_id = Request::getPost("obj_id","int",0);
		try
		{
			//Подключаем компонент рейтинга
			$ComRating = parent::getComponent("Rating",$this -> com_group_rating);
			$ComRating -> updateRatingById($obj_id,Request::getPost("rating","int",0));
			
			if(!isset($_COOKIE['modBoard_rating'][$obj_id]))
			{
				setcookie("modBoard_rating[".$obj_id."]",$obj_id,time()+32140800);
			}
			
			$ComRating -> showJSONRatingById($obj_id);
		}
		catch (Exception $e)
		{
			Factory::answerAjax(array(
				"error" => $e -> getMessage()
			));
		}
	}
	
	/**
	 * Создает e-mail картинку почтового адреса 
	 *
	 */
	public function createmailAction()
	{
		//Первоначальная установка данных
		$ad_id = Request::getGet('ad_id','int');
		//Получаем данные объявления
		$AdData = parent::getModel("Ad") -> getAdById($ad_id);
		
		if(isset($AdData -> ad_email) && $AdData -> ad_email)
		{
			// Create image
			$im = imagecreate(strlen($AdData -> ad_email)*7, 15);
			// White background and blue text
			imagecolorallocate($im, 255, 255, 255);
			// Write the string at the top left
			imagestring($im, 2, 0, 0, $AdData -> ad_email,imagecolorallocate($im, 0, 0, 0));
			// Output the image
			header('Content-type: image/png');
			
			imagepng($im);
			imagedestroy($im);
		}
		exit;
	}
	
	/**
	 * Отображаем схожие по тематике объявления
	 *
	 */
	public function aj_similaradAction()
	{
		CheckData::isAjax();

		try
		{
			//Получаем данные объявления
			$AdData = parent::getModel("Ad") -> getAdById(Request::getGet("ad_id","int"));
			try
			{
				CheckData::existsDataObject($AdData);
			}
			catch (Exception $e)
			{
				exit;
			}
			//Подключаем шаблон оформления
			$Phtml = parent::getTemplate("view.similarad");
			//Получаем объявления текущей рубрики
			$AdAr = parent::getModel("Ad","Board") -> getAdForSimilarByCatIdLimit($AdData -> cat_id,10);
			unset($AdAr[$AdData -> ad_id]);
			$Phtml -> SimilAdAr = parent::getLib() -> getSimilarAd($AdData -> ad_title,$AdAr);
		
		}
		catch (Exception $e)
		{
			exit;
		}
		die($Phtml -> getView());
	}
	
	
	/**
	 * Отображаем форму с выбором платежной системы
	 *
	 */
	public function aj_form_payAction()
	{
		//Первоначальная установка данных
		$ad_id 	= Request::getGet("ad_id","int");
		$type 	= Request::getGet("type");
		
		//Получаем данные объявления
		$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
		//Получаем настройки модуля
		$XMLSett = parent::getModel("Settings") -> getConfig();
		
		//Объект классов платежных систем
		$Pays = new stdClass();
		
		$pays_ar = (array)$XMLSett -> pay;
		foreach($pays_ar as $xml_pay_code => $Pay)
		{
			if($Pay -> isSwitch == "1")
			{
				//Формируем название класса платежной системы
				$class_name = "Pays_".$xml_pay_code."_Pay";
				
				$Pays -> $xml_pay_code = new $class_name();
			}
		}
		$this -> view -> Pays 		= $Pays;
		$this -> view -> ad_id 		= $ad_id;
		$this -> view -> type 		= $type;
		$this -> view -> ad_title 	= $Ad -> ad_title;
		$this -> view -> page_title	= parent::getLib() -> getPayTypeService($type);
		
		if(CheckData::isAjax(FALSE) == FALSE)
		{
			Element_Thickbox::get();
			Factory::js('/scripts/modules/board/ad.js');
			Site::addSkinVar('title',$this -> view -> page_title);
		}
		else
		{
			die(parent::getView());
		}
	}
	
	
	/**
	 * Добавляем запись в блокнот
	 *
	 */
	public function aj_notepadAction()
	{
		//Ограничеваем доступ к контроллеру
		User::checkPrivilegesPage(array(User::ROLE_USER, User::ROLE_ADMIN), TRUE);
		
		//Установка данных
		$ad_id = Request::getGet("ad_id","int");
		
		try
		{
			//Добавляем объявление в блокнот
			Modules_Board_Models_Notepad::instance() -> add(User::get('id'), $ad_id);
		}
		catch (Exception $e)
		{
			if(CheckData::isAjax(FALSE) == FALSE)
			{
				parent::redirect(Lng::_("FALSE:Во время добавления объявления в блокнот возникла ошибка"),"index.php?mod=board&go=ad&ad_id=".$ad_id);
			}
			else
			{
				Factory::answerAjax(array(
					'message' => 'Во время добавления объявления в блокнот возникла ошибка',
					'is_error' => 1,
				));
			}
		}
		
		if(CheckData::isAjax(FALSE) == FALSE)
		{
			parent::redirect(Lng::_("TRUE:Объявление добавлено в блокнот"),"index.php?mod=board&go=ad&ad_id=".$ad_id);
		}
		else
		{
			Factory::answerAjax(array(
				'message' => 'Объявление добавлено в блокнот',
				'is_error' => 0,
			));
		}
	}
}