<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, Cron", для гостя
 */

class Modules_Board_Controllers_IndexCron extends Modules_Board_Controllers_Index
{
	/**
	 * Кроном делаем рассылку по почте
	 *
	 */
	public function subscribeAction()
	{
		Site::setTimeLimit(0);
	
		//Получаем конфигурационные данные
		$Config =& Registry::get("Config");
		
		//Получаем подписчиков
		$SbAr = parent::getModel("Subscribe") -> getListSubscriberByActive(1);

		//В том случае, если подписчики отсутствуют, рассылку не делаем
		if(!sizeof($SbAr))
		{
			return true;
		}
		//Получаем объявления
		$data = Request::getPost("data", "string", FALSE);
		if($data)
		{
			$time = Str::convertDateToTimestamp($data, ".", 0, 0, 0);
		}
		else
		{
			$time = time() - Str::DATE_DAY;
		}
		$AdAr = parent::getModel("Ad") -> getAdByDateLt($time);

		if(sizeof($AdAr) > 0)
		{
			//Первоначальная установка данных 
			$subject = Lng::_('Рассылка объявлений с сайта').' "'.$Config -> site -> title.'"';
		
			//Создаем тело письма со списка объявлений
			$Phtml = parent::getTemplate("mail.subscribe_last_ad");
			$Phtml -> site_host = $Config -> site -> host;
			$Phtml -> AdAr = $AdAr;
			//Получаем тело сообщения
			$body = $Phtml -> getView();
			
			foreach($SbAr as $Sb)
			{
				//Перед отправкой сообщений, делаем паузу на пол секунды
				sleep(0.2);
				
				//Подпись письма
				$signature = '
				<p>
					'.Lng::_('Чтобы отписаться от рассылки, перейдите по ссылке').
					' "'.Helper_HTML::anchor($Config -> site -> host.'/index.php?mod=board&go=unsubscribe&sb_id='.$Sb -> sb_id, Lng::_('отписаться от расслки')).'"
				</p>';
				
				if(Mail::sendMail(NULL, $Config -> emails -> noreply, NULL, $Sb -> sb_email, $subject, $body.$signature) == FALSE)
				{
					throw new Exception(Lng::_('Во время рассылки объявлений кроном, возникла ошибка'));
				}
			}
		}
		
		//Делаем запись в лог о работе крона
		File::write("./files/.logs/cron-mod_board-subscribe.log",Str::dateDTS()." \n",FILE_APPEND);
	}
	
	/**
	 * Крон удаляющий старые объявления 
	 *
	 */
	public function deleteAction()
	{
		//Получаем секретное слово сайта
		$secretWord = (string)Registry::get("Config") -> site -> secretWord;
		
		//Если запрос не "прошел", выходим
		if($secretWord != Request::getGet("secretWord")){return;}
		
		//Первоначальная утановка данных
		$ad_ar = array();
		
		//Получаем объявления, которые нужно удалить
		$AdAr = parent::getModel("Ad") -> getOldAd();
		
		//Удаляем фотографии объявлений
		foreach($AdAr as $Ad)
		{
			$ad_ar[] = $Ad -> ad_id;
			if($Ad -> ad_foto && is_file(Modules_Board_Controllers_Index::PATH_DIR_NORMAL.$Ad -> ad_foto))
			{
				Modules_Board_Models_Ad::deleteImg($Ad -> ad_foto);
			}	
		}
		if(sizeof($ad_ar))
		{
			//Удаляем старые объявления
			parent::getModel("Ad","Board") -> deleteAdByAdAr($ad_ar);
			//Удаляем рейтинг объявлений
			parent::getComponent("Rating",$this -> com_group_rating) -> getModel() -> deleteRatingByAr($ad_ar);
		}
		
		//Делаем запись в лог о работе крона
		File::write("./files/.logs/cron-mod_board-delad.log",Str::dateDTS()." \n",FILE_APPEND);
	}
}