<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, PayLiqPAY", для гостя
 */

class Modules_Board_Controllers_IndexPayLiqPAY extends Modules_Board_Controllers_Index
{
	/**
	 * Отображаем форму оплаты
	 *
	 */
	public function indexAction()
	{		
		//Первоначальная установка данных
		$ad_id 	= Request::getPost("ad_id","int");
		$type = parent::getLib() -> getPayTypeValidate(Request::getPost("type"));
		
		//Проверяем, если данные отсутствуют, значит отображаем что страницы нет 
		if(!$ad_id || !$type)
		{
			throw new Exception_440(Lng::_('Невозможно применить услугу к объявлению, которое отсутствует'));
		}
		
		//Получаем данные объявления
		$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
		//Проверяем существование объявления
		try
		{
			CheckData::existsDataObject($Ad);
		}
		catch (Exception $e)
		{
			throw new Exception_440(Lng::_('Невозможно применить услугу к объявлению, которое отсутствует'));
		}

		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		
		//Вызов и установка данных класса платежа
		$Pay = new Pays_LiqPAY_Pay();

		//Устанавливаем данные формы
		$Pay -> form_action = "index.php?mod=board.payLiqPAY&go=aj_confirm";
		//Устанавливаем дополнительные поля в форму
		$Pay -> FormItem -> type 	= $type;
		$Pay -> FormItem -> ad_id 	= $ad_id;
		//Устанавливаем дополнительные надписи на форму
		$Pay -> FormLabel -> amount -> label = Lng::_('К оплате:');
		$Pay -> FormLabel -> amount -> text  = "<b style=\"color:red\">".$ModConfig -> pay -> LiqPAY -> $type -> amount." ".$ModConfig -> pay -> LiqPAY -> currency."</b>";
		
		//Передаем данные в видв
		$this -> view -> page_title	= parent::getLib() -> getPayTypeService(Request::getPost("type"),'"'.$Ad -> ad_title.'"');
		$this -> view -> form 		= $Pay -> getForm();
	}

	
	/**
	 * Отображает скрытую форму с подтверждением платежа, и сразуже отправляет ее с помщью JavaScript на обработку LiqPAY
	 *
	 */
	public function aj_confirmAction()
	{
		CheckData::isAjax();
		
		try
		{
			//Первоначальная установка данных
			$type = parent::getLib() -> getPayTypeValidate(Request::getPost("type"));
			
			//Конфигурационные данные сайта
			$Config = Registry::get('Config');
			//Получаем конфигурационные данные модуля
			$ModConfig = parent::getModel("Settings") -> getConfig();
		
			//-TS->
			parent::getModel("Pays") -> transactionStart();
			
			//Вызов и установка данных класса платежа
			$Pay = new Pays_LiqPAY_Pay();
			
			//-- ПОДГОТОВКА ДАННЫХ
			//Номер телефона плательщика
			$sender_phone 	= $Pay -> preparePhone(Request::getPost("sender_phone"));
			$amount			= $ModConfig -> pay -> LiqPAY -> $type -> amount;
			
			//-- СОХРАНЯЕМ ДАННЫЕ ПЛАТЕЖА В БД --
			parent::getModel("Pays") -> insertPay($Pay -> code,(Lng::_('Платеж абонента ').$sender_phone),null,($amount." ".$ModConfig -> pay -> LiqPAY -> currency),$type,0,time(),0,Request::getPost("ad_id","int"));

			//Данные для ХМЛ файла
			$Pay -> OperationXml -> result_url 		= URL::site("index.php?mod=board.payLiqPAY&go=result");
			$Pay -> OperationXml -> server_url 		= URL::site("index.php?mod=board.payLiqPAY&go=server");
			$Pay -> OperationXml -> merchant_id 	= $ModConfig -> pay -> LiqPAY -> merchant_id;
			$Pay -> OperationXml -> order_id 		= parent::getModel("Pays") -> getLastPayId();
			$Pay -> OperationXml -> amount 			= $amount;
			$Pay -> OperationXml -> currency 		= $ModConfig -> pay -> LiqPAY -> currency;
			$Pay -> OperationXml -> description 	= parent::getLib() -> getPayTypeService($type);
			$Pay -> OperationXml -> default_phone 	= $sender_phone;
			$Pay -> OperationXml -> pay_way 		= Request::getPost("pay_way");
			
			//Данные подписи
			$Pay -> OperationXml -> signature = $ModConfig -> pay -> LiqPAY -> signature;
		
			//-- ОТПРАВЛЯЕМ ДАННЫЕ ОБРАТНО --
			//Формируем данные (кодируем)
			$Pay -> encodeFormFields();
			
			//-TC->
			parent::getModel("Pays")-> transactionCommit();
		}
		catch (Exception $e)
		{
			//-TR->
			parent::getModel("Pays")-> transactionRollback();
			
			Factory::answerAjax(array(
				"error" => Lng::_("Во время обработки платежа возникла ошибка.\nПовторите попытку или свяжитесь с администратором для устранения неполадок.\nВОЗМОЖНАЯ ОШИБКА:\n").$e -> getMessage()
			));
		}
		//Формируем форму
		Factory::answerAjax(array(
			"html"=>$Pay -> getConfirmForm()
		));
	}

	/**
	 * Server действие
	 *
	 */
	public function serverAction()
	{
		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		
		//Вызов и установка данных класса платежа
		$Pay = new Pays_LiqPAY_Pay();
			
		//Устанавливаем данные ХМЛ и проверочной подписи
		$Pay -> encode_operation_xml = Request::getPost("operation_xml");
		$Pay -> encode_signature 	 = Request::getPost("signature");
		//Данные подписи
		$Pay -> OperationXml -> signature = (string) $ModConfig -> pay -> LiqPAY -> signature;
		
		try
		{	
			//Проверяем достоверность полученных данных
			if(!$Pay -> checkSuccess())
			{
				//Записываем ошибку в БД
				parent::getModel("Pays")-> updatePay($Pay -> OperationXml -> XML -> order_id,$Pay -> decode_operation_xml,0,time());	
				exit;
			}
			//ID Покупки
			$order_id = (string) $Pay -> OperationXml -> XML -> order_id;			
			//Получаем статус данные платежа
			$py_status = $this -> _getStatus($Pay);
			//Проверяем статус платежа
			if($py_status == 2 || $py_status == 3)
			{
				parent::getModel("Pays") -> updatePay($order_id,$Pay -> decode_operation_xml,$py_status,time());
				exit;
			}

			//-TS->
			parent::getModel("Pays") -> transactionStart();

			//Получаем данные платежа. Нужно для того, чтобы определить какое объявление обновлять и определения статуса платежа
			$PayData = parent::getModel("Pays") -> getPayById($order_id);
			
			if(doubleval($PayData -> py_amount) != ((string) $Pay -> OperationXml -> XML -> amount))
			{
				//Записываем ошибку в БД
				parent::getModel("Pays") -> updatePay($order_id,serialize($Pay -> decode_operation_xml),0,time());	
				exit;				
			}
			
			//ОБНОВЛЯЕМ ДАННЫЕ ПЛАТЕЖА ТОЛЬКО В ТОМ СЛУЧАЕ, ЕСЛИ ОПЕРАЦИЯ БЫЛА НЕ ПРОВЕДЕНА
			if(!$PayData -> py_status)
			{
				//Обновляем данные платежа
				parent::getModel("Pays") -> updatePay($order_id,$Pay -> decode_operation_xml,$py_status,time());
				
				//Формируем данные для сохранения
				if($PayData -> py_operations == "vip")
				{
					$row_ar = array(
						"ad_vip_date" => (time() + ($ModConfig -> terms -> vip -> day * Str::DATE_DAY))
					);
				}
				else if($PayData -> py_operations == "style")
				{
					$row_ar = array(
						"ad_style_date" => (time() + ($ModConfig -> terms -> style -> day * Str::DATE_DAY)), 
						"ad_style" => mysql_real_escape_string((string)$ModConfig -> terms -> style -> style)
					);
				}
				else
				{
					$row_ar = array(
						"ad_topin_date" => (time() + ($ModConfig -> terms -> topin -> day * Str::DATE_DAY))
					);
				}
				//Отправляем почтовое уведомление администратору
				parent::getLib('mail') -> adminSendEmailAfterPay($PayData -> py_parent_id);
				//Обновляем данные объявления
				parent::getModel("Ad") -> updatePayRowById($PayData -> py_parent_id,$row_ar);
				//Удаляем кэш главной страницы
				CacheFile::instance() -> remove('Modules_Board_Libs_Catch::getTopinAdAr', Modules_Board_Controllers_Index::CATCH_GROUP);
			}
			//-TC->
			parent::getModel("Pays") -> transactionCommit();
		}
		catch (Exception $e)
		{
			try
			{
				if($order_id == TRUE)
				{
					//Записываем ошибку в БД
					parent::getModel("Pays") -> updatePay($order_id,$Pay -> decode_operation_xml,4,time());
				}
			}
			catch (Exception $e) { }
			//-TR->
			parent::getModel("Pays")-> transactionRollback();
		}
		exit;
	}
	
	/**
	 * Result действие
	 *
	 */	
	public function resultAction()
	{
		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		
		//Вызов и установка данных класса платежа
		$Pay = new Pays_LiqPAY_Pay();

		//Устанавливаем данные ХМЛ и проверочной подписи
		$Pay -> encode_operation_xml 	= Request::getPost("operation_xml");
		$Pay -> encode_signature 		= Request::getPost("signature");
		 
		//Данные подписи
		$Pay -> OperationXml -> signature = $ModConfig -> pay -> LiqPAY -> signature;

		//Декодируем данные платежа
		$Pay -> decodeFormFields();

		//Получаем данные платежа. Нужно для того, чтобы определить какое объявление оплатили
		$PayData = parent::getModel("Pays")-> getAdByPayId(((string)$Pay -> OperationXml -> XML -> order_id));
		
		//Проверяем достоверность полученных данных
		if($Pay -> checkSuccess())
		{
			switch ($Pay -> OperationXml -> XML -> status)
			{
				case "success":
					parent::setView("./modules/board/views/common/pay/success.phtml");
					$this -> view -> pay_title 	= $Pay -> name_short;
					$this -> view -> ad_title 	= $PayData -> ad_title;
					$this -> view -> cat_id 	= $PayData -> cat_id;
				break;
				case "wait_secure":
					parent::setView("./modules/board/views/common/pay/pending.phtml");
					$this -> view -> pay_title 	= $Pay -> name_short;
					$this -> view -> ad_title 	= $PayData -> ad_title;
					$this -> view -> site 		= $Pay -> site;
				break;
				default:
				case "failure":
					parent::setView("./modules/board/views/common/pay/failure.phtml");
					$this -> view -> pay_title 	= $Pay -> name_short;
					$this -> view -> site 		= $Pay -> site;
				break;
			}
		}
		else
		{
			parent::setView("./modules/board/views/index.payliqpay/failure.phtml");
			$this -> view -> pay_title 	= $Pay -> name_short;
			$this -> view -> site 		= $Pay -> site;
		}
	}
	
	
	/**
	 * Возвращает Номер статуса платежа
	 *
	 * @return int
	 */
	public function _getStatus($Pay = NULL)
	{
		switch ($Pay -> OperationXml -> XML -> status)
		{
			case "success":
				return  1;
			break;
			case "failure":
				return  3;
			break;
			default:
			case "wait_secure":
				return  2;
			break;
		}
	}
}