<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, PaySMSOnline", для гостя
 */

class Modules_Board_Controllers_IndexPaySMSOnline extends Modules_Board_Controllers_Index
{
	/**
	 * Отображаем форму оплаты
	 *
	 */
	public function indexAction()
	{		
		//Первоначальная установка данных
		$ad_id 	= Request::getPost("ad_id","int");
		$type 	= Request::getPost("type");
		
		//Проверяем, если данные отсутствуют, значит отображаем что страницы нет 
		if(!$ad_id || !$type)
		{
			throw new Exception_440(Lng::_('Невозможно применить услугу к объявлению, которое отсутствует'));
		}
		
		//Получаем данные объявления
		$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
		//Проверяем существование объявления
		try
		{
			CheckData::existsDataObject($Ad);
		}
		catch (Exception $e)
		{
			throw new Exception_440(Lng::_('Невозможно применить услугу к объявлению, которое отсутствует'));
		}
		
		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		
		$this -> view ->  prefix 		= $ModConfig -> pay -> SMSOnline -> $type -> prefix;
		$this -> view ->  ad_id 		= $ad_id;
		$this -> view ->  phone 		= $ModConfig -> pay -> SMSOnline -> $type -> phone;
		$this -> view ->  amount 		= $ModConfig -> pay -> SMSOnline -> $type -> amount;
		$this -> view ->  info_type 	= nl2br(trim($ModConfig -> pay -> SMSOnline -> $type -> info));
		$this -> view ->  info_operator = nl2br(trim($ModConfig -> pay -> SMSOnline -> info));
		$this -> view ->  Pay			= new Pays_SMSOnline_Pay();
		
		//Передаем данные в видв
		$this -> view -> page_title	= parent::getLib() -> getPayTypeService(Request::getPost("type"),'"'.$Ad -> ad_title.'"');
	}

	/**
	 * Server действие
	 *
	 */
	public function serverAction()
	{
		try
		{
			//Первоначальная установка данных
			$pref = Request::getRequest("pref");
			$ad_id = preg_replace("/\D*/i","",Request::getRequest("txt"));
			$phone =  Request::getRequest("phone");
			
			//Получаем конфигурационные данные модуля
			$ModConfig = parent::getModel("Settings") -> getConfig();
			
			//Вызов и установка данных класса платежа
			$Pay = new Pays_SMSOnline_Pay();

			//Определяем тип операции по префиксу
			$py_operations 	= $this -> _getOperationsByPrefix($pref);
			$py_amount = $ModConfig -> pay -> SMSOnline -> $py_operations -> amount;
			
			//Устанавливаем SMS данные в класс
			$Pay -> SmsData -> password = (string)$ModConfig -> pay -> SMSOnline -> password;
			$Pay -> SmsData -> tid = Request::getRequest("tid");
			$Pay -> SmsData -> sn = Request::getRequest("sn");
			$Pay -> SmsData -> op = Request::getRequest("op");
			$Pay -> SmsData -> phone = $phone;
			$Pay -> SmsData -> pref = $pref;
			$Pay -> SmsData -> txt = $ad_id;
			$Pay -> SmsData -> md5 = Request::getRequest("md5");
			
			try
			{
				if($ModConfig -> pay -> SMSOnline -> isPassword == 1)
				{
					//Проверяем достоверность полученных дандных
					//Проверка MD5 суммы
					if(!$Pay -> checkSuccess())
					{
						$_POST['_PAY_COOMENT'] = Lng::_('Не подтверждена MD5 сумма платежа');
						throw new Exception(Lng::_('Платеж не проведен, ошибка оператора связи'));
					}
				}
				
				//Проверяем существование объявления
				if(!parent::getModel("Ad") -> isExistsId($ad_id))
				{
					$_POST['_PAY_COOMENT'] = Lng::_('Объявление, к которому подключается услуга - отсутствует');
					throw new Exception($_POST['_PAY_COOMENT']);
				}				
			}
			catch (Exception $e)
			{
				parent::getModel("Pays") -> insertPay($Pay -> code,(Lng::_('Платеж абонента ').$phone),serialize(Request::get()),$py_amount,$py_operations,3,time(),time(),$ad_id);
				die("sms=".$e -> getMessage());
			}
			
			//-TS->
			parent::getModel("Pays") -> transactionStart();
			
			//Сохраняем данные платежа
			parent::getModel("Pays") -> insertPay($Pay -> code,(Lng::_('Платеж абонента ').$phone),serialize(Request::get()),$py_amount,$py_operations,1,time(),time(),$ad_id);
			
			//Формируем данные для сохранения
			if($py_operations == "vip")
			{
				$row_ar = array(
					"ad_vip_date" => (time() + ($ModConfig -> terms -> vip -> day * Str::DATE_DAY))
				);
			}
			else if($py_operations == "style")
			{
				$row_ar = array(
					"ad_style_date" => (time() + ($ModConfig -> terms -> style -> day * Str::DATE_DAY)), 
					"ad_style" => mysql_real_escape_string((string)$ModConfig -> terms -> style -> style)
				);
			}
			else
			{
				$row_ar = array(
					"ad_topin_date" => (time() + ($ModConfig -> terms -> topin -> day * Str::DATE_DAY)
				));
			}
			//Отправляем почтовое уведомление администратору
			parent::getLib('mail') -> adminSendEmailAfterPay($ad_id);
			//Обновляем данные объявления
			parent::getModel("Ad") -> updatePayRowById($ad_id, $row_ar);
			//Удаляем кэш главной страницы
			CacheFile::instance() -> remove('Modules_Board_Libs_Catch::getTopinAdAr', Modules_Board_Controllers_Index::CATCH_GROUP);

			//-TC->
			parent::getModel("Pays")-> transactionCommit();
		}
		catch (Exception $e)
		{
			//-TR->
			parent::getModel("Pays")-> transactionRollback();
			try
			{
				$_POST['_PAY_COOMENT'] = Lng::_('Критическая ошибка системы при обработке платежа.');
				//Записываем ошибку в БД
				parent::getModel("Pays") -> insertPay($Pay -> code,(Lng::_('Платеж абонента ').$phone),serialize(Request::get()),$py_amount,$py_operations,4,time(),time(),$ad_id);
			}
			catch (Exception $e){	}
			die("sms=".Lng::_('Ошибка платежа, свяжитесь с администратором сайта'));
		}
		die("sms=".Lng::_('Ваше объявление успешно обработано!'));
	}
	
	/**
	 * Возвращает тип операции по префиксу СМС
	 *
	 * @param string $type
	 */
	private function _getOperationsByPrefix($pref=null)
	{
		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		$SMSOnline = (array)$ModConfig -> pay -> SMSOnline;
		
		$py_operations = "vip";
		foreach($SMSOnline as $py_operations_ =>$Node)
		{
			if(isset($Node -> prefix) && $Node -> prefix == $pref)
			{
				$py_operations = $py_operations_;
			}
		}

		return $py_operations;
	}
}