<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, PayLiqPAY", для гостя
 */

class Modules_Board_Controllers_IndexPayWebMoney extends Modules_Board_Controllers_Index
{
	/**
	 * Отображаем форму оплаты
	 *
	 */
	public function indexAction()
	{		
		//Первоначальная установка данных
		$ad_id 	= Request::getPost("ad_id","int");
		$type 	= parent::getLib() -> getPayTypeValidate(Request::getPost("type"));
		
		//Проверяем, если данные отсутствуют, значит отображаем что страницы нет 
		if(!$ad_id || !$type)
		{
			throw new Exception_440(Lng::_('Невозможно применить услугу к объявлению, которое отсутствует'));
		}
		
		//Получаем данные объявления
		$Ad = parent::getModel("Ad") -> getAdById($ad_id);
		
		//Проверяем существование объявления
		try
		{
			CheckData::existsDataObject($Ad);
		}
		catch (Exception $e)
		{
			throw new Exception_440(Lng::_('Невозможно применить услугу к объявлению, которое отсутствует'));
		}

		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		
		//Вызов и установка данных класса платежа
		$Pay = new Pays_WebMoney_Pay();
		//Устанавливаем данные формы
		$Pay -> form_action = "index.php?mod=board.payWebMoney&go=aj_confirm";
		//Устанавливаем дополнительные поля в форму
		$Pay -> FormItem -> type 	= $type;
		$Pay -> FormItem -> ad_id 	= $ad_id;
		
		//Передаем данные в вид
		$this -> view -> ad_title	= $Ad -> ad_title;
		$this -> view -> page_title	= parent::getLib() -> getPayTypeService(Request::getPost("type"),'"'.$Ad -> ad_title.'"');
		$this -> view -> info_type	= $ModConfig -> pay -> WebMoney -> $type -> info;
		$this -> view -> form 		= $Pay -> getForm();
	}

	/**
	 * Отображает скрытую форму с подтверждением платежа, и сразуже отправляет ее с помщью JavaScript на обработку LiqPAY
	 *
	 */
	public function aj_confirmAction()
	{
		CheckData::isAjax();
		
		try
		{
			//Первоначальная установка данных
			$type = parent::getLib() -> getPayTypeValidate(Request::getPost("type"));
			
			//Получаем конфигурационные данные модуля
			$ModConfig = parent::getModel("Settings") -> getConfig();
		
			//-TS->
			parent::getModel("Pays") -> transactionStart();
			
			//Вызов и установка данных класса платежа
			$Pay = new Pays_WebMoney_Pay();
			
			//-- ПОДГОТОВКА ДАННЫХ
			//Сумма плательщика
			$amount = $ModConfig -> pay -> WebMoney -> $type -> amount;
			
			//-- СОХРАНЯЕМ ДАННЫЕ ПЛАТЕЖА В БД --
			parent::getModel("Pays") -> insertPay($Pay -> code, Lng::_('Платеж через систему WebMoney'), NULL, $amount, $type, 0, time(), 0, Request::getPost("ad_id","int"));
		
			$Pay -> lmi_secret_key = (string) $ModConfig -> pay -> WebMoney -> lmi_secret_key;
			
			//Остальные данные формы палатежа
			$Pay -> lmi_payee_purse 	= (string) $ModConfig -> pay -> WebMoney -> wallet;
			$Pay -> lmi_payment_amount 	= $amount;
			$Pay -> lmi_payment_no 		= parent::getModel("Pays") -> getLastPayId();
			$Pay -> lmi_payment_desc 	= parent::getLib() -> getPayTypeService($type);
			$Pay -> lmi_mode 			= (string) $ModConfig -> pay -> WebMoney -> isTesting;
			
			
			//-TC->
			parent::getModel("Pays")-> transactionCommit();
		}
		catch (Exception $e)
		{
			//-TR->
			parent::getModel("Pays")-> transactionRollback();
			
			Factory::answerAjax(array(
				"error" => "Во время обработки платежа возникла ошибка.\nПовторите попытку или свяжитесь с администратором для устранения неполадок.\nВОЗМОЖНАЯ ОШИБКА:\n".$e -> getMessage()
			));
		}
		//Формируем форму
		Factory::answerAjax(array(
			"html" => $Pay -> getConfirmForm()
		));
	}
	
	
	/**
	 * Обработка статуса платежа
	 *
	 */
	public function resultAction()
	{
		//Блокируем сохранение данных форма предварительного запроса
		if(isset($_REQUEST['LMI_PREREQUEST']) && $_REQUEST['LMI_PREREQUEST'] == 1)
		{
			die('YES');
		}
		try
		{
			//Получаем конфигурационные данные модуля
			$ModConfig = parent::getModel("Settings") -> getConfig();

			//Вызов и установка данных класса платежа
			$Pay = new Pays_WebMoney_Pay();
			//Подготавливаем переданные данные
			$Pay -> prepareResultData();
			//ID магазина и секретный ключ
			$Pay -> lmi_secret_key = (string) $ModConfig -> pay -> WebMoney -> lmi_secret_key;

			//В случае тестового платежа, никакие операции в дальнейшем не выполняем
			if($Pay -> lmi_mode === 1)
			{
				exit;
			}
			
			//Кошелек на который поступили средства не кошелек продавца
			if($Pay -> lmi_payee_purse != ((string) $ModConfig -> pay -> WebMoney -> wallet))
			{
				$_POST['_PAY_COOMENT'] = Lng::_('Попытка перечислить деньги не на кошелек продавца.');
				//Записываем ошибку в БД
				parent::getModel("Pays")-> updatePay($Pay -> lmi_payment_no,serialize($_POST),0,time());	
				exit;				
			}

			//Проверяем ХЭШ формы
			if($Pay -> checkSignHash() === FALSE)
			{
				$_POST['_PAY_COOMENT'] = Lng::_('Хэш сумма перевода не совпала.');
				//Записываем ошибку в БД
				parent::getModel("Pays")-> updatePay($Pay -> lmi_payment_no,serialize($_POST),0,time());	
				exit;
			}
			
			//-TS->
			parent::getModel("Pays") -> transactionStart();

			//Получаем данные платежа. Нужно для того, чтобы определить какое объявление обновлять и определения статуса платежа
			$PayData = parent::getModel("Pays") -> getPayById($Pay -> lmi_payment_no);
			if($PayData -> py_amount != $Pay -> lmi_payment_amount)
			{
				$_POST['_PAY_COOMENT'] = Lng::_('Сумма перевода не совпала с зафиксированной в БД (т.е. попытка перевода ложной суммы)');
				//Записываем ошибку в БД
				parent::getModel("Pays") -> updatePay($Pay -> lmi_payment_no,serialize($_POST),0,time());	
				exit;
			}
			
			//ОБНОВЛЯЕМ ДАННЫЕ ПЛАТЕЖА ТОЛЬКО В ТОМ СЛУЧАЕ, ЕСЛИ ОПЕРАЦИЯ БЫЛА НЕ ПРОВЕДЕНА
			if(!$PayData -> py_status)
			{
				//Обновляем данные платежа
				parent::getModel("Pays") -> updatePay($Pay -> lmi_payment_no,serialize($_POST),1,time());
				
				//Формируем данные для сохранения
				if($PayData -> py_operations == "vip")
				{
					$row_ar = array(
						"ad_vip_date" => (time() + ($ModConfig -> terms -> vip -> day * Str::DATE_DAY))
					);
				}
				else if($PayData -> py_operations == "style")
				{
					$row_ar = array(
						"ad_style_date" => (time() + ($ModConfig -> terms -> style -> day * Str::DATE_DAY)), 
						"ad_style" => mysql_real_escape_string((string)$ModConfig -> terms -> style -> style)
					);
				}
				else
				{
					$row_ar = array(
						"ad_topin_date" => (time() + ($ModConfig -> terms -> topin -> day * Str::DATE_DAY))
					);
				}
				//Отправляем почтовое уведомление администратору
				parent::getLib('mail') -> adminSendEmailAfterPay($PayData -> py_parent_id);
				//Обновляем данные объявления
				parent::getModel("Ad") -> updatePayRowById($PayData -> py_parent_id,$row_ar);
				//Удаляем кэш главной страницы
				CacheFile::instance() -> remove('Modules_Board_Libs_Catch::getTopinAdAr', Modules_Board_Controllers_Index::CATCH_GROUP);
			}
			
			//-TC->
			parent::getModel("Pays")-> transactionCommit();
			
		}
		catch (Exception $e)
		{
			try
			{
				$_POST['_PAY_COOMENT'] = Lng::_('Критическая ошибка системы при обработке платежа.');
				//Записываем ошибку в БД
				parent::getModel("Pays") -> updatePay($Pay -> lmi_payment_no,serialize($_POST),4,time());
			}
			catch (Exception $e) { }
			//-TR->
			parent::getModel("Pays")-> transactionRollback();
		}
		exit;
	}

	/**
	 * Платеж принят
	 *
	 */
	public function successAction()
	{
		//Получаем конфигурационные данные модуля
		$ModConfig = parent::getModel("Settings") -> getConfig();
		
		//Вызов и установка данных класса платежа
		$Pay = new Pays_WebMoney_Pay();

		//Получаем данные платежа. Нужно для того, чтобы определить какое объявление оплатили
		$PayData = parent::getModel("Pays") -> getAdByPayId(Request::getPost('LMI_PAYMENT_NO','int'));

		parent::setView("./modules/board/views/common/pay/success.phtml");
		$this -> view -> pay_title 	= $Pay -> name_short;
		$this -> view -> site 		= $Pay -> site;
		$this -> view -> cat_id 	= $PayData -> cat_id;
	}
	
	/**
	 * Платеж не принят
	 *
	 */
	public function failAction()
	{
		//Вызов и установка данных класса платежа
		$Pay = new Pays_WebMoney_Pay();
			
		parent::setView("./modules/board/views/common/pay/failure.phtml");
		$this -> view -> site = $Pay -> site;
		$this -> view -> pay_title = $Pay -> name_short;
	}
}