<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений, Subscribe", для гостя
 */

class Modules_Board_Controllers_IndexSubscribe extends Modules_Board_Controllers_Index
{
	/**
	 * Подтверждаем подписку
	 *
	 */
	public function subscribeAction()
	{
		$this -> view -> is_sb_active = 1;
		try
		{
			//Получаем данные подписки
			$SbData = parent::getModel("Subscribe") -> getSubscribeById($_GET['sb_id']);
			
			CheckData::existsDataObject($SbData);
			
			//Активируем подписку
			parent::getModel("Subscribe") -> updateSbActiveById($_GET['sb_id'],1);
		}
		catch(Exception_CheckData $e)
		{
			$this -> view ->  is_sb_active = 2;	
		}
		catch(Exception $e)
		{
			$this -> view ->  is_sb_active = 0;	
		}
		$this -> view -> Sb = $SbData;
	}
	
	/**
	 * Отписываемся от подписки
	 *
	 */
	public function unsubscribeAction()
	{
		$this -> view ->  is_sb_active = 1;
		try
		{
			//Получаем данные подписки
			$SbData = parent::getModel("Subscribe") -> getSubscribeById($_GET['sb_id']);
			try
			{
				CheckData::existsDataObject($SbData);
			}
			catch (Exception $e)
			{
				$this -> view -> is_sb_active = 2;		
			}
			//Активируем подписку
			parent::getModel("Subscribe") -> deteteSubscribeById($_GET['sb_id']);
		}
		catch(Exception $e)
		{
			$this -> view -> is_sb_active = 0;	
		}
		$this -> view -> Sb = $SbData;		
	}
	
	/********************************************************************************************************************/
	/************************************************** AJAX METHODS ****************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Подписываемся на почтовую рассылку
	 *
	 */
	public function aj_subscribeAction()
	{
		CheckData::isAjax();
		
		//Установка данных
		$mail = Request::getPost("email");
		
		//Проверяем корректность введенного почтового ящика
		try
		{
			CheckData::email($mail);
		}
		catch ( Exception $e)
		{
			Factory::answerAjax(array(
				'error' => '<span class="important">'.Lng::_('E-mail введен в не правильном формате').'</span>'
			));
		}

		try
		{
			//Проверяем, есть ли e-mail в БД
			if(parent::getModel("Subscribe") -> isExistsEmail($mail))
			{
				Factory::answerAjax(array(
					'error' => '<span class="important">'.Lng::_('Вы уже подписаны на рассылку').'</span>'
				));
			}
			//Подписываемся на рассылку
			parent::getModel("Subscribe") -> addSubscribe($mail,0);
			//Получаем id только что созданной подписки
			$last_sb_id = parent::getModel("Subscribe") -> getLastIdSubscribe();
		}
		catch (Exception $e)
		{
			Factory::answerAjax(array(
				'error' => '<span class="important">'.Lng::_('Ошибка БД').'</span>'
			));
		}
		//Отправляем пользователю письмо
		$is_send = parent::getLib("Mail") -> subscribeUser(parent::getTemplate("mail.subscribe.add_in_db"),$last_sb_id,$mail);
		//Если письмо не отправили, отображаем ошибку
		if(!$is_send)
		{
			Factory::answerAjax(array(
				'error' => '<span class="important">'.Lng::_('Не удалось отправить письмо с подтверждением о подписке. Свяжитесь с администратором, для подтверждения подписки').'</span>'
			));
		}
		Factory::answerAjax(array(
			'message' => Lng::_('Для активации рассылки, на указанный вами почтовый ящик выслано письмо')
		));
	}
}