<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Доска объявлений", для формирования sitemap.xml файла
 */

class Modules_Board_Controllers_Sitemap extends Guard_Base
{
	/**
	 * Возвращает элементы для формирования sitemap.xml файла
	 *
	 * @return array
	 */
	public function getElements()
	{
		return array("index" 	=> array("changefreq" => "daily", "priority" => "0.9", "lastmod" => date("Y-m-d")),//Главная страница модуля
					"select" 	=> array("changefreq" => "daily", "priority" => "0.6", "lastmod" => date("Y-m-d")),//Страница выбора рубрик для подачи объявлений
					"rule" 		=> array("changefreq" => "daily", "priority" => "0.5", "lastmod" => ""),//Страница с правилами объявлений
					"cat" 		=> array("changefreq" => "daily", "priority" => "0.7", "lastmod" => ""),//Просмотр рубрики с объявлениями внутри
					"ad" 		=> array("changefreq" => "daily", "priority" => "0.8", "lastmod" => ""),//Просмотр объявления
					"news" 		=> array("changefreq" => "daily", "priority" => "0.8", "lastmod" => ""));//Просмотр объявления
	}
	
	/**
	 * Формирует часть sitemap.xml файла
	 *
	 * @param array $data_ar данные
	 */
	public function formedSitemapFile($data_ar=array())
	{
		$host = URL::getHost()."/";
		
		$c  = "";
		$c .= Sitemap::formedUrlBlock($host.URL::trans(""),$data_ar['index']['lastmod'],$data_ar['index']['changefreq'],$data_ar['index']['priority']);
		/*$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=board&go=select"),$data_ar['select']['lastmod'],$data_ar['select']['changefreq'],$data_ar['select']['priority']);*/
		$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=board&go=rule"),$data_ar['rule']['lastmod'],$data_ar['rule']['changefreq'],$data_ar['rule']['priority']);
		
		//Получаем данные рубрик
		$CatAr = parent::getModel("Category","Board") -> getCategory();
		foreach($CatAr as $Cat)
		{
			$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=board&go=cat&cat_id=".$Cat -> cat_id,$Cat -> cat_title),$data_ar['cat']['lastmod'],$data_ar['cat']['changefreq'],$data_ar['cat']['priority']);
		}
		
		//Получаем данные объявлений
		$AdAr = parent::getModel("Ad","Board") -> getTitleAd();
		foreach($AdAr as $Ad)
		{
			$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=board&go=ad&ad_id=".$Ad -> ad_id,$Ad -> ad_title),date("Y-m-d",$Ad -> ad_date),$data_ar['ad']['changefreq'],$data_ar['ad']['priority']);
		}
		
		$NewsAr = parent::getModel("News", "News") -> getArticlesIndexList();
		foreach($NewsAr as $News)
		{
			$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=news&go=article&nw_id=".$News -> nw_id,$News -> nw_title),date("Y-m-d",$News -> nw_date_create),$data_ar['news']['changefreq'],$data_ar['news']['priority']);
		}
		
		return $c;
	}
}