<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Библиотека "Catch" модуля "Board"
 */

class Modules_Board_Libs_Catch
{
	//Инстанс метод блять!
	public static function instance()
	{
		static $Instance;
 
		if(!is_object($Instance))
    {
        $Instance = new self;
    }
		return $Instance;
	}
	/**
	 * Возвращает данные всех категорий
	 *
	 * @return array
	 */
	public function getCatAr()
	{
		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		$c_key_ar = __METHOD__;
		$cat_ar = $Cache -> get($c_key_ar, Str::DATE_WEEK, Modules_Board_Controllers_Index::CATCH_GROUP);
		//Получаем данные с кэша
		if($cat_ar == false)
		{
			//Получаем данные всех категорий и формируем с них дерево
			$cat_ar = Modules_Board_Models_Category::instance() -> prepCategory("getCategory");
			$Cache -> set($cat_ar, $c_key_ar, Modules_Board_Controllers_Index::CATCH_GROUP);
		}
		return $cat_ar;
	}
	
	/**
	 * Возвращает количество объявлений в категориях
	 *
	 * @return array
	 */
	public function getCountAdInCategory()
	{
		//Получаем данные кэширования
		$Cache = CacheFile::instance();
		$c_key_ar = __METHOD__;
		$cat_ad_ar = $Cache -> get($c_key_ar, Str::DATE_WEEK, Modules_Board_Controllers_Index::CATCH_GROUP);
		//Получаем данные с кэша
		if($cat_ad_ar == false)
		{
			//Получаем количество объявлений в категориях
			$cat_ad_ar = Modules_Board_Models_Category::instance() -> getCountAdInCategory();
			$Cache -> set($cat_ad_ar, $c_key_ar, Modules_Board_Controllers_Index::CATCH_GROUP);
		}
		return $cat_ad_ar;		
	}
	
	/**
	 * Возвращает объявления которые размещаются в topin блоке 
	 *
	 * @return array
	 */
	public function getTopinAdAr()
	{
		//Получаем настройки сайта
		$Config = Modules_Board_Models_Settings::instance() -> getConfig();
		
		if($Config -> terms -> topin -> isCache == '1')
		{
			//Получаем данные кэширования
			$Cache = CacheFile::instance();
			$c_key_ar = __METHOD__;
			$ad_ar = $Cache -> get($c_key_ar, Str::DATE_DAY, Modules_Board_Controllers_Index::CATCH_GROUP);
			//Получаем данные с кэша
			if($ad_ar === FALSE)
			{
				//Получаем количество объявлений в категориях
				$ad_ar = Modules_Board_Models_Ad::instance() -> getTrueTopinAd();
				$Cache -> set($ad_ar, $c_key_ar, Modules_Board_Controllers_Index::CATCH_GROUP);
			}
		}
		else
		{
			//Получаем количество объявлений в категориях
			$ad_ar = Modules_Board_Models_Ad::instance() -> getTrueTopinAd();
		}
		return $ad_ar;		
	}
}