<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Библиотека "General" модуля "Board"
 */

class Modules_Board_Libs_General
{
	//Инстанс метод блять!
	public static function instance()
	{
		static $Instance;
 
		if(!is_object($Instance))
    {
        $Instance = new self;
    }
		return $Instance;
	}	
	/**
	 * Проверяет данные объявления
	 *
	 * @param object $ModelCat модель данных рубрик
	 * @param array $cnf_ar массив настроек проверки
	 */
	public function checkAdData($ModelCat = NULL, $cnf_ar = array())
	{
		//Проверяем длину ИМЕНИ
		if(!$_POST['ad_name'] || Str::strlen($_POST['ad_name']) <= 1)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Длина "имени" не может быть меньше двух символов'));
		}
		//Проверяем правильность формата EMAIL
		try
		{
			CheckData::email($_POST['ad_email']);
		}
		catch (Exception_CheckData $e)
		{
			throw new Exception_CheckData(Lng::_('FALSE:E-mail введен в не правильном формате'));
		}
		//Проверяем длину ЗАГОЛОВОКА ОБЪЯВЛЕНИЯ
		if(!$_POST['ad_title'] || Str::strlen($_POST['ad_title']) <= 2)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Длина заголовока объявления не может быть меньше трех символов'));
		}
		//Проверяем длину ОБЪЯВЛЕНИЯ
		if(!$_POST['ad_text'] || Str::strlen($_POST['ad_text']) <= 9)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Длина описания должна быть больше десяти символов'));
		}
		//Проверяем РУБРИКУ
		if($_POST['cat_id'] == 0)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Выберете рубрику для объявления'));
		}
		else
		{
			if(!$ModelCat -> isExistsCategory($_POST['cat_id']))
			{
				throw new Exception_CheckData(Lng::_('FALSE:Выбранная Вами рубрика отсутствует'));
			}
		}
		
		//Проверяем СРОК ХРАНЕНИЯ
		if($_POST['ad_keep'] == 0)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Выберете срок хранения объявления'));
		}
	
		//Если User пользователь или гость
		if(User::isUser() || User::isGuest())
		{
			//Проверяем РЕГИОН
			//if(!isset($_POST['rule']))
			//{
			//	throw new Exception_CheckData(Lng::_('FALSE:Для публикации объявления на сайте, нужно согласиться с условиями публикации'));
			//}
			//Проверяем правильность КАПЧИ
			//if($cnf_ar['check_captcha'] == TRUE)
			//{
			//	if(CheckData::captcha($_POST['check_access']) == FALSE)
			//	{
			//		throw new Exception_CheckData(Lng::_('FALSE:Не правильно введен защитный код'));
			//	}
			//}
		}
	}
	
	/**
	 * Выполняет валидацию одной загружаемой фотографии
	 *
	 * @param array $file_ar масссив с загружаемыми файлами
	 * @param string $file_name новое имя для файла
	 * @return array
	 */
	public function validateFoto($file_ar = array(), $file_name = NULL)
	{
		//Выполняем валидацию данных
		$Validate = new UploadFile($file_ar);
		$Validate -> setFileName($file_name);
		$Validate -> setFileExtensions(Modules_Board_Controllers_Index::$upload_extensions_ar);
		$Validate -> setFileByte(0,Modules_Board_Controllers_Index::UPLOAD_MAX_SIZE);
		$Validate -> setFilePx(5000,5000);
		return $Validate -> validate();
	}
	
	/**
	 * Выполняем валидацию загружаемым фотографиям объявления
	 *
	 * @return array массив имен доп файлов.
	 */
	public function validateFotos()
	{
		$ad_fotos_ar = array();
		
		if(isset($_FILES['ad_foto']) && $_FILES['ad_foto']['size'])
		{
			try
			{
				$this -> validateFoto($_FILES['ad_foto'], 'noname.');
			}
			catch (Exception $e)
			{
				throw new Exception_CheckData(Lng::_('FALSE:Вы загружаете неверный тип файла'));
			}
		}
		
		if(isset($_FILES['ad_fotos']))
		{
			//Переформировываем массив с доп. файлами
			$_FILES['ad_fotos'] = UploadFile::prepareArrayFiles($_FILES['ad_fotos']);
			try
			{
				foreach ($_FILES['ad_fotos'] as $file_id => $file_ar)
				{
					if($file_ar['size'] > 0)
					{
						//Формируем имя файла
						//Выполняем валидацию данных
						$ad_fotos_ar[$file_id] = $this -> validateFoto($file_ar, uniqid(Str::randomText(3, 'string', 'int')).'.');
					}
				}
			}
			catch (Exception $e)
			{
				throw new Exception_CheckData(Lng::_('FALSE:Вы загружаете неверный тип файла'));
			}
		}

		return $ad_fotos_ar;
	}
	
	/**
	 * Загружаем и сохраняем фото
	 *
	 * @param object $Model модель данных
	 * @param string $ad_id название файла
	 * @param string $img_date_dir каталог дат
	 */
	public function uploadAndSaveMainFoto($Model = NULL, $ad_id = null, $img_date_dir = NULL)
	{
		//Загружаем файл
		$file_name = uniqid(Str::randomText(3, 'string', 'int')).'.'.Request::getExtensionFileUpload('ad_foto');
		
		//Загружаем файл на сервер
		Helper_Upload::save($_FILES['ad_foto'], $file_name, Modules_Board_Controllers_Index::PATH_DIR_NORMAL.$img_date_dir, 0777);
		
		//Выполняем ресайз изображения
		$this -> _resizeImg($img_date_dir.$file_name);

		//Обновляем данные объявления, добавляем значения фотографии
		$Model -> updateAdFotoById($ad_id, $img_date_dir.$file_name);
	}
	
	/**
	 * Загружаем и сохраняем дополнительные фоографии объявления
	 *
	 * @param int $ad_id ID объявления, для которого загружается фотография
	 * @param array $ad_fotos_ar массив названий фотографий
	 * @param string $img_date_dir путь из каталого дат
	 * @param int $allow_uploads количество загрузок, которое разрешено выполнять
	 */
	public function uploadAndSaveAddFoto($ad_id = 0, $ad_fotos_ar = null, $img_date_dir = NULL, $allow_uploads = 3)
	{
		$i = 1;
		$Model = Models_Images::instance();
		
		foreach ($ad_fotos_ar as $file_id => $file_name)
		{
			if(isset($_FILES['ad_fotos'][$file_id]) && $i <= $allow_uploads)
			{
				//Загружаем файл
				Helper_Upload::save($_FILES['ad_fotos'][$file_id], $file_name, Modules_Board_Controllers_Index::PATH_DIR_NORMAL.$img_date_dir, 0777);
				
				//Формируем путь к загруженному изображению
				$path_to_foto = Modules_Board_Controllers_Index::PATH_DIR_NORMAL.$img_date_dir.$file_name;
				
				//Выполняем ресайз изображения
				$this -> _resizeImg($img_date_dir.$file_name);
		    	
				//Сохраняем фото в БД
				$Model -> addImage($ad_id, $img_date_dir.$file_name, ($i++), Modules_Board_Controllers_Index::GROUP_IMG);
			}
		}
	}
	
	/**
	 * Создает каталог для изображений объявления (т.е. структуру каталого вида YYYY-MM/DD/)
	 *
	 * @param string $path_th_dir путь к базовому каталогу, где должны хранится объявления
	 * @return sting название каталога и подкаталога
	 */
	public function createImgPath($path_th_dir = NULL)
	{
		$Y_m = date('Y-m');
		$d = date('d');
		
		//Для фотографий нормального размера
		if(is_dir($path_th_dir.$Y_m.'/') == FALSE)
		{
			mkdir($path_th_dir.$Y_m.'/', 0777);
		}
		if(is_dir($path_th_dir.$Y_m.'/'.$d.'/') == FALSE)
		{
			mkdir($path_th_dir.$Y_m.'/'.$d.'/', 0777);
		}
		
		//Для thumb фотографий
		if(is_dir($path_th_dir.'thumb/'.$Y_m.'/') == FALSE)
		{
			mkdir($path_th_dir.'thumb/'.$Y_m.'/', 0777);
		}
		if(is_dir($path_th_dir.'thumb/'.$Y_m.'/'.$d.'/') == FALSE)
		{
			mkdir($path_th_dir.'thumb/'.$Y_m.'/'.$d.'/', 0777);
		}
		
		return $Y_m.'/'.$d.'/';
	}
	
	/**
	 * Подсчитывает количество объявлений в дочерних категориях
	 *
	 * @param array $cat_ar массив категорий 
	 * @param int $start_cat_id id категории с которой начинается подсчет
	 * @param array &$new_cat_ar новый массив, с учетом всех подсчетов
	 * @return int
	 */
	public function getCountAdInCat($cat_ar=array(),$start_cat_id=0,&$new_cat_ar=array())
	{
		$child_count = 0;
		if(isset($cat_ar[$start_cat_id]))
		{
			foreach($cat_ar[$start_cat_id] as $count_ad)
			{
				$child_count += $count_ad;
			}
			
			foreach($cat_ar[$start_cat_id] as $cat_id => $count_ad)
			{
				if(isset($cat_ar[$cat_id]))
				{
					$new_cat_ar[$start_cat_id][$cat_id] = $count_ad + $this -> getCountAdInCat($cat_ar,$cat_id,$new_cat_ar);
					
					$child_count += $new_cat_ar[$start_cat_id][$cat_id] - $count_ad;
				}
				else
				{
					$new_cat_ar[$start_cat_id][$cat_id] = $count_ad;
				}
			}
		}
		return $child_count;
	}
	
	/**
	 * Переформировывает массив деверва категорий в одномерный массив
	 *
	 * @param array $cat_ar
	 * @return array
	 */
	public function prepareCatData($cat_ar=array())
	{
		$new_cat_ar = array();
		
		foreach($cat_ar as $parent_id => $val_ar)
		{
			foreach($val_ar as $cat_id => $cat_title)
			{
				$new_cat_ar[$cat_id] = $cat_id;
			}
		}
		return $new_cat_ar;
	}
	
	/**
	 * Возвращает path way категорий
	 *
	 * @param array $cat_ar
	 * @param int $cat_id
	 * @return array
	 */
	public static function getPathWay($cat_ar=array(),$cat_id=0)
	{
		$path_way = "";
		//Формируем path way
		$path_way = Category::getPathWayStr($cat_ar,$cat_id,"index.php?mod=board&go=cat&cat_id=", array('itemprop' => 'url'));
		if($path_way)
		{
			return substr($path_way,0,-9);
		}
		return $path_way;
	}
	
	/**
	 * Возвращает path way БЛЯТЬ СУКА ЗАРАБОТАЙ ДЛЯ СПИСКА ОБЪЯВЛЕНИЙ
	 *
	 * @param array $cat_ar
	 * @param int $cat_id
	 * @return array
	 */
	public static function getPathWayHyi($cat_ar=array(),$cat_id=0)
	{
		$path_way = "";
		//Формируем path way
		$path_way = Category::getPathWayPiz($cat_ar,$cat_id,"index.php?mod=board&go=cat&cat_id=");
		if($path_way)
		{
			return substr($path_way,0,-9);
		}
		return $path_way;
	}
	
	/**
	 * Возвращает path way категорий с последней выделенной категорией
	 *
	 * @param array $cat_ar
	 * @param int $cat_id
	 * @return array
	 */
	public function getPathWayLastBold($cat_ar=array(),$cat_id=0)
	{
		//Формируем path way
		$pathway_ar = array_reverse(Category::getPathWayAr($cat_ar,$cat_id));
		
		$last_cat_index = (sizeof($pathway_ar)-1);
		$last_cat_title = $pathway_ar[$last_cat_index];

		unset($pathway_ar[$last_cat_index]);
		$pathway = join(" &raquo; ",$pathway_ar)." &raquo; <b>".$last_cat_title."</b>"; 
		
		return $pathway;
	}
	
	/**
	 * По названию объявления определяет похожие
	 *
	 * @param string $ad_title заголовок текущего объявления
	 * @param array $AdAr
	 * @return array
	 */
	public function getSimilarAd($ad_title=null,$AdAr=array())
	{
		//Массив элементов, которые нужно заменить
		$replace_ar = array(","=>" ","."=>" ","если"=>" ",);
		$NewAdAr = array();
		
		//Массив заголовка текущего объявления
		$ad_title_ar = explode(" ",strtr($ad_title,$replace_ar));
		
		foreach ($AdAr as $Ad)
		{
			$ad_simil_ar = explode(" ",strtr($Ad -> ad_title,$replace_ar));
			if(sizeof($ad_simil_ar))
			{
				foreach ($ad_simil_ar as $word)
				{
					if(Str::strlen($word) > 3 && in_array($word,$ad_title_ar))
					{
						$NewAdAr[$Ad -> ad_id] = $Ad;
					}
				}
			}
		}
		return $NewAdAr;
	}
	
	/**
	 * Обновляет количество просмотров объявления
	 *
	 * @param object $DBAd объект класс БД объявлений
	 * @param int $ad_id id объявления
	 */
	public function setCountShows($DBAd=null,$ad_id=0)
	{
		if(!isset($_COOKIE['modBoard_cshows'][$ad_id]))
		{
			@setcookie("modBoard_cshows[".$ad_id."]",$ad_id,time()+32140800);
			$DBAd -> incrementCountShowsById($ad_id);
		}
	}
	
	/**
	 * Возвращает тип услуги
	 *
	 * @param string $type
	 * @param string $title
	 * @return string
	 */
	public function getPayTypeService($type = "vip", $title = NULL)
	{
		if($type == 'vip')
		{ 
			$t = Lng::_('Сделать объявление ').'{title}'.Lng::_(' премиум');
		}
		else if($type == 'style')
		{ 
			$t = Lng::_('Выделить объявлние').' {title}';
		}
		else
		{
			$t = Lng::_('Публикация объявления {title} на главной странице');
		}
		
		return trim(str_replace('{title}',$title,$t));
	}
	
	/**
	 * Выполняет простую валидацию данных типа услуги
	 *
	 * @param string $type
	 * @return string
	 */
	public function getPayTypeValidate($type = 'vip')
	{
		if($type == 'vip')
		{ 
			return 'vip';
		}
		else if($type == 'style')
		{ 
			return 'style';
		}
		return 'topin';
	}
	
	/********************************************************************************************************************/
	/************************************************* PRIVATE METHODS **************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Выполняет ресайз изображения
	 *
	 * @param string $path_to_img путь к изображению
	 */
	private function _resizeImg($path_to_img = NULL)
	{
		//Формируем путь к загруженному изображению
		$path_to_foto = Modules_Board_Controllers_Index::PATH_DIR_NORMAL.$path_to_img;
		
		//Уменьшаем изображение
    	$Image = Helper_Image::factory($path_to_foto);
	   	if($Image -> width > Modules_Board_Controllers_Index::IMG_MAX_RESIZE)
    	{
    		$Image -> resize(Modules_Board_Controllers_Index::IMG_MAX_RESIZE);
    	}
    	//Если путь прописан, налаживаем ватермарк
    	if(Modules_Board_Controllers_Index::PATH_TO_WATERMARK == TRUE)
    	{
    		$Image -> watermark(Helper_Image::factory(Modules_Board_Controllers_Index::PATH_TO_WATERMARK), TRUE, TRUE, 65);
    	}
    	$Image -> save($path_to_foto);
		
		//Уменьшаем изображение
    	$Image = Helper_Image::factory($path_to_foto);
	   	if($Image -> width > Modules_Board_Controllers_Index::IMG_MIN_RESIZE)
    	{
    		$Image -> resize(Modules_Board_Controllers_Index::IMG_MIN_RESIZE);
    	}
    	$Image -> save(Modules_Board_Controllers_Index::PATH_DIR_THUMB.$path_to_img);
	}
}