<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Библиотека "Mail" модуля "Board"
 */

class Modules_Board_Libs_Mail
{
	/**
	 * Отправляет почтовое сообщение Пользователю после ДОБАВЛЕНИЕ им ОБЪЯВЛЕНИЯ
	 *
	 * @param object $Phtml
	 * @param string $ad_name
	 * @param string $ad_email
	 * @param string $ad_code
	 */
	public function userAddAd($Phtml = NULL, $ad_name = NULL, $ad_email = NULL, $ad_title = NULL, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");
		
		$subject = Lng::_('Объявление успешно добавлено и ожидает проверки');
		
		$Phtml -> ad_name 		= $ad_name;
		$Phtml -> ad_title 	    = $ad_title;
		$Phtml -> site_title 	= $Config -> site -> title;
		$Phtml -> site_host 	= $Config -> site -> host;
		$Phtml -> ad_code 		= $ad_code;
		$Phtml -> is_link_check = (int)Modules_Board_Models_Settings::instance() -> getConfig() -> general -> isCheckAddAdByEmail;
		
		if(Mail::sendMail(NULL,$Config -> emails -> noreply, $ad_name, $ad_email, $subject, $Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Ваше объявление добавлено, но на Ваш почтовый адрес не удалось отправить почтовое сообщение'));
		}
	}
	
	/**
	 * Отправляем письмо пользователю о том, что админ удалил его объявление
	 *
	 * @param object $Phtml
	 * @param string $ad_name
	 * @param string $ad_email
	 * @param string $ad_code
	 */
	public function adminDeleteAd($Phtml = NULL, $ad_name = NULL, $ad_email = NULL, $ad_title = NULL, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");
		
		$subject = Lng::_('Объявление удалено (нарушение правил)');
		
		$Phtml -> ad_name 		= $ad_name;
		$Phtml -> ad_title 	    = $ad_title;
		$Phtml -> site  	    = $Config -> site -> url;
		$Phtml -> site_title 	= $Config -> site -> title;
		$Phtml -> site_host 	= $Config -> site -> host;
		$Phtml -> ad_code 		= $ad_code;
		$Phtml -> is_link_check = (int)Modules_Board_Models_Settings::instance() -> getConfig() -> general -> isCheckAddAdByEmail;
		
		if(Mail::sendMail(NULL,$Config -> emails -> noreply, $ad_name, $ad_email, $subject, $Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Не удалось уведомить пользователя об удалении объявления.'));
		}
	}

	/**
	 * Отправляем письмо пользователю о том, что админ ОТКЛОНИЛ его объявление
	 *
	 * @param object $Phtml
	 * @param string $ad_name
	 * @param string $ad_email
	 * @param string $ad_code
	 */
	public function adminWarnsAd($Phtml = NULL, $ad_name = NULL, $ad_email = NULL, $ad_title = NULL, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");

		$subject = Lng::_('Объявление ОТКЛОНЕНО (отредактируйте)');

		$Phtml -> ad_name 		= $ad_name;
		$Phtml -> ad_title 	    = $ad_title;
		$Phtml -> site  	    = $Config -> site -> url;
		$Phtml -> site_title 	= $Config -> site -> title;
		$Phtml -> site_host 	= $Config -> site -> host;
		$Phtml -> ad_code 		= $ad_code;
		$Phtml -> is_link_check = (int)Modules_Board_Models_Settings::instance() -> getConfig() -> general -> isCheckAddAdByEmail;

		if(Mail::sendMail(NULL,$Config -> emails -> noreply, $ad_name, $ad_email, $subject, $Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Не удалось уведомить пользователя об отклонении объявления.'));
		}
	}
	
	/**
	 * Отправляем письмо пользователю о том, что ОБЪЯВЛЕНИЕ ОДОБРЕНО
	 *
	 * @param object $Phtml
	 * @param string $ad_name
	 * @param string $ad_email
	 * @param string $ad_code
	 */
	public function adminPublicateAd($Phtml = NULL, $ad_name = NULL, $ad_email = NULL, $ad_title = NULL, $ad_id = 0, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");
		
		$subject = Lng::_('Объявление одобрено');
			
		$Phtml -> ad_name 		= $ad_name;
		$Phtml -> ad_id         = $ad_id = Request::getGet("ad_id","int",0);
		$Phtml -> ad_title 	    = $ad_title;
		$Phtml -> site_title 	= $Config -> site -> title;
		$Phtml -> site_host 	= $Config -> site -> host;
		$Phtml -> ad_code 		= $ad_code;
		$Phtml -> is_link_check = (int)Modules_Board_Models_Settings::instance() -> getConfig() -> general -> isCheckAddAdByEmail;
		
		if(Mail::sendMail(NULL,$Config -> emails -> noreply, $ad_name, $ad_email, $subject, $Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Не удалось уведомить пользователя об добрении объявления.'));
		}
	}
	
	/**
	 * Отправляет почтовое сообщение Пользователю после ДОБАВЛЕНИЕ им ОБЪЯВЛЕНИЯ и РЕГИСТРАЦИИ
	 *
	 * @param object $Phtml
	 * @param string $ad_name
	 * @param string $ad_password
	 * @param string $ad_email
	 * @param string $ad_code
	 */
	public function userAddAdRegistr($Phtml = NULL, $ad_name = NULL, $ad_password = NULL, $ad_email = NULL, $ad_title = NULL, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");
		
		$subject = Lng::_('Объявление успешно добавлено и ожидает проверки');
		
		$Phtml -> ad_email 		= $ad_email;
		$Phtml -> ad_name 		= $ad_name;
		$Phtml -> ad_password 	= $ad_password;
		$Phtml -> ad_title 	    = $ad_title;
		$Phtml -> site_title 	= $Config -> site -> title;
		$Phtml -> ad_code 		= $ad_code;
		$Phtml -> is_link_check = (int)Modules_Board_Models_Settings::instance() -> getConfig() -> general -> isCheckAddAdByEmail;
		
		if(Mail::sendMail(NULL, $Config -> emails -> noreply, $ad_name, $ad_email, $subject, $Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Ваше объявление добавлено, но на Ваш почтовый адрес не удалось отправить почтовое сообщение'));
		}
	}
	
	/**
	 * Отсылаем почтовое сообщение Пользователю для АКТИВАЦИИ ПОДПИСКИ
	 *
	 * @param object $Phtml шаблон оформления
	 * @param int $sb_id id подписки
	 * @param string $sb_email почтовый ящик подписчика
	 * @return bool оптправлено/не отправлено письмо с активацией подписки подписчику
	 */
	public function subscribeUser($Phtml = NULL, $sb_id = 0, $sb_email = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");
		
		$subject = Lng::_('Активация подписки на рассылку объявлений, с сайта').' "'.$Config -> site -> title.'"';
		
		$Phtml -> sb_id = $sb_id;
		$Phtml -> sb_mail = $sb_email;
		$Phtml -> site_title = $Config -> site -> title;
		
		return Mail::sendMail(NULL,$Config -> emails -> noreply,$sb_email,$sb_email,$subject,$Phtml -> getView());
	}
	
	/**
	 * Отправляет почтовое сообщение Администратору после ДОБАВЛЕНИЯ ОБЪЯВЛЕНИЯ Пользователем
	 *
	 * @param object $Phtml шаблон оформления
	 * @param string $ad_name имя пользователя
	 * @param string $ad_email почтовый ящик пользователя
	 * @param string $ad_title название объявления
	 * @param string $ad_text содержимое объявления
	 * @param string $ad_code уникальный код объявления
	 * @return bool
	 */
	public function adminUserAddAd($Phtml = NULL, $ad_name = NULL, $ad_email = NULL, $ad_title = NULL, $ad_text = NULL, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");

		//$subject = Lng::_('На сайте').' "'.$Config -> site -> title.'" '.Lng::_('добавлено новое объявление');
		$subject = Lng::_('На сайте DNP.dp.ua добавлено объявление');

		$Phtml -> ad_name 	= $ad_name;
		$Phtml -> ad_email 	= $ad_email;
		$Phtml -> ad_title 	= $ad_title;
		$Phtml -> ad_text 	= $ad_text;
		$Phtml -> ad_code 	= $ad_code;

		$Phtml -> site_title = $Config -> site -> title;
		$Phtml -> site_host = $Config -> site -> host;

		if(Mail::sendMail(NULL,$Config -> emails -> noreply,$Config -> contacts -> admin,$Config -> contacts -> email,$subject,$Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Ваше объявление добавлено, но на Ваш почтовый адрес не удалось отправить почтовое сообщение'));
		}
	}

	/**
	 * Отправляет почтовое сообщение Администратору после РЕДАКТИРОВАНИЯ ОБЪЯВЛЕНИЯ Пользователем
	 *
	 * @param object $Phtml шаблон оформления
	 * @param string $ad_name имя пользователя
	 * @param string $ad_email почтовый ящик пользователя
	 * @param string $ad_title название объявления
	 * @param string $ad_text содержимое объявления
	 * @param string $ad_code уникальный код объявления
	 * @return bool
	 */
	public function adminUserEditdAd($Phtml = NULL, $ad_name = NULL, $ad_email = NULL, $ad_title = NULL, $ad_text =
	NULL, $ad_code = NULL)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");

		//$subject = Lng::_('На сайте').' "'.$Config -> site -> title.'" '.Lng::_('отредактировано объявление');
		$subject = Lng::_('На сайте DNP.dp.ua отредактировано объявление');

		$Phtml -> ad_name 	= $ad_name;
		$Phtml -> ad_email 	= $ad_email;
		$Phtml -> ad_title 	= $ad_title;
		$Phtml -> ad_text 	= $ad_text;
		$Phtml -> ad_code 	= $ad_code;

		$Phtml -> site_title = $Config -> site -> title;
		$Phtml -> site_host = $Config -> site -> host;

		if(Mail::sendMail(NULL,$Config -> emails -> noreply,$Config -> contacts -> admin,$Config -> contacts -> email,$subject,$Phtml -> getView()) == FALSE)
		{
			throw new Exception_CheckData(Lng::_('FALSE:Ваше объявление отредактировано, но на Ваш почтовый адрес не
			удалось отправить почтовое сообщение'));
		}
	}

	/**
	 * Отправляет почтовое уведомление администратору о том, что была приобретена платная услуга
	 *
	 * @param int $ad_id ID объявления
	 */
	public function adminSendEmailAfterPay($ad_id = 0)
	{
		//Получаем конфигурационные данные
		$Config = Registry::get("Config");
		$ConfigMod = Modules_Board_Models_Settings::instance() -> getConfig();
		
		if($ConfigMod -> general -> isSendEmailAfterPay == '1')
		{
			try
			{
				//Отправляем письмо администратору
				Mail::sendMail(
					NULL,
					$Config -> emails -> noreply,
					$Config -> contacts -> admin,
					$Config -> contacts -> email,
					//Lng::_('На сайте').' "'.$Config -> site -> title.'", '.Lng::_('была приобретена платная услуга'),
					Lng::_('Оплата услуги на DNP.dp.ua'),
					View::get('./modules/board/templates/mail.admin_send_email_after_pay',
						array(
							'AdAr' => Modules_Board_Models_Ad::instance() -> getAdById($ad_id),
						)
					)
				);
			}
			catch(Exception $e)
			{
				
			}
		}
	}
}