<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Ad" модуля "Доска объявлений"
 */

class Modules_Board_Models_Ad extends Guard_Model
{
	/**
	 * Возвращает объект
	 *
	 * @return object
	 */
	public static function instance()
	{
		static $Instance;
		
		if(!is_object($Instance))
		{
			$Instance = new self;
		}
		return $Instance;
	}
	
	/**
	 * Возвращает данные объявления по ID объявления
	 *
	 * @param int $ad_id
	 * @return array
	 */
	public function getAdById($ad_id = 0)
	{
		$sql = "SELECT `a`.* , `u`.`us_name`, `c`.`cat_title`
			FROM 
		`#__mod_board_ad` AS `a`  
			LEFT JOIN 
		`#__sys_category` AS `c` 
			ON(`a`.`ad_region`=`c`.`cat_id` AND `c`.`cat_group`='city')
			LEFT JOIN 
		`#__mod_user` AS `u` 
			ON(`a`.`us_id`=`u`.`us_id`)
			WHERE 
		`a`.`ad_id`='".((int)$ad_id)."'";
		
		return $this -> DB -> setQuery($sql,"Не удалось получить данные объявления",TRUE); 
	}
	
	/**
	 * Возвращает данные объявления по КОДУ объявления
	 *
	 * @param string $ad_code
	 * @return array
	 */
	public function getAdByCode($ad_code = NULL)
	{
		return parent::getDataById("mod_board_ad","ad_code",mysql_real_escape_string($ad_code),"Не удалось получить данные объявления");
	}
	
	/**
	 * Возвращает список всех объявлений
	 *
	 * @return array
	 */
	public function getListAllAd()
	{
		return parent::getAllData('mod_board_ad','ad_id','ad_id ASC','Во время получения данных всех объявленийи возникла ошибка');
	}
	
	/**
	 * Возвращает объявления по id рубрики с учетом лимита
	 *
	 * @param int $cat_id
	 * @param int $ls
	 * @param int $lf
	 * @param bool $ad_is_lock при выборке данных нужно / не нужно получать только заблокированные объявления
	 * @return array
	 */
	public function getAdByCatIdLimit($cat_id = 0, $ls = 0, $lf = -1, $ad_is_lock = FALSE)
	{
		$sql = "SELECT `a`.`ad_id`, `a`.`ad_name`, `a`.`ad_email`, `a`.`ad_title`, `a`.`ad_is_lock`, `a`.`ad_date`, `a`.`ad_foto`, `a`.`ad_vip_date`, `u`.`us_name`, `a`.`ad_text`
			FROM 
		`#__mod_board_ad` AS `a`
			LEFT JOIN 
		`#__mod_user` AS `u` 
			ON(`a`.`us_id`=`u`.`us_id`)";		
		$sql .= $cat_id > 0 || $ad_is_lock == TRUE ? 'WHERE ' : '';
		$sql .= $cat_id > 0 ? "`a`.`cat_id`='".((int)$cat_id)."' " : '';
		$sql .= $cat_id > 0 && $ad_is_lock == TRUE ? " AND " : '';
		$sql .= $ad_is_lock == TRUE ? "`a`.`ad_is_lock`='1' " : '';
		$sql .= "ORDER BY `a`.`ad_date` DESC, `a`.`ad_title` ASC";
		$sql .= $lf > 0 ? " LIMIT ".intval($ls).",".intval($lf) : "";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить объявлений');
	}
	
	/**
	 * Возшращает все ообъявления с учетом лимита
	 *
	 * @param int $ls
	 * @param int $lf
	 * @param bool $ad_is_lock
	 * @return array
	 */
	public function getAdByLimit($ls = 0, $lf = -1, $ad_is_lock = FALSE)
	{
		return $this -> getAdByCatIdLimit(-1, $ls, $lf, $ad_is_lock);
	}
	
	/**
	 * Отображает разблокированные объявления
	 *
	 * @param int $ls начало лимита
	 * @param int $lf конец лимита
	 * @return array
	 */
	/*public function getAdByLimitUnlock($cat_ar = array(), $ls = 0, $lf = -1, $ad_id = 0)
	{
		$sql = "SELECT `a`.*, `a`.`ad_id`, `a`.`ad_name`, `a`.`ad_title`, `a`.`ad_text`, `a`.`ad_foto`, `a`.`ad_phone`, `a`.`ad_date`, 
						`a`.`ad_vip_date`, `a`.`ad_style`, `a`.`ad_style_date`, `c`.`cat_id`, `a`.`cat_id`, `c`.`cat_title` , `a`.`ad_sum`
			FROM 
		`#__mod_board_ad` AS `a`
			LEFT JOIN 
		`#__sys_category` AS `c` 
			ON(`a`.`ad_region`=`c`.`cat_id` AND `c`.`cat_group`='city')			
			WHERE 
		`a`.`cat_id` IN(".join(",", array_map("intval",$cat_ar)).") 
			AND 
		`a`.`ad_is_lock`='0' 
			ORDER BY `a`.`ad_vip_date` DESC, `a`.`ad_date` DESC, `a`.`ad_title` ASC";
		$sql .= $lf > 0 ? " LIMIT ".intval($ls).",".intval($lf) : "";
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить объявления');
	}*/	 
	 
	public function getAdByLimitUnlock($ls = 0, $lf = -1)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_foto`, `ad_text`, `ad_date`, `ad_vip_date`, `ad_style`, `ad_style_date`,  `ad_foto`, `ad_sum`  
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0'   
				ORDER BY 
			`ad_date` DESC, `ad_title` ASC
				LIMIT ".intval($ls).",".intval($lf);
		
		return parent::sqlToArray($sql,'ad_id',"Не удалось получить объявленй");
	}
	
	
	/**
	 * Возвращает не заблокированные объявления указанных категорий с учетом лимита
	 *
	 * @param array $cat_ar
	 * @param int $ls начало лимита
	 * @param int $lf конец лимита
	 * @return array
	 */
	public function getAdByCatArLimit($cat_ar = array(), $ls = 0, $lf = -1, $ad_id = 0)
	{
		//тут получаем регион, но хуй знает как получить ебучие категории
		//УРАА, ЁБАНАЯ КАТЕГОРИЯ, МЫ ТЕБЯ ПОЛУЧИЛИ!
		$sql = "SELECT `a`.*, `a`.`ad_id`, `a`.`ad_name`, `a`.`ad_title`, `a`.`ad_text`, `a`.`ad_foto`, `a`.`ad_phone`, `a`.`ad_date`, 
						`a`.`ad_vip_date`, `a`.`ad_style`, `a`.`ad_style_date`, `c`.`cat_id`, `a`.`cat_id`, `c`.`cat_title` , `a`.`ad_sum`
			FROM 
		`#__mod_board_ad` AS `a`
			LEFT JOIN 
		`#__sys_category` AS `c` 
			ON(`a`.`ad_region`=`c`.`cat_id` AND `c`.`cat_group`='city')			
			WHERE 
		`a`.`cat_id` IN(".join(",", array_map("intval",$cat_ar)).") 
			AND 
		`a`.`ad_is_lock`='0' 
			ORDER BY `a`.`ad_vip_date` DESC, `a`.`ad_date` DESC, `a`.`ad_title` ASC";
		$sql .= $lf > 0 ? " LIMIT ".intval($ls).",".intval($lf) : "";
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить объявления');
		
	
		
		//тут мы получаем все айдишники, но не можем нихера вывести
		/*$sql = "SELECT *, `ad_id`, `ad_name`, `ad_title`, `ad_text`, `ad_foto`, `ad_phone`, `ad_date`, `ad_vip_date`, `ad_style`, `ad_style_date`, `cat_id`, `ad_region`, `ad_sum`
			FROM 
		`#__mod_board_ad`
			WHERE 
		`cat_id` IN(".join(",", array_map("intval",$cat_ar)).") 
			AND
		`ad_is_lock`='0'
			ORDER BY `ad_vip_date` DESC, `ad_date` DESC, `ad_title` ASC";
		$sql .= $lf > 0 ? " LIMIT ".intval($ls).",".intval($lf) : "";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить объявления');*/

		
	}
	
	
	
	/**
	 * Возвращает список объявлений рубрики для формирования списка похожих объявлений
	 *
	 * @param int $cat_id
	 * @param int $lf
	 * @return int
	 */
	public function getAdForSimilarByCatIdLimit($cat_id = 0, $lf = -1)
	{
		$sql = "SELECT `ad_id`, `ad_title`  
			FROM 
		`#__mod_board_ad` 
			WHERE 
		`cat_id`='".intval($cat_id)."'  
			AND 
		`ad_is_lock`='0' 
			ORDER BY `ad_vip_date` DESC, `ad_date` DESC, `ad_title` ASC 
			LIMIT 0,".intval($lf);
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить объявления');
	}
	
	/**
	 * Возвращает заголовки не заблокированных объявлений и дату их публикации
	 *
	 * @return array
	 */
	public function getTitleAd()
	{
		$sql = "SELECT `ad_id`, `ad_title`, `ad_date`  
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0'   
				ORDER BY 
			`ad_date` DESC, `ad_title`, `ad_email` ASC";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить данные объявленй');
	}
	
	/**
	 * Плучаем данные объявлений с даты и по дату
	 *
	 * @param int $fdate с даты
	 * @param int $tdate по дату
	 * @return int
	 */
	public function getIdAdByFDateTDate($fdate=null,$tdate=null)
	{
		$sql = "SELECT `ad_id`, `ad_date`  
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_date`>='".$fdate."' 
				AND 
			`ad_date`<='".$tdate."'";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить данные объявленй');
	}
	
	/**
	 * Возвращает массив ТОП объявлений
	 *
	 * @param int $ls начало выборки
	 * @param int $lf конец выборки
	 * @return array
	 */
	public function getListTopAdByLimitUnlock($ls = 0, $lf = -1)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_foto`, `ad_text`, `ad_date`, `ad_foto`, `ad_sum`  
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0'   
				ORDER BY 
			`ad_count_shows` DESC, `ad_date` DESC, `ad_title` ASC
				LIMIT ".intval($ls).",".intval($lf);
		
		return parent::sqlToArray($sql,'ad_id',"Не удалось получить объявленй");
	}
	
	/**
	 * Возвращает массив VIP объявлениями (с применением RAND() MySQL) 
	 *
	 * @param int $ls начало выборки
	 * @param int $lf конец выборки
	 * @return array
	 */
	public function getListVipRandomAdByLimitUnlock($ls = 0, $lf = -1)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_foto`, `ad_text`, `ad_date`, `ad_foto`, `ad_sum`  
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0' 
				AND 
			`ad_vip_date` > ".time()."
				ORDER BY 
				RAND() 
				LIMIT ".intval($ls).",".intval($lf);
		
		return parent::sqlToArray($sql,'ad_id',"Не удалось получить объявленй");
	}
	
	/**
	 * Возвращает массив из списка VIP объявлений
	 *
	 * @param int $ls начало лимита
	 * @param int $lf конец лимита
	 * @return array
	 */
	public function getListVipAdByLimitUnlock($ls = 0, $lf = -1)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_foto`, `ad_text`, `ad_date`, `ad_vip_date`, `ad_sum`  
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0' 
				AND 
			`ad_vip_date` > ".time()."
				ORDER BY 
			`ad_count_shows` DESC, `ad_date` DESC, `ad_title` ASC
				LIMIT ".intval($ls).",".intval($lf);
		
		return parent::sqlToArray($sql,'ad_id',"Не удалось получить объявленй");
	}
	
	/**
	 * Возвращает массив из topin объявлений
	 *
	 * @return array
	 */
	public function getTrueTopinAd()
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_foto`, `ad_date`, `ad_sum`   
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0' 
				AND 
			`ad_topin_date` > ".time()."
				ORDER BY 
			`ad_count_shows` DESC, `ad_date` DESC, `ad_title` ASC";
		
		return parent::sqlToArray($sql,'ad_id',"Не удалось получить topin объявленя");
	}
	
	/**
	 * Возвращает количество объявлений по всем категориям
	 *
	 * @return array
	 */
	public function getCountsAd()
	{
		$sql = "SELECT `cat_id`, COUNT(`ad_id`) AS `count_ad`
				FROM 
			`#__mod_board_ad`
				GROUP BY `cat_id`";
		
		$result = $this -> DB -> setQuery($sql,"Не удалось определить количество объявлений в категориях");

		$ad_ar = array();
		while($Ad = $this -> DB -> getObject($result))
		{
			$ad_ar[$Ad -> cat_id] = $Ad -> count_ad;
		}

		return $ad_ar;
	}
	
	/**
	 * Возвращает количество всех объявлений
	 *
	 * @param bool $ad_is_lock отображать только заблокированные объявления
	 * @return int
	 */
	public function getCountAd($ad_is_lock = FALSE)
	{
		$sql = "SELECT `ad_id`
				FROM 
			`#__mod_board_ad`";
		$sql .= $ad_is_lock == TRUE ? "WHERE `ad_is_lock`='1' " : '';
		
		return $this -> DB -> setQuery($sql,"Не удалось определить количество всех объявлений","getCount");
	}
	
	/**
	 * Возвращает общее количество опубликованных VIP объявлений
	 *
	 * @return int
	 */
	public function getCountVipAd()
	{
		$sql = "SELECT `ad_id`
				FROM 
			`#__mod_board_ad`
				WHERE 
			`ad_is_lock`='0' 
				AND 
			`ad_vip_date` > ".time();
		
		return $this -> DB -> setQuery($sql,"Не удалось определить количество всех объявлений","getCount");
	}
	
	/**
	 * Возвращает количество объявлений категории $cat_id
	 *
	 * @param int $cat_id 
	 * @param bool $ad_is_lock отображать только заблокированные объявления
	 * @return int
	 */
	public function getCountAdByCatId($cat_id = 0, $ad_is_lock = FALSE)
	{
		$sql = "SELECT `ad_id`
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`cat_id`='".((int)$cat_id)."'";
		$sql .= $ad_is_lock == TRUE ? "AND `ad_is_lock`='1' " : '';
		
		return $this -> DB -> setQuery($sql,"Не удалось определить количество всех объявлений","getCount");
	}
	
	/**
	 * ПОИСК (фильтр) объявлений 
	 *
	 * @param string $search_text искомая фраза
	 * @param int $sr_region_id ID региона
	 * @param array $cats_ar массив из ID рубрик
	 * @param int $ls
	 * @param int $lf
	 * @return array
	 */
	public function filterAdBy($search_text = null, $sr_region_id = 0, array $cats_ar = array(), $s1, $s2, $ls = 0, $lf = 20)
	{
		//Массив условий
		$where_ar = array(
			"`a`.`ad_is_lock`='0'",
		);
		
		if($s1 > 0 && $s2 > 0)
		{
		$where_ar[] = '`a`.`ad_sum` >= '.$s1;
		$where_ar[] = '`a`.`ad_sum` <= '.$s2;
		}
		else if($s1 > 0)
		{
		$where_ar[] = '`a`.`ad_sum` >= '.$s1;
		}
		else if($s2 > 0)
		{
		$where_ar[] = '`a`.`ad_sum` <= '.$s2;
		}
		
		
		//Формируем массив условий
		if($search_text)
		{
			$where_ar[] = "`a`.`ad_title` LIKE '%".mysql_real_escape_string($search_text)."%'";
		}
		if($sr_region_id)
		{
			$where_ar[] = "`a`.`ad_region`='".$sr_region_id."'";
		}
		if(sizeof($cats_ar) == true)
		{
			$where_ar[] = "`a`.`cat_id` IN (".join(',',$cats_ar).")";
		}
		$sql = "SELECT `a`.*, `a`.`ad_id`, `a`.`ad_name`, `a`.`ad_title`, `a`.`ad_text`, `a`.`ad_foto`, `a`.`ad_phone`, `a`.`ad_date`, 
						`a`.`ad_vip_date`, `a`.`ad_style`, `a`.`ad_style_date`, `a`.`cat_id` , `c`.`cat_title` , `a`.`ad_sum` 
			FROM 
		`#__mod_board_ad` AS `a`  
			LEFT JOIN 
		`#__sys_category` AS `c` 
			ON(`a`.`ad_region`=`c`.`cat_id` AND `c`.`cat_group`='city') 
			WHERE
		".join(' AND ', $where_ar)."
			ORDER BY `a`.`ad_vip_date` DESC, `a`.`ad_date` DESC, `a`.`ad_title` ASC
			LIMIT ".intval($ls).",".intval($lf);
		return parent::sqlToArray($sql,'ad_id',"Не удалось получить данные объявлений");
	}
	
	

	
	
	
	
	/**
	 * ПОИСК. Определяем количество найденных объявлений для упрощенного поиска
	 *
	 * @param string $search_text искомая фраза
	 * @param string $search_city город
	 * @return int
	 */
public function filterCountAdBy($search_text = null, $sr_region_id = 0, array $cats_ar = array(),  $s1, $s2)
{
	//Массив условий
	$where_ar = array(
		"`a`.`ad_is_lock`='0'",
	);

	if($s1 > 0 && $s2 > 0)
	{
		$where_ar[] = '`a`.`ad_sum` >= '.$s1;
		$where_ar[] = '`a`.`ad_sum` <= '.$s2;
	}
	else if($s1 > 0)
	{
		$where_ar[] = '`a`.`ad_sum` >= '.$s1;
	}
	else if($s2 > 0)
	{
		$where_ar[] = '`a`.`ad_sum` <= '.$s2;
	}

	//Формируем массив условий
	if($search_text)
	{
		$where_ar[] = "`a`.`ad_title` LIKE '%".mysql_real_escape_string($search_text)."%'";
	}
	if($sr_region_id)
	{
		$where_ar[] = "`a`.`ad_region`='".$sr_region_id."'";
	}
	if(sizeof($cats_ar) == true)
	{
		$where_ar[] = "`a`.`cat_id` IN (".join(',',$cats_ar).")";
	}

	$sql = "SELECT COUNT(`ad_id`) AS `ad_count`  
		FROM 
	`#__mod_board_ad` AS `a`  
		WHERE 
	".join(' AND ', $where_ar);

	$result = $this -> DB -> setQuery($sql,"Не удалось определить количество объявлений");
	return $this -> DB -> getObject($result) -> ad_count;
}
	
	/**
	 * ПОИСК. Упрощенный поиск объявлений 
	 *
	 * @param string $search_text искомая фраза
	 * @param string $search_city город
	 * @param int $ls
	 * @param int $lf
	 * @return array
	 */
	public function searchAdBy($search_text=null,$search_city=null,$ls=0,$lf=20)
	{
		$sql = "SELECT `a`.`ad_id`, `a`.`ad_name`, `a`.`ad_title`, `a`.`ad_text`, `a`.`ad_foto`, `a`.`ad_phone`, `a`.`ad_date`, 
						`a`.`ad_vip_date`, `a`.`ad_style`, `a`.`ad_style_date` , `c`.`cat_title`, `a`.`cat_id`, `a`.`ad_sum`
			FROM 
		`#__mod_board_ad` AS `a`  
			LEFT JOIN 
		`#__sys_category` AS `c` 
			ON(`a`.`ad_region`=`c`.`cat_id` AND `c`.`cat_group`='city') 
			WHERE 
		(`a`.`ad_title` LIKE '%".mysql_real_escape_string($search_text)."%' 
				OR
		`a`.`ad_text` LIKE '%".mysql_real_escape_string($search_text)."%')   
			AND 
		`a`.`ad_is_lock`='0' ";
		 
		if($search_city)
		{
			$sql .= "AND 
				`c`.`cat_title` LIKE '".mysql_real_escape_string($search_city)."%' ";
		}
		
		$sql .= "ORDER BY `a`.`ad_vip_date` DESC, `a`.`ad_date` DESC, `a`.`ad_title` ASC
			LIMIT ".intval($ls).",".intval($lf);
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить данные объявлений');
	}
	
	/**
	 * ПОИСК. Определяем количество найденных объявлений для упрощенного поиска
	 *
	 * @param string $search_text искомая фраза
	 * @param string $search_city город
	 * @return int
	 */
	public function searchCountAdBy($search_text = NULL, $search_city = NULL)
	{
		$sql = "SELECT COUNT(`a`.`ad_id`) AS `ad_count`  
			FROM 
		`#__mod_board_ad` AS `a`  
			LEFT JOIN 
		`#__sys_category` AS `c` 
			ON(`a`.`ad_region`=`c`.`cat_id` AND `c`.`cat_group`='city') 
			WHERE 
		(`a`.`ad_title` LIKE '%".mysql_real_escape_string($search_text)."%' 
				OR
		`a`.`ad_text` LIKE '%".mysql_real_escape_string($search_text)."%') 
			AND 
		`a`.`ad_is_lock`='0' ";
		if($search_city)
		{
			$sql .= "AND 
				`c`.`cat_title` LIKE '".mysql_real_escape_string($search_city)."%' ";
		}
		
		$result = $this -> DB -> setQuery($sql,"Не удалось определить количество объявлений");
		$Ad = $this -> DB -> getObject($result);
		
		return $Ad -> ad_count;
	}
	
	
	/**
	 * Возврашает объявления, дата которых больше $date 
	 *
	 * @param int $date дата
	 * @return array массив объектов объявлений
	 */
	public function getAdByDateLt($date = NULL)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_text`, `ad_date`  
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`ad_date`>'".$date."'
				AND 
			`ad_is_lock`='0'";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить данные объявлений');
	}
	
	/**
	 * Возвращает старые объявления, дата которых (ad_keep) меньше текущей
	 *
	 * @return array
	 */
	public function getOldAd($ls = 0, $lf = 0)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_title`, `ad_foto`, `ad_date`  
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`ad_keep`<".time()." 
				ORDER BY 
			`ad_date` DESC, `ad_title` ASC ";
		
		if($lf > 0)
		{
			$sql .= "LIMIT ".intval($ls).",".intval($lf);
		}

		return parent::sqlToArray($sql, 'ad_id', "Не удалось получить данные объявлений");
	}
	
	/**
	 * Возвращает количество старых объявлений, дата которых (ad_keep) меньше текущей
	 *
	 * @return int
	 */
	public function countOldAd()
	{
		$sql = "SELECT `ad_id`
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`ad_keep`<'".time()."'";
		
		return $this -> DB -> setQuery($sql,"Не удалось определить количество объявлений","getCount");
	}
	
	/**
	 * Возвращает количество объявлений по датам для рабочего стола
	 *
	 * @return array
	 */
	public function getCountArAdForDesktop()
	{
		$sql = "SELECT `ad_id`, `ad_date`
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`ad_date`>'".(time() - Str::DATE_DAY * 7)."'";
		
		$AdAr = parent::sqlToArray($sql, 'ad_id', "Не удалось получить данные объявлений");
		
		
		$ad_ar = array(
			1 => 0,
			2 => 0,
			3 => 0,
			4 => 0,
			5 => 0,
			6 => 0,
			7 => 0,
		);
		foreach ($AdAr as $Ad)
		{
			if($Ad -> ad_date > (time() - Str::DATE_DAY))
			{
				$ad_ar[1]++;
			}
			else if($Ad -> ad_date > (time() - Str::DATE_DAY * 2))
			{
				$ad_ar[2]++;
			}
			else if($Ad -> ad_date > (time() - Str::DATE_DAY * 3))
			{
				$ad_ar[3]++;
			}
			else if($Ad -> ad_date > (time() - Str::DATE_DAY * 4))
			{
				$ad_ar[4]++;
			}
			else if($Ad -> ad_date > (time() - Str::DATE_DAY * 5))
			{
				$ad_ar[5]++;
			}
			else if($Ad -> ad_date > (time() - Str::DATE_DAY * 6))
			{
				$ad_ar[6]++;
			}
			else if($Ad -> ad_date > (time() - Str::DATE_DAY * 7))
			{
				$ad_ar[7]++;
			}
		}
		return $ad_ar;
	}
	
	/**
	 * Возвращает фотографии объявлений по id массиву объявлений
	 *
	 * @param array $ad_ar
	 * @return array
	 */
	public function getFotoAdByArId($ad_ar = array())
	{
		$sql = "SELECT `ad_id`, `ad_foto`   
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`ad_id` IN (".join(",",array_map("intval",$ad_ar)).")";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить данные объявлений');
	}
	
	/**
	 * Получаем объявления пользователя
	 *
	 * @param int $us_id id пользователя
	 * @return array
	 */
	public function getAdByUsId($us_id = 0)
	{
		$sql = "SELECT `ad_id`, `ad_name`, `ad_email`, `ad_title`, `ad_date`, `ad_foto`, `ad_is_lock`, `ad_vip_date`   
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`us_id`='".((int)$us_id)."' 
				ORDER BY 
			`ad_date` DESC, `ad_title` ASC";
		
		return parent::sqlToArray($sql, 'ad_id', 'Не удалось получить объявлений пользователя');
	}
	
	/**
	 * Определяем доступ пользователя к объявлению
	 *
	 * @param int $us_id id пльзователя
	 * @param int $ad_id id объявления
	 * @return bool
	 */
	public function checkAccessUserToAd($us_id = 0, $ad_id = 0)
	{
		$sql = "SELECT `ad_id`    
				FROM 
			`#__mod_board_ad` 
				WHERE 
			`us_id`='".((int)$us_id)."' 
				AND 
			`ad_id`='".((int)$ad_id)."'";
		
		$Data = $this -> DB -> setQuery($sql,"Не удалось определить доступ пользователя к объявлению",true);
		
		$count = true;
		try
		{
			CheckData::existsDataObject($Data);
		}
		catch (Exception_CheckData $e)
		{
			$count = FALSE;
		}

		return $count;
	}
	
	/**
	 * Проверяет существования объявления в БД
	 *
	 * @param int $ad_id
	 * @return bool
	 */
	public function isExistsId($ad_id = 0)
	{
		$AdData = $this -> getAdById($ad_id);
		
		$count = 1;
		try
		{
			CheckData::existsDataObject($AdData);
		}
		catch (Exception_CheckData $e)
		{
			$count = 0;
		}

		return $count;
	}
	
	/**
	 * Добавляет объявление
	 *
	 * @param string $us_id id пользователя в системе
	 * @param string $ad_name
	 * @param string $ad_email
	 * @param string $ad_phone
	 * @param string $ad_site
	 * @param string $ad_title
	 * @param string $ad_text
	 * @param int $ad_region
	 * @param int $cat_id
	 * @param string $ad_foto
	 * @param int $ad_is_lock
	 * @param int $ad_keep
	 * @param string $ad_code
	 */
	public function addAd($us_id=0,$ad_name=null,$ad_email=null,$ad_phone=null,$ad_site=null,$ad_title=null,$ad_text=null,$ad_region=0,$cat_id=0,$ad_foto=null,$ad_is_lock=1,$ad_keep=0,$ad_code=null,$ad_sum=0)
	{
		$sql = "INSERT INTO `#__mod_board_ad` 
			(`us_id`, `ad_name`, `ad_email`, `ad_phone`, `ad_site`, `ad_title`, `ad_text`, `ad_region`, 
			 `cat_id`, `ad_foto`, `ad_is_lock`, `ad_keep`, `ad_date`,`ad_code`,`ad_sum`)
				VALUES
			('".((int)$us_id)."', 
			'".mysql_real_escape_string(strip_tags($ad_name))."', 
			'".mysql_real_escape_string($ad_email)."', 
			'".mysql_real_escape_string(strip_tags($ad_phone))."', 
			'".mysql_real_escape_string(strip_tags($ad_site))."', 
			'".mysql_real_escape_string(strip_tags($ad_title))."', 
			'".mysql_real_escape_string(trim(strip_tags($ad_text)))."', 
			'".((int)$ad_region)."',  
			'".((int)$cat_id)."', 
			'".$ad_foto."', 
			'".((int)$ad_is_lock)."',  
			'".(time() + ((int)$ad_keep))."', 
			'".time()."',
			'".$ad_code."',
			'".floatval($ad_sum)."')";
		
		$this -> DB -> setQuery($sql,"Во время сохранения данных объявления возникла ошибка");
	}
	
	/**
	 * Импортирует объявление
	 *
	 * @param array $data_import_ar
	 * @param bool $is_ad_id
	 * @param bool $is_region_id
	 * @param bool $is_vip
	 * @param bool $is_style
	 * @param int $cat_id
	 * @param array $us_ar
	 */
	public function importAd(array $data_import_ar = array(), $is_ad_id = 0, $is_region_id = 0, $is_vip = 0, $is_style = 0, $cat_id = 0, array $us_ar = array())
	{
		$sql_ar 		= array();
		$us_ar			= array_map('intval',$us_ar);
		$first_us_id	= reset($us_ar);
		$count_us_id 	= sizeof($us_ar)-1;
		
		$sql = "INSERT INTO `#__mod_board_ad` (";
		if($is_ad_id == true)
		{
			$sql .= "`ad_id`";
		}
		$sql .= "`us_id` ,
				 `ad_name` ,
				 `ad_email` ,
				 `ad_phone` ,
				 `ad_site` ,
				 `ad_title` ,
				 `ad_text` ,
				 `ad_region` ,
				 `cat_id` ,
				 `ad_is_lock` ,
				 `ad_keep` ,
				 `ad_date` ,
				 `ad_count_shows` ,
				 `ad_vip_date` ,
				 `ad_style` ,
				 `ad_style_date` ,
				 `ad_code`) VALUES ";
		
		$i = 0;
		foreach ($data_import_ar as $ad_ar)
		{
			$sql_ar[$i]  = '(';
			if($is_ad_id == true)
			{
				$sql_ar[$i] .= '"'.intval($ad_ar['ad_id']).'", ';
			}
			//Если первй пользователь равен "-1", значит импортируем данные с файла
			if($first_us_id == '-1')
			{
				$sql_ar[$i] .= '"'.intval($ad_ar['us_id']).'", ';
			}
			else
			{
				$sql_ar[$i] .= '"'.$us_ar[rand(0,$count_us_id)].'", ';
			}
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_name']).'", ';
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_email']).'", ';
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_phone']).'", ';
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_site']).'", ';
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_title']).'", ';
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_text']).'", ';
			if($is_region_id == true)
			{
				$sql_ar[$i] .= '"'.intval($ad_ar['ad_region']).'", ';
			}
			else
			{
				$sql_ar[$i] .= '"0", ';
			}
			if($cat_id == '-1')
			{
				$sql_ar[$i] .= '"'.intval($ad_ar['cat_id']).'", ';
			}
			else
			{
				$sql_ar[$i] .= '"'.$cat_id.'", ';
			}
			$sql_ar[$i] .= '"'.intval($ad_ar['ad_is_lock']).'", ';
			$sql_ar[$i] .= '"'.intval($ad_ar['ad_keep']).'", ';
			$sql_ar[$i] .= '"'.intval($ad_ar['ad_date']).'", ';
			$sql_ar[$i] .= '"'.intval($ad_ar['ad_count_shows']).'", ';
			if($is_vip == true)
			{
				$sql_ar[$i] .= '"'.intval($ad_ar['ad_vip_date']).'", ';
			}
			else
			{
				$sql_ar[$i] .= '"0", ';
			}
			if($is_style == true)
			{
				$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_style']).'", ';
				$sql_ar[$i] .= '"'.intval($ad_ar['ad_style_date']).'", ';
			}
			else
			{
				$sql_ar[$i] .= '"", ';
				$sql_ar[$i] .= '"0", ';
			}
			$sql_ar[$i] .= '"'.mysql_real_escape_string($ad_ar['ad_code']).'" ';
			$sql_ar[$i] .= ')';
			
			$i++;
		}

		$this -> DB -> setQuery($sql.join(', ',$sql_ar),"Во время импорта данных объявления возникла ошибка");
	}
	
	/**
	 * Обновляет данные объявления по ID объявления
	 *
	 * @param int $ad_id
	 * @param string $ad_name
	 * @param string $ad_email
	 * @param string $ad_phone
	 * @param string $ad_site
	 * @param string $ad_title
	 * @param string $ad_text
	 * @param int $ad_region
	 * @param int $cat_id
	 * @param int $ad_is_lock
	 * @param int $ad_keep
	 * @param array $add_row_ar дополнительные поля
	 */
	public function updateAd($ad_id=0,$ad_name=null,$ad_email=null,$ad_phone=null,$ad_site=null,$ad_title=null,$ad_text=null,$ad_region=0,$cat_id=0,$ad_is_lock=1,$ad_keep=0,$add_row_ar=array())
	{
		$sql = "UPDATE 
			`#__mod_board_ad`
				SET
			`ad_name`='".mysql_real_escape_string(strip_tags($ad_name))."', 
			`ad_email`='".mysql_real_escape_string($ad_email)."', 
			`ad_phone`='".mysql_real_escape_string(strip_tags($ad_phone))."', 
			`ad_site`='".mysql_real_escape_string(strip_tags($ad_site))."', 
			`ad_title`='".mysql_real_escape_string(trim(strip_tags($ad_title)))."', 
			`ad_text`='".mysql_real_escape_string(strip_tags($ad_text))."', 
			`ad_region`='".((int)$ad_region)."',  
			`cat_id`='".((int)$cat_id)."', 
			`ad_is_lock`='".((int)$ad_is_lock)."', ";
		if(sizeof($add_row_ar))
		{
			foreach($add_row_ar as $row => $val)
			{
				$sql .= "`".$row."`='".$val."', ";	
			}
		}
		$sql .= "`ad_keep`='".(time() + ((int)$ad_keep))."' 
				WHERE 
			`ad_id`='".((int)$ad_id)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось обновить данные объявления");
	}
	
	/**
	 * Обновляет фотографию объявления
	 *
	 * @param int $ad_id
	 * @param string $ad_foto
	 */
	public function updateAdFotoById($ad_id = 0, $ad_foto = NULL)
	{
		parent::updateRowById("mod_board_ad", "ad_id", ((int)$ad_id), "ad_foto", $ad_foto, "Не удалось обновить фотографию объявления");
	}
	
	/**
	 * Обновляет блокировку объявления по CODE
	 *
	 * @param string $ad_code
	 * @param int $lock
	 */
	public function updateAdLockedByCode($ad_code = NULL, $lock = 0)
	{
		parent::updateRowById("mod_board_ad","ad_code",$ad_code,"ad_is_lock",((int)$lock),"Не удалось отобразить/спрятать объявления");
	}
	
	/**
	 * Обновляет блокировку объявления по ID
	 *
	 * @param int $ad_id
	 * @param int $lock
	 */
	public function updateAdLockedById($ad_id = 0, $lock = 0)
	{
		parent::updateRowById("mod_board_ad","ad_id",((int)$ad_id),"ad_is_lock",((int)$lock),"Не удалось отобразить/спрятать объявления");
	}
	
	/**
	 * Приращивает счетчик просмотра объявления на еденицу
	 *
	 * @param int $ad_id
	 */
	public function incrementCountShowsById($ad_id = 0)
	{
		$sql = "UPDATE 
			`#__mod_board_ad`
				SET
			`ad_count_shows`=`ad_count_shows`+1
				WHERE 
			`ad_id`='".((int)$ad_id)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось обновить счетчик просмотра объявления");
	}
	
	/**
	 * Обновляет данные 
	 *
	 * @param int $ad_id
	 * @param array $row_ar массив полй что нужно обновить
	 */
	public function updatePayRowById($ad_id = 0, $row_ar = array())
	{
		parent::updateSomeRowById("mod_board_ad","ad_id",((int)$ad_id),$row_ar,"Во время обновления платежных полей возникла ошибка");
	}
	
	/**
	 * Удаляет объявление по ID объявлению
	 *
	 * @param int $ad_id
	 */
	public function deleteAdById($ad_id = 0)
	{
		parent::deleteDataById("mod_board_ad","ad_id",((int)$ad_id),"Во время удаления объявления возникла ошибка");
	}
	
	/**
	 * Удаляет объявления по массиву id объявлений
	 *
	 * @param int $ad_ar
	 */
	public function deleteAdByAdAr($ad_ar = array())
	{
		$sql = "DELETE `#__mod_board_ad` 
			FROM 
		`#__mod_board_ad` 
			WHERE 
		`ad_id` IN (".join(",",array_map("intval",$ad_ar)).")";
		
		$this -> DB -> setQuery($sql,"Во время удаления объявлений возникла ошибка");
	}
	
	/**
	 * Удаляем изображения объявления
	 *
	 */
	public static function deleteImg($img = NULL)
	{
		File::deleteFile(Modules_Board_Controllers_Index::PATH_DIR_NORMAL.$img);
		File::deleteFile(Modules_Board_Controllers_Index::PATH_DIR_THUMB.$img);
	}
}