<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Board" модуля "Доска объявлений"
 */

class Modules_Board_Models_Board
{
	/**
	 * Возвраща текст правила
	 *
	 * @return string
	 */
	public function getTextRule()
	{
		return $this -> getText("rule");
	}
	
	/**
	 * Сохраняет правило
	 *
	 * @param string $text содержимое правила
	 */
	public function setTextRule($text=null)
	{
		$this -> setText($text,"rule");
	}
	
	/**
	 * Возвраща текст страницы платежей
	 *
	 * @return string
	 */
	public function getTextPays()
	{
		return $this -> getText("pays");
	}
	
	/**
	 * Сохраняет текст страницы платежей
	 *
	 * @param string $text содержимое правила
	 */
	public function setTextPays($text=null)
	{
		$this -> setText($text,"pays");
	}
	
	/**
	 * Возвраща содержимое файла
	 *
	 * @param string $file имя файла
	 * @return string
	 */
	private function getText($file=null)
	{
		$doc = "";
		if(is_file("./files/db/models/board/".$file.".html"))
		{
			$doc = File::read("./files/db/models/board/".$file.".html");
		}
		else
		{
			throw new Exception_440();
		}
		
		return $doc;
	}
	
	/**
	 * Сохраняет содержимое файла
	 *
	 * @param string $text содержимое правила
	 * @param string $file имя файла
	 */
	private function setText($text=null,$file=null)
	{
		if(is_file("./files/db/models/board/".$file.".html"))
		{
			File::write("./files/db/models/board/".$file.".html",$text);
		}
		else
		{
			throw new Exception();
		}
	}
}