<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Notepad" модуля "Доска объявлений"
 */

class Modules_Board_Models_Notepad extends Guard_Model
{
	/**
	 * Возвращает объект
	 *
	 * @return object
	 */
	public static function instance()
	{
		static $Instance;
		
		if(!is_object($Instance))
		{
			$Instance = new self;
		}
		return $Instance;
	}
	
	/**
	 * Получаем объявления пользователя
	 *
	 * @param int $us_id id пользователя
	 * @return array
	 */
	public function getAdByUsId($us_id = 0)
	{
		$sql = "SELECT `a`.`ad_id`, `a`.`ad_title`, `n`.`np_id`, `n`.`np_date_create` 
				FROM 
			`#__mod_board_notepad` AS `n`
				LEFT JOIN
			`#__mod_board_ad` AS `a`
				ON(`n`.`ad_id`=`a`.`ad_id`)
				WHERE 
			`n`.`us_id`='".((int)$us_id)."' 
				ORDER BY 
			`n`.`np_date_create` DESC";
		
		return parent::sqlToArray($sql, 'np_id', 'Не удалось получить объявлений пользователя');
	}
	
	/**
	 * Добавляет объявление в блокнот
	 *
	 * @param int $us_id ID пользователя
	 * @param int $ad_id ID объявления
	 */
	public function add($us_id = 0, $ad_id = 0)
	{
		$this -> DB -> setQuery("INSERT INTO `#__mod_board_notepad`
			(`us_id`, `ad_id`, `np_date_create`)
				VALUES
			(".intval($us_id).", ".intval($ad_id).", ".time().")", 
			'Во время добавления объявления в блокнот возникла ошибка' 
		);
	}
	
	/**
	 * Удаляет объявление с блокнота
	 *
	 * @param int $us_id ID пользователя
	 * @param int $np_id ID записи блокнота
	 */
	public function delete($us_id = 0, $np_id = 0)
	{
		$this -> DB -> setQuery("DELETE FROM `#__mod_board_notepad`
								WHERE
							`us_id`=".intval($us_id)."
							 	AND
							`np_id`=".intval($np_id),  
			'Во время удаления объявления с блокнота возникла ошибка' 
		);		
	}
	
	/**
	 * Проверяем, есть ли у пользователя в блокноте объявление
	 *
	 * @param int $us_id
	 * @param int $ad_id
	 * @return bool
	 */
	public function inNotepad($us_id = 0, $ad_id = 0)
	{
		return (bool) $this -> DB -> setQuery("SELECT 
							`np_id` 
								FROM
							`#__mod_board_notepad`
								WHERE
							`us_id`=".intval($us_id)."
							 	AND
							`ad_id`=".intval($ad_id), 
			'Не удалось определить наличие объявления в блокноте', 
			'getCount'
		);
	}
}