<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Pay" модуля "Доска объявлений"
 */

class Modules_Board_Models_Pays extends Models_Pays 
{
	public function __construct()
	{
		parent::__construct("board");
	}
	
	/**
	 * Возвращает данные платежа
	 *
	 * @param int $py_id id платежа
	 * @return object
	 */
	public function getPayById($py_id)
	{
		return parent::getDataById($py_id);
	}
	
	/**
	 * Возвращает ID объявления
	 *
	 * @param int $py_id
	 * @return object
	 */
	public function getObjIdPayById($py_id)
	{
		return parent::getParentIdById($py_id);
	}
	
	/**
	 * Возвращает платежи с учетом лимита
	 *
	 * @param int $ls
	 * @param int $lf
	 * @return array
	 */
	public function getPaysLimit($ls=0,$lf=-1)
	{
		$sql = "SELECT `p`.`py_id`, `p`.`py_code`, `p`.`py_title`, `p`.`py_amount`, `p`.`py_operations`, `p`.`py_status`, 
						`p`.`py_date_start`, `p`.`py_date_end`,	`p`.`py_parent_id`, `a`.`ad_id`, `a`.`ad_title`, `a`.`ad_vip_date`, `a`.`ad_style_date`  
				FROM 
			`#__sys_pays` AS `p` 
				LEFT JOIN 
			`#__mod_board_ad` AS `a`
				ON(`p`.`py_parent_id`=`a`.`ad_id` AND `p`.`py_group`='".$this -> group."') 
				WHERE 
			`p`.`py_group`='".$this -> group."'
				ORDER BY 
			`p`.`py_date_start` DESC";
		$sql .= $lf > 0 ? " LIMIT ".$ls.",".$lf : "";
		
		return parent::sqlToArray($sql, 'py_id', 'Во время получения данных платежей возникла ошибка');
	}
	
	/**
	 * Возвращаем данные объявления по ID платежа
	 *
	 * @param int $py_id
	 * @return object
	 */
	public function getAdByPayId($py_id=0)
	{
		$sql = "SELECT `a`.`ad_id`, `a`.`cat_id`, `a`.`ad_title` 
				FROM 
			`#__sys_pays` AS `p` 
				LEFT JOIN 
			`#__mod_board_ad` AS `a`
				ON(`p`.`py_parent_id`=`a`.`ad_id` AND `p`.`py_group`='".$this -> group."') 
				WHERE 
			`p`.`py_id`='".((int)$py_id)."' 
				AND 
			`p`.`py_group`='".$this -> group."'";
		
		return $this -> DB -> setQuery($sql,"Во время получения данных объявления возникла ошибка",true);
	}
	
	/**
	 * Возвращаем id только что выполненного запроса
	 *
	 * @return unknown
	 */
	public function getLastPayId()
	{
		return parent::getLastId();
	}	
	
	/**
	 * Возвращает количество платежей группы
	 *
	 * @return int
	 */
	public function getCountPays()
	{
		return parent::getCountData();
	}
	
	/**
	 * Сохраняем данные платежа
	 *
	 * @param unknown_type $py_code
	 * @param unknown_type $py_title
	 * @param unknown_type $py_description
	 * @param unknown_type $py_amount
	 * @param unknown_type $py_operations
	 * @param unknown_type $py_status
	 * @param unknown_type $py_date_start
	 * @param unknown_type $py_date_end
	 * @param unknown_type $py_parent_id
	 */
	public function insertPay($py_code=null,$py_title=null,$py_description=null,$py_amount=0,$py_operations=null,$py_status=0,$py_date_start=null,$py_date_end=null,$py_parent_id=0)
	{
		parent::insertData($py_code,$py_title,$py_description,$py_amount,$py_operations,$py_status,$py_date_start,$py_date_end,$py_parent_id);
	}
	
	/**
	 * Обновляет данные платежа
	 *
	 * @param int $py_id
	 * @param string $py_description
	 * @param int $py_status
	 * @param string $py_date_end
	 */
	public function updatePay($py_id=0,$py_description=null,$py_status=null,$py_date_end=null)
	{
		parent::updateData($py_id,$py_description,$py_status,$py_date_end);
	}
	
	
	/**
	 * Обновляем данные статуса платежа
	 *
	 * @param int $py_id
	 * @param int $py_status
	 */
	public function updatePayStatus($py_id=0,$py_status=null)
	{
		parent::updateRowById("sys_pays","py_id",((int)$py_id),"py_status",((int)$py_status),"Во время обновления данных статуса возникла ошибка");
	}
}