<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Settings" модуля "Доска объявлений"
 */

class Modules_Board_Models_Settings extends Guard_Model
{
	/**
	 * Возвращает объект
	 *
	 * @return object
	 */
	public static function instance()
	{
		static $Instance;
		
		if(!is_object($Instance))
		{
			$Instance = new self;
		}
		return $Instance;
	}
	
	/**
	 * Возвращаем настройки модуля
	 *
	 * @return object
	 */
	public function getConfig()
	{
		if(is_file("./files/db/models/board/config.xml"))
		{
			return XML::getObj("./files/db/models/board/config.xml");
		}
		return false;
	}
	
	/**
	 * Устанавливаем новые данные настроек
	 *
	 * @param array $data_ar POST данные настроек
	 */
	public function setConfig($data_ar)
	{
		if(is_file("./files/db/models/board/config.xml"))
		{
			XMLDocument::setObj("./files/db/models/board/config.xml");
			
			XMLDocument::setData('//data/general/isPublicAdAfterAdd',(int)$data_ar['general']['isPublicAdAfterAdd']);
			XMLDocument::setData('//data/general/isPublicAdAfterEdit',(int)$data_ar['general']['isPublicAdAfterEdit']);
			XMLDocument::setData('//data/general/isPublicAdWithLink',(int)$data_ar['general']['isPublicAdWithLink']);
			XMLDocument::setData('//data/general/isSendMailAdminAfterAdAdd',(int)$data_ar['general']['isSendMailAdminAfterAdAdd']);
			XMLDocument::setData('//data/general/isShowMessageOldAd',(int)$data_ar['general']['isShowMessageOldAd']);
			XMLDocument::setData('//data/general/isSendEmailAfterPay',(int)$data_ar['general']['isSendEmailAfterPay']);
			XMLDocument::setData('//data/general/isShowAdComments',(int)$data_ar['general']['isShowAdComments']);
			XMLDocument::setData('//data/general/isShowAdOnIndexPage',(int)$data_ar['general']['isShowAdOnIndexPage']);
			XMLDocument::setData('//data/general/isCheckAddAdByEmail',(int)$data_ar['general']['isCheckAddAdByEmail']);
			XMLDocument::setData('//data/general/isAddAdWithoutRegistration',(int)$data_ar['general']['isAddAdWithoutRegistration']);

			
			XMLDocument::setData('//data/terms/vip/isSwitch',(int)$data_ar['terms']['vip']['isSwitch']);
			XMLDocument::setData('//data/terms/vip/day',(int)$data_ar['terms']['vip']['day']);
			XMLDocument::setData('//data/terms/style/isSwitch',(int)$data_ar['terms']['style']['isSwitch']);
			XMLDocument::setData('//data/terms/style/day',(int)$data_ar['terms']['style']['day']);
			XMLDocument::setData('//data/terms/style/style',join("",$data_ar['terms']['style']['style']));
			XMLDocument::setData('//data/terms/topin/isSwitch',(int)$data_ar['terms']['topin']['isSwitch']);
			XMLDocument::setData('//data/terms/topin/isShowAd',(int)$data_ar['terms']['topin']['isShowAd']);
			XMLDocument::setData('//data/terms/topin/isCache',(int)$data_ar['terms']['topin']['isCache']);
			XMLDocument::setData('//data/terms/topin/day',(int)$data_ar['terms']['topin']['day']);
			XMLDocument::setData('//data/terms/topin/count',(int)$data_ar['terms']['topin']['count']);
			
			
			XMLDocument::setData('//data/pay/SMSOnline/isSwitch',(int)$data_ar['pay']['SMSOnline']['isSwitch']);
			XMLDocument::setData('//data/pay/SMSOnline/isPassword',(int)$data_ar['pay']['SMSOnline']['isPassword']);
			XMLDocument::setData('//data/pay/SMSOnline/password',$data_ar['pay']['SMSOnline']['password']);
			XMLDocument::setData('//data/pay/SMSOnline/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['SMSOnline']['info']))));
			XMLDocument::setData('//data/pay/SMSOnline/vip/phone',strip_tags($data_ar['pay']['SMSOnline']['vip']['phone']));
			XMLDocument::setData('//data/pay/SMSOnline/vip/prefix',strip_tags($data_ar['pay']['SMSOnline']['vip']['prefix']));
			XMLDocument::setData('//data/pay/SMSOnline/vip/amount',strip_tags($data_ar['pay']['SMSOnline']['vip']['amount']));
			XMLDocument::setData('//data/pay/SMSOnline/vip/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['SMSOnline']['vip']['info']))));
			XMLDocument::setData('//data/pay/SMSOnline/style/phone',strip_tags($data_ar['pay']['SMSOnline']['style']['phone']));
			XMLDocument::setData('//data/pay/SMSOnline/style/prefix',strip_tags($data_ar['pay']['SMSOnline']['style']['prefix']));
			XMLDocument::setData('//data/pay/SMSOnline/style/amount',strip_tags($data_ar['pay']['SMSOnline']['style']['amount']));
			XMLDocument::setData('//data/pay/SMSOnline/style/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['SMSOnline']['style']['info']))));
			XMLDocument::setData('//data/pay/SMSOnline/topin/phone',strip_tags($data_ar['pay']['SMSOnline']['topin']['phone']));
			XMLDocument::setData('//data/pay/SMSOnline/topin/prefix',strip_tags($data_ar['pay']['SMSOnline']['topin']['prefix']));
			XMLDocument::setData('//data/pay/SMSOnline/topin/amount',strip_tags($data_ar['pay']['SMSOnline']['topin']['amount']));
			XMLDocument::setData('//data/pay/SMSOnline/topin/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['SMSOnline']['topin']['info']))));
			
			
			XMLDocument::setData('//data/pay/LiqPAY/isSwitch',(int)$data_ar['pay']['LiqPAY']['isSwitch']);
			XMLDocument::setData('//data/pay/LiqPAY/merchant_id',strip_tags($data_ar['pay']['LiqPAY']['merchant_id']));
			XMLDocument::setData('//data/pay/LiqPAY/signature',strip_tags($data_ar['pay']['LiqPAY']['signature']));
			XMLDocument::setData('//data/pay/LiqPAY/currency',$data_ar['pay']['LiqPAY']['currency']);
			XMLDocument::setData('//data/pay/LiqPAY/vip/amount',(double)$data_ar['pay']['LiqPAY']['vip']['amount']);
			XMLDocument::setData('//data/pay/LiqPAY/style/amount',(double)$data_ar['pay']['LiqPAY']['style']['amount']);
			XMLDocument::setData('//data/pay/LiqPAY/topin/amount',(double)$data_ar['pay']['LiqPAY']['topin']['amount']);

			
			XMLDocument::setData('//data/pay/INTERKASSA/isSwitch',(int)$data_ar['pay']['INTERKASSA']['isSwitch']);
			XMLDocument::setData('//data/pay/INTERKASSA/ik_shop_id',strip_tags($data_ar['pay']['INTERKASSA']['ik_shop_id']));
			XMLDocument::setData('//data/pay/INTERKASSA/secret_key',strip_tags($data_ar['pay']['INTERKASSA']['secret_key']));
			XMLDocument::setData('//data/pay/INTERKASSA/vip/amount',(double)$data_ar['pay']['INTERKASSA']['vip']['amount']);
			XMLDocument::setData('//data/pay/INTERKASSA/vip/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['INTERKASSA']['vip']['info']))));
			XMLDocument::setData('//data/pay/INTERKASSA/style/amount',(double)$data_ar['pay']['INTERKASSA']['style']['amount']);
			XMLDocument::setData('//data/pay/INTERKASSA/style/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['INTERKASSA']['style']['info']))));
			XMLDocument::setData('//data/pay/INTERKASSA/topin/amount',(double)$data_ar['pay']['INTERKASSA']['topin']['amount']);
			XMLDocument::setData('//data/pay/INTERKASSA/topin/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['INTERKASSA']['topin']['info']))));
			
			
			XMLDocument::setData('//data/pay/WebMoney/isSwitch',(int)$data_ar['pay']['WebMoney']['isSwitch']);
			XMLDocument::setData('//data/pay/WebMoney/isTesting',(int)$data_ar['pay']['WebMoney']['isTesting']);
			XMLDocument::setData('//data/pay/WebMoney/lmi_secret_key',strip_tags($data_ar['pay']['WebMoney']['lmi_secret_key']));
			XMLDocument::setData('//data/pay/WebMoney/currency',strip_tags($data_ar['pay']['WebMoney']['currency']));
			XMLDocument::setData('//data/pay/WebMoney/wallet',strip_tags($data_ar['pay']['WebMoney']['wallet']));
			XMLDocument::setData('//data/pay/WebMoney/vip/amount',(double)$data_ar['pay']['WebMoney']['vip']['amount']);
			XMLDocument::setData('//data/pay/WebMoney/vip/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['WebMoney']['vip']['info']))));
			XMLDocument::setData('//data/pay/WebMoney/style/amount',(double)$data_ar['pay']['WebMoney']['style']['amount']);
			XMLDocument::setData('//data/pay/WebMoney/style/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['WebMoney']['style']['info']))));
			XMLDocument::setData('//data/pay/WebMoney/topin/amount',(double)$data_ar['pay']['WebMoney']['topin']['amount']);
			XMLDocument::setData('//data/pay/WebMoney/topin/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['WebMoney']['topin']['info']))));
			
			XMLDocument::setData('//data/pay/Robokassa/isSwitch',(int)$data_ar['pay']['Robokassa']['isSwitch']);
			XMLDocument::setData('//data/pay/Robokassa/isTesting',(int)$data_ar['pay']['Robokassa']['isTesting']);
			XMLDocument::setData('//data/pay/Robokassa/login',strip_tags($data_ar['pay']['Robokassa']['login']));
			XMLDocument::setData('//data/pay/Robokassa/pass1',$data_ar['pay']['Robokassa']['pass1']);
			XMLDocument::setData('//data/pay/Robokassa/pass2',$data_ar['pay']['Robokassa']['pass2']);
			XMLDocument::setData('//data/pay/Robokassa/vip/amount',(double)$data_ar['pay']['Robokassa']['vip']['amount']);
			XMLDocument::setData('//data/pay/Robokassa/vip/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['Robokassa']['vip']['info']))));
			XMLDocument::setData('//data/pay/Robokassa/style/amount',(double)$data_ar['pay']['Robokassa']['style']['amount']);
			XMLDocument::setData('//data/pay/Robokassa/style/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['Robokassa']['style']['info']))));
			XMLDocument::setData('//data/pay/Robokassa/topin/amount',(double)$data_ar['pay']['Robokassa']['topin']['amount']);
			XMLDocument::setData('//data/pay/Robokassa/topin/info',htmlspecialchars(strip_tags(trim($data_ar['pay']['Robokassa']['topin']['info']))));
			
			XMLDocument::save();
		}		
	}
}