<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Subscribe" модуля "Доска объявлений"
 */

class Modules_Board_Models_Subscribe extends Guard_Model
{
	/**
	 * Возвращает данные подписки по ее id
	 *
	 * @param int $sb_id id подписчика
	 * @return object
	 */
	public function getSubscribeById($sb_id=0)
	{
		return parent::getDataById("mod_board_subscribe","sb_id",((int)$sb_id),"Не удалось получить данные подписки");
	}
	
	/**
	 * Возвращает список подписчиков с учетом лимита
	 *
	 * @param int $ls начало лимита
	 * @param int $lf конец лимита
	 * @return array
	 */
	public function getSubscribeByLimit($ls=0,$lf=30)
	{
		$sql = "SELECT * FROM 
			`#__mod_board_subscribe`
				ORDER BY 
			`sb_date` DESC
				LIMIT $ls,$lf";
				
		return parent::sqlToArray($sql, 'sb_id', 'Не удалось получить список подписчиков');
	}

	/**
	 * Получаем список активных подписчиков
	 *
	 * @return array массив объектов подписчиков
	 */
	public function getListSubscriberByActive($sb_active=0)
	{
		$sql = "SELECT * FROM 
			`#__mod_board_subscribe`
				WHERE 
			`sb_active`='".((int)$sb_active)."'";
		
		return parent::sqlToArray($sql, 'sb_id', 'Не удалось получить список активированных подписчиков');
	}
	
	/**
	 * Количество подписчиков
	 *
	 * @return string
	 */
	public function getCountSubscribe()
	{
		return parent::getCountData("mod_board_subscribe","sb_id","Не удалось определить количество подписчиков");
	}
	
	/**
	 * Возвращает id последней подписки 
	 *
	 * @return int
	 */
	public function getLastIdSubscribe()
	{
		return parent::getLastId(); 
	}
	
	/**
	 * Добавляе подписчика в БД
	 *
	 * @param string $sb_email почтовый ящик подписчика
	 * @param int $sb_active активирован пользователь или нет
	 */
	public function addSubscribe($sb_email=null,$sb_active=0)
	{
		$sql = "INSERT INTO `#__mod_board_subscribe`
			(`sb_email` , `sb_active`,`sb_date`)
				VALUES 
			('".mysql_real_escape_string($sb_email)."', '".((int)$sb_active)."','".time()."')";
		
		$this -> DB -> setQuery($sql,"Во время сохранения данных возникла ошибка");
	}
	
	/**
	 * Обновляет состояние подписки
	 *
	 * @param int $ab_id id подписки
	 * @param int $sb_active состояние подписки, активирована (1) или нет (0)
	 */
	public function updateSbActiveById($sb_id=0,$sb_active=0)
	{
		$sql = "UPDATE `#__mod_board_subscribe` 
				SET 
			`sb_active`='".((int)$sb_active)."' 
				WHERE 
			`sb_id`='".((int)$sb_id)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось обновисть состояние подписки");
	}
	
	/**
	 * Удаляет подписчика с БД
	 *
	 * @param int $sb_id id подписчика
	 */
	public function deteteSubscribeById($sb_id=0)
	{
		parent::deleteDataById("mod_board_subscribe","sb_id",((int)$sb_id),"Во время удаления подписки возникла ошибка");
	}
	
	/**
	 * Провермяем наличие почтового ящика в БД
	 *
	 * @param string $sb_email почтовый ящик подписчика
	 * @return int есть (1) или нет (0) почтового ящика в таблице БД
	 */
	public function isExistsEmail($sb_email=null)
	{
		$SubData = parent::getDataById("mod_board_subscribe","sb_email",mysql_escape_string($sb_email),"Не удалось получить данные подписки");
		
		$count = 1;
		try
		{
			CheckData::existsDataObject($SubData);
		}
		catch (Exception_CheckData $e)
		{
			$count = 0;
		}

		return $count;
	}
}