<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "City"
 */

class Modules_City_Controllers_Admin extends Guard_Controller
{
	/**
	 * Отображает список городов
	 *
	 */
	public function indexAction()
	{
		Factory::zebra();
		$this -> view -> Cityes = parent::getModel() -> getCityes();
	}
	
	
	/**
	 * Создает город
	 *
	 */
	public function addAction()
	{
		if(Request::isPost())
		{
			try
			{
				//Создаем город
				parent::getModel() -> createCity(
					Request::getPost('cat_title'),
					Request::getPost('cat_order')
				);
			}
			catch(Exception_CheckData $e)
			{
				throw new Exception_Message($e -> getMessage(),1);
			}		
			parent::redirect(Lng::_("TRUE:Город успешно создан"));
		}

		//View
		$this -> view -> form_action = "admin.php?mod=city&go=add";
	}
	
	
	/**
	 * Редактирует город
	 *
	 */
	public function editAction()
	{
		//Set view


		parent::setView('./modules/city/views/admin/add.phtml');
		
		//Sets
		$city_id = Request::getGet('city_id','int');
		
		if(Request::isPost())
		{
			try
			{
				//Обновляем данные города
				parent::getModel() -> updateCityById(
					$city_id,
					Request::getPost('cat_title'),
					Request::getPost('cat_order')
				);
			}
			catch(Exception_CheckData $e)
			{
				throw new Exception_Message($e -> getMessage(),1);
			}
			parent::redirect(Lng::_("TRUE:Город успешно отредактирован"),"admin.php?mod=city&go=edit&city_id=".$city_id);
		}
		
		//Get

		$CategoryData = parent::getModel() -> getCityById($city_id);

		//View
		$this -> view -> form_action = "admin.php?mod=city&go=edit&city_id=".$CategoryData -> cat_id;
		$this -> view -> cat_title = $CategoryData -> cat_title;

	}
	
	/**
	 * Удаляет город
	 *
	 */
	public function deleteAction()
	{
		try
		{
			parent::getModel() -> deleteCityById(Request::getGet('city_id','int'));
		}
		catch(Exception_CheckData $e)
		{
			throw new Exception_Message($e -> getMessage(),1);
		}
		parent::redirect(Lng::_("TRUE:Город успешно удален"),"admin.php?mod=city");
	}
}