<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "City"
 */

class Modules_City_Models_City extends Models_Category
{
	public function __construct()
	{
		parent::__construct("city");
	}
	
	/**
	 * Возвращает данные города по его id ($city_id)
	 *
	 * @param int $city_id
	 * @return object
	 */
	public function getCityById($city_id = 0)
	{
		return parent::getDataById($city_id);
	}

	/**
	 * Возвращает данные города по его названию ($city_title)
	 *
	 * @param string $city_title
	 * @return object
	 */
	public function getCityByTitle($city_title = NULL)
	{
		return parent::getDataByTitle($city_title);
	}
	
	/**
	 * Выполняет поиск городов
	 *
	 * @param string $city_title название города
	 * @return string
	 */
	public function searchCityByTitle($city_title = NULL)
	{
		return parent::searchDataBy("cat_title",$city_title."%");
	}
	
	/**
	 * Возвращает список городов
	 *
	 * @return array
	 */
	public function getCityes()
	{
		return parent::getListData();
	}
	
	/**
	 * Возвращает список городов
	 *
	 * @return array
	 */
	public function getListCityes()
	{
		$CityesAr =  parent::getListData();
		$city_ar = array();
		foreach ($CityesAr as $City)
		{
			$city_ar[$City -> cat_id] = $City -> cat_title;
		}
		
		return $city_ar;
	}

	/**
	 * Возвращает количество городов
	 *
	 * @return int
	 */
	public function countCityes()
	{
		return parent::getCountData('sys_category', 'cat_id');
	}
	
	/**
	 * Создает город
	 *
	 * @param string $cat_title
	 * @param int $cat_order
	 */
	public function createCity($cat_title, $cat_order)
	{
		parent::insertData(0, strip_tags($cat_title), NULL, NULL, NULL, NULL, NULL, NULL, NULL, $cat_order);
	}
	
	
	/**
	 * Обновляет данные города
	 *
	 * @param int $cat_id
	 * @param string $cat_title
	 * @param int $cat_order
	 */
	public function updateCityById($cat_id, $cat_title, $cat_order)
	{
		parent::updateData($cat_id, 0, strip_tags($cat_title), NULL, NULL, NULL, NULL, NULL, NULL, NULL, $cat_order);
	}
	
	/**
	 * Удаляет категорию по ее id
	 *
	 * @param int $city_id
	 */
	public function deleteCityById($city_id = 0)
	{
		parent::deleteById($city_id);
	}
}