<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер формы обратной связи, для гостя
 */

class Modules_Feedback_Controllers_Index extends Guard_Controller
{
	/**
	 * Отображаем форму обратной связи
	 *
	 */
	public function indexAction()
	{
		if(Request::isPost())
		{
			//Установка данных по умолчанию
			$is_error = FALSE;
			
			//Первоначальная установка данных
			$name = Request::getPost('name',array(
				'strip_tags',
				'Security::xssClean'
			));
			$email = Request::getPost('email');
			$title = Request::getPost('title',array(
				'strip_tags',
				'Security::xssClean'
			));
			$message = Request::getPost('message',array(
				'strip_tags',
				'Security::xssClean'
			));
			
			$this -> view -> name 		= $name;
			$this -> view -> email 		= $email;
			$this -> view -> title 		= $title;
			$this -> view -> message 	= $message;
			
			if(isset($_POST['check_access']) == FALSE || CheckData::captcha($_POST['check_access']) == FALSE)
			{
				parent::setMessage(Lng::_('FALSE:Неправильно введен защитный код'));
				$is_error = TRUE;
			}
			if($message == FALSE)
			{
				parent::setMessage(Lng::_('FALSE:Вы не заполнили обязательное поле "письмо"'));
				$is_error = TRUE;
			}
			try
			{
				CheckData::email($email);
			}
			catch (Exception_CheckData $e)
			{
				parent::setMessage(Lng::_('FALSE:Не правильно введен почтовый ящик'));
				$is_error = TRUE;
			}
			if($is_error == FALSE)
			{
				//Получаем конфигурационные данные
				$Config = Registry::get("Config");
				
				$Phtml = parent::getTemplate("mail");
				$Phtml -> name 			= $name;
				$Phtml -> email 		= $email;
				$Phtml -> message 		= nl2br($message);
				$Phtml -> site_title 	= $Config -> site -> title;
				
				if(Mail::sendMail($name, $email, $Config -> contacts -> admin, $Config -> contacts -> email, $title, $Phtml -> getView()))
				{
					parent::redirect(Lng::_("TRUE:Письмо отправлено. Очень скоро мы с Вами свяжемся"));
				}
				else
				{
					parent::setMessage(Lng::_('FALSE:Не удалось отправить письмо'));
				}
			}
		}
		
		//Устанавливаем заголовок
		Site::setSkinVar("title",Lng::_('Форма обратной связи'));
	}
}