<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер новостной ленты
 */

class Modules_News_Controllers_Admin extends Guard_Controller
{
	/**
	 * Расширения изображений допустимых для загрузки
	 *
	 * @var unknown_type
	 */
	private static $upload_extensions_ar = array('jpg', 'jpeg', 'png', 'gif');
	
	/**
	 * Расширения изображений допустимых для загрузки (для вида)
	 *
	 */
	const UPLOAD_EXTENSIONS_VIEW = '*.jpg; *.jpeg; *.png; *.gif';
	
	/**
	 * Размер изображения для ресайза
	 *
	 */
	const IMG_RESIZE = 125;
	
	/**
	 * Масимально допустимый файл для загрузки в килобайтах
	 *
	 */
	const UPLOAD_MAX_SIZE = 1024;
	
	/**
	 * Масимально допустимый файл для загрузки в мегабайтах (для вида) 
	 *
	 */
	const UPLOAD_MAX_SIZE_VIEW = '1 мб.';
	
	/**
	 * Отображает список статей
	 *
	 */
	public function indexAction()
	{

		//Sets
		$on_page = 30;

		$page = BreakPage::getPageNum();
		
		Factory::zebra();
		$this -> view -> Articles = parent::getModel("News","News") -> getListArticlesByLimit((($page-1)*$on_page),$on_page);
		$this -> view -> breakpage = BreakPage::getPages(parent::getModel("News","News") -> countArticles(),$on_page,$page,"admin.php?mod=news&page=");
	}

	/**
	 * Добавляет новую статью
	 *
	 */
	public function addAction()
	{
		if(Request::isPost())
		{
			//Сохраняем основные данные статьи
			parent::getModel("News","News") -> addArticle(
				Request::getPost("nw_title"),

				Request::getPost("nw_meta_title"),
				Request::getPost("nw_meta_keywords"),
				Request::getPost("nw_meta_description"),
				Request::getPost("nw_author"),

				Request::getPost("nw_content"),
				Request::getPost("nw_is_comment","int",0),
				Str::convertDateToTimestamp(Request::getPost("nw_date_create"))
			);
											  
			if(Request::isFileUpload('nw_img_preview') == TRUE)
			{
				$rows_ar = array(


					'nw_img_preview' => $this -> _uploadFile(),
				);
				
				//Уменьшаем изображение
		    	$Image = Helper_Image::factory(Modules_News_Controllers_Index::PATH_DIR_NORMAL.$rows_ar['nw_img_preview']);
			   	if($Image -> width > Modules_News_Controllers_Admin::IMG_RESIZE)
		    	{
		    		$Image -> resize(Modules_News_Controllers_Admin::IMG_RESIZE);
		    	}
		    	$Image -> save(Modules_News_Controllers_Index::PATH_DIR_NORMAL.$rows_ar['nw_img_preview']);
				
				//Обновляем данные изображения
				parent::getModel("News","News") -> updateRowsArticle(
					parent::getModel("News","News") -> getLastId(),
					$rows_ar
				);
			}
			
			parent::redirect(Lng::_("TRUE:Статья сохранена"));
		}
		
		//View
		Element_Datepicker::get("#nw_date_create");
		Element_Wysiwyg::get(array(
			'id' => '#nw_content'
		));
		



		$this -> view -> page_title = Lng::_('Создание статьи');
		$this -> view -> form_action= "admin.php?mod=news&go=add";
		$this -> view -> nw_date_create 	= Str::dateD();
	}
	
	/**
	 * Редактирует статью
	 *
	 */
	public function editAction()
	{

		//View
		parent::setView('./modules/news/views/admin/add.phtml');
		

		//Sets
		$nw_id = Request::getGet("nw_id","int");
		
		if(Request::isPost())
		{
			$rows_ar = array(
				'nw_title'				=> mysql_real_escape_string(Request::getPost("nw_title")),
				'nw_meta_title' 		=> mysql_real_escape_string(Request::getPost("nw_meta_title")),
				'nw_meta_keywords'		=> mysql_real_escape_string(Request::getPost("nw_meta_keywords")),
				'nw_meta_description'	=> mysql_real_escape_string(Request::getPost("nw_meta_description")),
				'nw_author' 			=> mysql_real_escape_string(Request::getPost("nw_author")),
				'nw_content' 			=> mysql_real_escape_string(Request::getPost("nw_content")),
				'nw_is_comment' 		=> Request::getPost("nw_is_comment","int"),
				'nw_date_create' 		=> Str::convertDateToTimestamp(Request::getPost("nw_date_create")),
			);
			








			if(Request::isFileUpload('nw_img_preview') == TRUE)
			{
				//Загуржаем фото
				$rows_ar['nw_img_preview'] = $this -> _uploadFile();
				
				//Уменьшаем изображение
		    	$Image = Helper_Image::factory(Modules_News_Controllers_Index::PATH_DIR_NORMAL.$rows_ar['nw_img_preview']);
			   	if($Image -> width > Modules_News_Controllers_Admin::IMG_RESIZE)
		    	{
		    		$Image -> resize(Modules_News_Controllers_Admin::IMG_RESIZE);
		    	}
		    	$Image -> save(Modules_News_Controllers_Index::PATH_DIR_NORMAL.$rows_ar['nw_img_preview']);
			}
			
			//Обновляем данные статьи
			parent::getModel("News","News") -> updateRowsArticle($nw_id, $rows_ar);
			
			parent::redirect(Lng::_("TRUE:Статья отредактирована"),"admin.php?mod=news&go=edit&nw_id=".$nw_id);
		}

		


		//Get
		$Article = parent::getModel("News","News") -> getArticle($nw_id);
		
		//View
		Element_Datepicker::get("#nw_date_create");
		Factory::fancyBox('a.nw_img_preview');
		Element_Wysiwyg::get(array(
			'id' => '#nw_content'
		));
		
		$this -> view -> addToView($Article);
		$this -> view -> page_title		= Lng::_('Редактирование статьи');
		$this -> view -> form_action	= "admin.php?mod=news&go=edit&nw_id=".$nw_id;
		$this -> view -> nw_date_create = Str::dateD($Article -> nw_date_create);
	}
	
	/**
	 * Удаляет статью
	 *
	 */
	public function deleteAction()
	{
		try
		{
			$nw_id = Request::getGet("nw_id","int");

			//Получаем данные статьи
			$News = parent::getModel("News","News") -> getArticle($nw_id);
			
			//Удаляем данные изображения
			File::deleteFile(Modules_News_Controllers_Index::PATH_DIR_NORMAL.$News -> nw_img_preview);
			
			parent::getModel("News","News") -> deleteArticle($nw_id);
			$redirect = Lng::_("TRUE:Статья удалена");
		}
		catch(Exception_DB $e)
		{
			$redirect = Lng::_('FALSE:Во время удаления статьи возникла ошибка');	
		}
		parent::redirect($redirect,"admin.php?mod=news");
	}
	

	/**
	 * Удаляем изображение статьи
	 *
	 */
	public function deleteimgAction()
	{
		$nw_id = Request::getGet("nw_id","int");
		
		//Получаем данные статьи
		$News = parent::getModel("News","News") -> getArticle($nw_id);
		
		//Удаляем данные изображения
		File::deleteFile(Modules_News_Controllers_Index::PATH_DIR_NORMAL.$News -> nw_img_preview);
		
		//Обновляем данные изображения в БД
		parent::getModel("News","News") -> updateRowsArticle($nw_id,array("nw_img_preview"=>""));
		
		parent::redirect(Lng::_("TRUE:Изображение удалено"),"admin.php?mod=news&go=edit&nw_id=".$nw_id);	
	}
	
	/********************************************************************************************************************/
	/************************************************* PRIVATE METHODS **************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Загружает файл на сервер
	 *
	 */
	private function _uploadFile()
	{
		$UploadFile = new UploadFile($_FILES['nw_img_preview']);
		$UploadFile -> setFileName(uniqid().".");
		$UploadFile -> setFileExtensions(Modules_News_Controllers_Admin::$upload_extensions_ar);
		$UploadFile -> setFileByte(0, Modules_News_Controllers_Admin::UPLOAD_MAX_SIZE);
		$UploadFile -> setFilePx(1600, 1600);
		$UploadFile -> setFilePath(Modules_News_Controllers_Index::PATH_DIR_NORMAL);
		
		return $UploadFile -> upload();
	}
}