<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель новостной ленты
 */

class Modules_News_Models_News extends Guard_Model
{
	/**
	 * Возвращает содержимое статьи
	 *
	 * @param int $nw_id id статьи
	 */
	public function getArticle($nw_id = 0)
	{
		return parent::getDataById("mod_news","nw_id",((int)$nw_id),"Не удалось получить данные статьи");
	}
	
	/**
	 * Возвращает список из N последних новостей
	 *
	 * @param int $ls
	 * @param int $lf
	 * @return array
	 */
	public function getArticlesIndexList($ls = 0, $lf = 10)
	{
		$sql = "SELECT `nw_id`, `nw_title`, `nw_content`, `nw_date_create` 
				FROM 
			`#__mod_news` 
				ORDER BY 
			`nw_date_create` DESC 
				LIMIT $ls,$lf";
		
		return parent::sqlToArray($sql,"nw_id","Не удалось получить статьи");
	}
	
	/**
	 * Возвращает список всех статей для гостя
	 *
	 * @return array
	 */
	public function getListArticlesByLimit($ls = 0, $lf = 10)
	{
		$sql = "SELECT `nw_id`, `nw_title`, `nw_img_preview`, `nw_content`, `nw_author`, `nw_is_comment`, `nw_date_create` 
				FROM 
			`#__mod_news` 
				ORDER BY 
			`nw_date_create` DESC 
				LIMIT $ls,$lf";
		
		return parent::sqlToArray($sql,"nw_id","Не удалось получить статьи");
	}
	
	/**
	 * Возвращает количество статей
	 *
	 * @return int
	 */
	public function countArticles()
	{
		return parent::getCountData("mod_news","nw_id","Не удалось определить количество статей");		
	}


	/**
	 * Добавляет статью
	 *







	 */
	public function addArticle($nw_title, $nw_meta_title, $nw_meta_keywords, $nw_meta_description, $nw_author, $nw_content, $nw_is_comment, $nw_date_create)
	{
		$this -> DB -> setQuery(
			"INSERT INTO `#__mod_news` 

			(
			`nw_title`,
			`nw_meta_title`,
			`nw_meta_keywords`,
			`nw_meta_description`,
			`nw_author`,
			`nw_content`,
			`nw_is_comment`,
			`nw_date_create`
			)
				VALUES
			('".mysql_real_escape_string($nw_title)."',

			 '".mysql_real_escape_string($nw_meta_title)."',
			 '".mysql_real_escape_string($nw_meta_keywords)."',
			 '".mysql_real_escape_string($nw_meta_description)."',
			 '".mysql_real_escape_string($nw_author)."',
			 '".mysql_real_escape_string($nw_content)."',
			 '".intval($nw_is_comment)."',
			 '".mysql_real_escape_string($nw_date_create)."')",

		"Не удалось сохранить статью");
	}
	
	/**
	 * Обновляем данные статьи
	 *
	 * @param int $nw_id
	 * @param array $rows_ar
	 */
	public function updateRowsArticle($nw_id = 0, $rows_ar = array())
	{
		parent::updateSomeRowById("mod_news","nw_id",$nw_id,$rows_ar,"Во время удаления статьи возникла ошибка");
	}
	
	/**
	 * Удаляет статью
	 *
	 * @param int $nw_id id статьи
	 */
	public function deleteArticle($nw_id = 0)
	{
		parent::deleteDataById("mod_news","nw_id",((int)$nw_id),"Во время удаления статьи возникла ошибка");
	}
}