<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Pageh", для формирования sitemap.xml файла
 */

class Modules_Page_Controllers_Sitemap extends Guard_Base
{
	/**
	 * Возвращает элементы для формирования sitemap.xml файла
	 *
	 * @return array
	 */
	public function getElements()
	{
		$data_ar = array();
		
		$pages_ar = parent::getModel("Page","Page") -> getAllPage();
		foreach($pages_ar AS $Page)
		{
			$data_ar[$Page -> pg_id] = array("changefreq" => "monthly", "priority" => "0.5", "lastmod" => date("Y-m-d",$Page -> pg_date_create), "additional_ar" => array("#pg_title" => $Page -> pg_title));
		}

		return $data_ar;
	}
	
	/**
	 * Формирует часть sitemap.xml файла
	 *
	 * @param array $data_ar данные
	 */
	public function formedSitemapFile($data_ar=array())
	{
		$host = URL::getHost()."/";
		$c  = "";

		foreach($data_ar AS $pg_id => $pg_ar)
		{
			if($pg_ar['priority'] == "-"){continue;}
							
			$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=page&pg_id=".$pg_id,$pg_ar['#pg_title']),$pg_ar['lastmod'],$pg_ar['changefreq'],$pg_ar['priority']);
		}
		
		return $c;
	}
}