<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "SEO", для админа
 */

class Modules_SEO_Controllers_Admin extends Guard_Controller
{
	/**
	 * Отображаем страницу с модулями которые поддерживают создание 
	 *
	 */
	public function indexAction()
	{
		//Формируем меню
		$this -> _menubar();
		
		if(Request::isPost())
		{
			Site::setTimeLimit(0);
			
			parent::getModel("Sitemap","SEO") -> createSitemapFile($this -> view -> Modules, Request::post());
			parent::redirect(Lng::_("TRUE:Файл sitemap.xml обновлен"));
		}
		 $params = "changeMonth: true, 
					changeYear: true, 
					showOn: 'button', 
					dateFormat: 'yy-mm-dd',
					buttonImageOnly: true ";
		
 		//Подключаем элемент Datepicker
		Element_Datepicker::get(".el_date",$params);

		//Получаем массив элементов модуля для формирования sitemap.xml файла
		$this -> view -> elements_ar = parent::getModel("Sitemap","SEO") -> getElements($this -> view -> Modules);
		
		if (isset ($this -> view -> elements_ar ['users']))
		unset ($this -> view -> elements_ar ['users']);
	}
	
	/**
	 * Редактирование файла robots.txt 
	 *
	 */
	public function editrobotsAction()
	{
		if(Request::isPost())
		{
			try
			{
				parent::getModel("Robots","SEO") -> setData(Request::getPost("text"));
			}
			catch(Exception $e)
			{
				parent::redirect(Lng::_('FALSE:Во время сохранения файла robots.txt возникла ошибка'));
			}
			parent::redirect(Lng::_("TRUE:Файл robots.txt сохранен"));
		}
		//Формируем меню
		$this -> _menubar();
		
		$this -> view -> text = parent::getModel("Robots","SEO") -> getData();
	}

	/**
	 * Редактирование Мета-тегов
	 *
	 */
	public function editmetatagsAction()
	{
		//Модуль, мета-теги которого мы редактируем
		$module = Request::getGet("module");
		
		if(Request::getPost("sub_save","bool",false))
		{
			parent::getModel("MetaTags","SEO") -> setData(Request::getGet("module"), Request::post());
			parent::redirect(Lng::_("TRUE:Мета-теги сохранены"),"admin.php?mod=seo&go=editmetatags&module=".$module);
		}
		
		//Формируем меню
		$this -> _menubar();
		
		Factory::zebra();
		$this -> view -> form_action = "admin.php?mod=seo&go=editmetatags&module=".$module;
		$this -> view -> module = $module;
		$this -> view -> Metatags = parent::getModel("MetaTags","SEO") -> getData($module);
	}
	
	/**
	 * Формируем меню модуля
	 *
	 */
	private function _menubar()
	{
		$this -> view -> Modules = Registry::get("Modules");
		
		//Формируем меню
		Element_Menu::get(".skin-submenubar");
	}
}