<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "MetaTags" модуля "SEO"
 */

class Modules_SEO_Models_MetaTags extends Guard_Model
{
	/**
	 * Возвращает объект XML модуля мета-тегов
	 *
	 * @param string $module модуль
	 * @return object
	 */
	public function getData($module=null)
	{
		if(is_file("./files/db/models/".$module."/metatags.xml"))
		{
			return XML::getObj("./files/db/models/".$module."/metatags.xml");
		}
		return false;
	}
	
	/**
	 * Сохраняет данные метатегов
	 *
	 * @param string $module модуль
	 * @param array $post массив POST данных
	 */
	public function setData($module=null,$post=array())
	{
		if(is_file("./files/db/models/".$module."/metatags.xml"))
		{
			$Metatags = XML::getObj("./files/db/models/".$module."/metatags.xml");
			foreach ($Metatags as $Metatag)
			{
				$name = (string)$Metatag['name'];
				if(isset($post[$name]))
				{
					if(isset($post[$name]['keywords']))
					{
						$Metatag -> keywords = trim(strip_tags($post[$name]['keywords']));
					}
					if(isset($post[$name]['description']))
					{
						$Metatag -> description = trim(strip_tags($post[$name]['description']));
					}
				}
			}
			XML::save();
		}
	}
}