<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Sitemap" модуля "SEO"
 */

class Modules_SEO_Models_Sitemap extends Guard_Model
{
	/**
	 * Возвращает массив форм
	 *
	 * @param object $Modules
	 * @return array
	 */
	public function getElements($Modules=null)
	{
		$elements_ar = array();
		foreach($Modules as $name => $Module)
		{
			if(is_file("./modules/".$name."/controllers/sitemap.php"))
			{
				$class_name = "Modules_".$name."_Controllers_Sitemap";
				$Sitemap = new $class_name();
				$elements_ar[$name] = $Sitemap -> getElements(); 
			}
		}
		return $elements_ar;
	}
	
	/**
	 * Создает sitemap.xml файл
	 *
	 * @param object $Modules
	 * @param array $post
	 */
	public function createSitemapFile($Modules=null,$post=array())
	{
		$file  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		$file .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
		
		foreach($Modules as $name => $Module)
		{
			if(isset($post['sys:module'][$name]))
			{
				if(is_file("./modules/".$name."/controllers/sitemap.php"))
				{
					$class_name = "Modules_".$name."_Controllers_Sitemap";
					$Sitemap = new $class_name();
					$file .= $Sitemap -> formedSitemapFile($post[$name]); 
				}
			}
		}
		$file .= "</urlset>";
		
		//Сохраняем файл
		File::write("./sitemap.xml",$file, NULL, TRUE);
		
		$zp_rf = gzopen('sitemap.xml.gz', 'w9');
		gzwrite($zp_rf, $file);
		gzclose($zp_rf);
	}
}