<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Users", для админа
 */

class Modules_Users_Controllers_Admin extends Guard_Controller
{
	private $us_on_page = 30;
	
	/**
	 * Отображает список пользователей
	 *
	 */
	public function indexAction()
	{
		$page = BreakPage::getPageNum();
		
		//--> Формируем вид
		Factory::zebra();
		$this -> view -> Users = parent::getModel() -> getUsers((($page-1)*$this -> us_on_page),$this -> us_on_page);
		$this -> view -> breakpage = BreakPage::getPages(parent::getModel() -> countUsers(),$this -> us_on_page,$page,"admin.php?mod=users&page=");
		$this -> view -> num = ($page-1)*$this -> us_on_page;
	}
	
	/**
	 * Редактирует профиль пользователя
	 *
	 */
	public function editAction()
	{
		//Первоначальная установка данных
		$us_id = Request::getGet("us_id","int");
		
		try
		{
			if(Request::isPost())
			{
				//Проверяем длину ИМЕНИ
				if(!$_POST['name'] || Str::strlen($_POST['name']) <= 1)
				{
					parent::setMessage(Lng::_('FALSE:Длина "имени" не может быть меньше двух символов'));
					throw new Exception();
				}
				//Если пользователь захотел изменить ПАРОЛЬ
				if($_POST['password1'])
				{
					//Проверяем длину ПАРОЛЯ
					if(strlen($_POST['password1']) < 6)
					{
						parent::setMessage(Lng::_('FALSE:Пароль должен быть больше пяти символов'));
						throw new Exception();
					}
					if($_POST['password1'] != $_POST['password2'])
					{
						parent::setMessage(Lng::_('FALSE:Вы не правильно подтвердили "пароль"'));
						throw new Exception();
					}
				}
				//Проверяем правильность формата EMAIL
				try
				{
					CheckData::email($_POST['email']);
				}
				catch (Exception_CheckData $e)
				{
					parent::setMessage(Lng::_('FALSE:E-mail введен в не правильном формате'));
					throw new Exception();
				}
				
				//Получаем данные пользователя
				$User = $this -> getModel() -> getUserByEmail($_POST['email']);
				
				if(is_object($User) == TRUE)
				{
					if ($User -> us_email == $_POST['email'] && $User -> us_id != $us_id)
					{
						parent::setMessage(Lng::_('FALSE:Пользователь с указанным почтовым ящиком уже зарегистрирован. Выберете другой email для регистрации.'));
						throw new Exception();						
					}
				}
				
				//Обновляем данные ПОЛЬЗОВАТЕЛЯ в БД
				parent::getModel() -> updateUserDataByUsId(
					$us_id, 
					$_POST['name'], 
					$_POST['password1'], 
					$_POST['email'],
					$_POST['role']
				);

				parent::redirect(Lng::_("TRUE:Учетная запись пользователя отредактирована"),"admin.php?mod=users&go=edit&us_id=".$us_id);
			}
		}
		catch (Exception $e)
		{
			if($e -> getMessage())
			{
				throw new Exception_Message($e -> getMessage(),1);
			}
		}
		
		//Получаем данные пользователя
		$UserData = parent::getModel() -> getUserById($us_id);

		if(is_object($UserData) == FALSE)
		{
			throw new Exception_440('Выбранный Вами пользователь отсутствует');
		}
		
		$this -> view -> us_id 		= $UserData -> us_id;
		$this -> view -> us_name 	= $UserData -> us_name; 
		$this -> view -> us_email 	= $UserData -> us_email; 
		$this -> view -> us_role 	= $UserData -> us_role; 
	}
	
	/**
	 * Удаляет пользователя
	 *
	 */
	public function deleteAction()
	{
		//Удаляем пользователя с БД
		parent::getModel() -> updateDeleteUserById(Request::getGet("us_id","int"));
		parent::redirect(Lng::_("TRUE:Пользователь удален"),"admin.php?mod=users");
	}
	
	/**
	 * Активация, в бан, с бана пользователя
	 *
	 */
	public function activeAction()
	{
		parent::getModel() -> updateUserActiveByUsId(
			Request::getGet("us_id","int"), 
			Request::getGet("active","int")
		);
		
		if($_GET['active'])
		{
			parent::redirect(Lng::_("TRUE:Пользователь удален с банлиста"),"admin.php?mod=users");
		}
		else if(!$_GET['active'])
		{
			parent::redirect(Lng::_("TRUE:Пользователь помещен в банлист"),"admin.php?mod=users");
		}
	}
}