<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Users", для гостя
 */

class Modules_Users_Controllers_Index extends Guard_Controller
{
	/**
	 * Отображает страницу авторизации
	 *
	 */
	public function indexAction()
	{
		if(User::isAuth() == FALSE)
		{
			if(Request::isPost() == TRUE)
			{
				//Получаме данные пользователя по логину и паролю
				$UserData = $this -> getModel() -> getUserByEmailPassword($_POST['us_email'], $_POST['us_password']);
				try
				{
					CheckData::existsDataObject($UserData);
				}
				catch (Exception_CheckData $e)
				{
					parent::redirect(Lng::_('FALSE:Не правильно введен логин или пароль'));
				}
				if($UserData -> us_role == User::ROLE_DELETE)
				{
					parent::redirect(Lng::_('FALSE:Вы не можете войти. Ваша учетная запись удалена'));
				}
				if($UserData -> us_role == User::ROLE_BANNED)
				{
					parent::redirect(Lng::_('FALSE:Вам запрещено посещать сайт, потому что вы помещены в банлист'));
				}
				//Устанавливаем данные пользователя в сессии
				User::set($UserData);
				
				if($UserData -> us_role == User::ROLE_ADMIN)
				{
					URL::redirect('admin.php');
				}
				
				URL::redirect(URL::_("index.php?mod=users"));
			}
			Site::addSkinVar("title", Lng::_('Вход'));
		}
		else
		{
			Site::addSkinVar("title", Lng::_('Личный кабинет'));
		}
	}
	
	/**
	 * Регистрация нового пользователя
	 *
	 */
	public function registrationAction()
	{
		try
		{
			if(Request::isPost())
			{
				$this -> view -> us_name 	= 	$us_name 	= $_POST['name'];
				$this -> view -> us_email 	= 	$us_email 	= $_POST['email'];
												$password1 	= $_POST['password1'];
												$password2 	= $_POST['password2'];
				
				if($us_name == FALSE || Str::strlen($us_name) <= 1)
				{
					parent::setMessage(Lng::_('FALSE:Длина "имени" не может быть меньше двух символов'));
					throw new Exception();
				}
				//Проверяем, на находится ли имя пользователя в листе запрещенных имен
				if(Modules_Users_Models_Users::isBlackName($us_name) == TRUE)
				{
					parent::setMessage(Lng::_('FALSE:Регистрация с выбранным именем запрещена'));
					throw new Exception();					
				}
				if($password1 == FALSE || strlen($password1) < 6)
				{
					parent::setMessage(Lng::_('FALSE:Пароль должен быть больше пяти символов'));
					throw new Exception();
				}
				if($password1 != $password2)
				{
					parent::setMessage(Lng::_('FALSE:Вы не правильно подтвердили "пароль"'));
					throw new Exception();
				}
				try
				{
					CheckData::email($us_email);
				}
				catch (Exception_CheckData $e)
				{
					parent::setMessage(Lng::_('FALSE:E-mail введен в не правильном формате'));
					throw new Exception();
				}
				if($this -> getModel() -> isExistsEmail($us_email))
				{
					parent::setMessage(Lng::_('FALSE:Пользователь с указанным почтовым ящиком уже зарегистрирован. Выберете другой email для регистрации.'));
					throw new Exception();
				}
				if(CheckData::captcha($_POST['check_access']) == FALSE)
				{
					parent::setMessage(Lng::_('FALSE:Не правильно введена защита от спама'));
					throw new Exception();
				}
				 
				//Добавляем пользователя в БД
				parent::getModel("Users") -> addUser($us_name, $password1, $us_email);
				
				parent::redirect(Lng::_('TRUE:Вы успешно зарегистрировались на сайте'),"index.php?mod=users");
			}
		}
		catch (Exception $e)
		{
			if($e -> getMessage())
			{
				throw new Exception_Message($e -> getMessage(),1);
			}
		}
		
		Site::addSkinVar("title", Lng::_('Регистрация'));
		
		//Проверяем дубликат логина в БД
		Element_Autochecker::get("#us_email", "index.php?mod=users&go=aj_emailchecker", 4);
	}
	
	/**
	 * Восстановление пароля
	 *
	 */
	public function restoreAction()
	{
		try
		{
			if(Request::isPost())
			{
				$this -> view -> email = $_POST['email'];
				
				if(!CheckData::captcha($_POST['check_access']))
				{
					parent::setMessage(Lng::_('FALSE:Не правильно введены буквы и/или цифры указанные на картинке'));
					throw new Exception();
				}
				try
				{
					$UserData = parent::getModel() -> getUserByEmail($_POST['email']);
					
					CheckData::existsDataObject($UserData);
				}
				catch(Exception_CheckData $e)
				{
					parent::setMessage(Lng::_('FALSE:Не один пользователь с таким почтовым ящиком не зарегистрирован'));
					throw new Exception();
				}
				
				try
				{
					//Обновляем пароль
					$new_pass = Str::randomText(8, 'string', 'int', 'symbol');
					parent::getModel() -> updateUserPasswordByEmail($UserData -> us_email, $new_pass);
				}
				catch (Exception $e)
				{
					parent::setMessage(Lng::_('FALSE:Во время обновления пароля возникла ошибка. Повторите восстановление пароля еще раз'));
					throw new Exception();
				}
				//Получаем шаблон письма
				$Phtml = parent::getTemplate("mail.restore_pass");
				$Phtml -> us_email 		= $UserData -> us_email;
				$Phtml -> us_name 		= $UserData -> us_name;
				$Phtml -> new_pass 		= $new_pass;

				//Отправляем письмо
				if(Mail::sendMail(NULL, Registry::get("Config") -> emails -> noreply, $UserData -> us_name, $UserData -> us_email, Lng::_('Восстановление пароля'),$Phtml -> getView()))
				{
					parent::redirect(Lng::_('TRUE:На указанный Вами почтовый ящик при регистрации, выслан новый пароль'));	
				}
				parent::setMessage(Lng::_('FALSE:Во время отправки почтового сообщения возникла ошибка. Повторите восстановление пароля еще раз'));
				throw new Exception();
			}
		}
		catch (Exception $e)
		{

		}
		Site::addSkinVar("title", Lng::_('Восстановление пароля'));
	}
	
	/**
	 * Изменение профиля
	 *
	 */
	public function editAction()
	{
		User::checkPrivilegesPage(array(User::ROLE_USER, User::ROLE_ADMIN), TRUE);
		
		try
		{
			if(Request::isPost())
			{
				//Проверяем длину ИМЕНИ
				if(Str::strlen($_POST['name']) <= 1)
				{
					parent::setMessage(Lng::_('FALSE:Длина "Имени" не может быть меньше двух символов'));
					throw new Exception();
				}
				//Если пользователь захотел изменить ПАРОЛЬ
				if($_POST['password1'])
				{
					//Проверяем длину ПАРОЛЯ
					if(strlen($_POST['password1']) < 6)
					{
						parent::setMessage(Lng::_('FALSE:Пароль должен быть больше пяти символов'));
						throw new Exception();
					}
					if($_POST['password1'] != $_POST['password2'])
					{
						parent::setMessage(Lng::_('FALSE:Вы не правильно подтвердили "пароль"'));
						throw new Exception();
					}
				}
				try
				{
					CheckData::email($_POST['email']);
				}
				catch (Exception_CheckData $e)
				{
					parent::setMessage(Lng::_('FALSE:E-mail введен в не правильном формате'));
					throw new Exception();
				}

				//Проверяем, занят ли почтовый ящик
				$User = Modules_Users_Models_Users::instance() -> getUserByEmail($_POST['email']);
				if(is_object($User) == TRUE)
				{
					if($User -> us_email == $_POST['email'] && $User -> us_id != User::get('id'))
					{
						parent::setMessage(Lng::_('FALSE:E-mail занят. Выберете другой почтовый ящик.'));
						throw new Exception();
					}
				}
				
				//Обновляем данные пользователя в бд
				parent::getModel() -> updateUserDataByUsId(
					User::get('id'), 
					$_POST['name'], 
					$_POST['password1'], 
					$_POST['email']
				);

				//Получаем данные пользователя по его ID для обновления сессии
				User::set(parent::getModel() -> getUserById(User::get("id")));

				parent::redirect(Lng::_('TRUE:Данные профиля обновлены'));
			}
		}
		catch (Exception $e)
		{
			if($e -> getMessage())
			{
				throw new Exception_Message($e -> getMessage(),1);
			}
		}
		//Получаем данные пользователя по его ID
		$UserData = parent::getModel() -> getUserById(User::get("id"));

		//Устанавливаем данны в вид
		$this -> view -> us_name 	= $UserData -> us_name;
		$this -> view -> us_email 	= $UserData -> us_email;

		Site::addSkinVar('title', Lng::_('Изменение данных профиля'));
	}
	
	/**
	 * Выход с сайта
	 *
	 */
	public function logoutAction()
	{
		//Выходим из системы
		User::set();
		session_destroy();
		URL::redirect('/');
	}

	/**
	 * Авторизация и вход на сайт через Loginza
	 */
	public function loginzaAction()
	{
		
	}
	
	/********************************************************************************************************************/
	/************************************************** AJAX METHODS ****************************************************/
	/********************************************************************************************************************/
	
	/**
	 * Проверка существования логина в БД Ajax способом
	 *
	 */
	public function aj_emailcheckerAction()
	{
		CheckData::isAjax();
		
		//Установка данных
		$email = Request::getGet('val', 'trim');
		
		try
		{
			CheckData::email($email);
		}
		catch (Exception $e)
		{
			die('<br><small class="important">'.Lng::_('Не правильный формат почтового адреса').'</small>');
		}
		
		//Проверяем наличие ЛОГИНА в БД
		if($this -> getModel() -> isExistsEmail($email) == TRUE)
		{
			die('<br><small class="important">'.Lng::_('Выбранный Вами e-mail занят').'</small>');
		}
		die('<br><small class="secondary">'.Lng::_('E-mail свободен').'</small>');
	}
}