<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Контроллер "Users", для формирования sitemap.xml файла
 */

class Modules_Users_Controllers_Sitemap extends Guard_Base
{
	/**
	 * Возвращает элементы для формирования sitemap.xml файла
	 *
	 * @return array
	 */
	public function getElements()
	{
		return array("index" 		=> array("changefreq" => "yearly", "priority" => "0.5", "lastmod" => ""),//Главная страница модуля
					 "registration" => array("changefreq" => "yearly", "priority" => "0.5", "lastmod" => ""),//Страница регистрации пользователя
					 "restore" 		=> array("changefreq" => "yearly", "priority" => "0.5", "lastmod" => ""));//Страница восстановления пароля
	}
	
	/**
	 * Формирует часть sitemap.xml файла
	 *
	 * @param array $data_ar данные
	 */
	public function formedSitemapFile($data_ar=array())
	{
		$host = URL::getHost()."/";
		$c  = Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=users"),$data_ar['index']['lastmod'],$data_ar['index']['changefreq'],$data_ar['index']['priority']);
		$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=users&go=registration"),$data_ar['registration']['lastmod'],$data_ar['registration']['changefreq'],$data_ar['registration']['priority']);
		$c .= Sitemap::formedUrlBlock($host.URL::trans("index.php?mod=users&go=restore"),$data_ar['restore']['lastmod'],$data_ar['restore']['changefreq'],$data_ar['restore']['priority']);
		
		return $c;
	}
}