<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Модель "Users"
 */

class Modules_Users_Models_Users extends Guard_Model
{
	/**
	 * Соль пароля
	 * @var string
	 */
	const SALT = 'ygaifqw37874w7y8&Y*&YHJGfytf7';
	
	/**
	 * Возвращает объект
	 *
	 * @return object
	 */
	public static function instance()
	{
		static $Instance;
		
		if(!is_object($Instance))
		{
			$Instance = new self;
		}
		return $Instance;
	}
	
	/**
	 * Возвращает данные пользователя
	 *
	 * @param string $us_email
	 * @param string $us_password
	 * @return array
	 */
	public function getUserByEmailPassword($us_email = NULL, $us_password = NULL)
	{
		$sql = "SELECT *  
				FROM 
			`#__mod_user`
				WHERE
			`us_email`='".mysql_real_escape_string($us_email)."'
				AND 
			`us_password`='".$this -> _formedPassword($us_password)."'";

		return $this -> DB -> setQuery($sql,"Не удалось получить данные пользователя",true);
	}
	
	/**
	 * Возвращает данные пользователя по его почтовому ящику
	 *
	 * @param string $us_email
	 * @return string
	 */
	public function getUserByEmail($us_email = NULL)
	{
		return parent::getDataById("mod_user", "us_email", mysql_real_escape_string($us_email), "Не удалось получить данные пользователя");
	}
	
	/**
	 * Возвращает данные пользователя по его логину
	 *
	 * @param string $us_id ID
	 * @return string
	 */
	public function getUserById($us_id = NULL)
	{
		return parent::getDataById("mod_user", "us_id", ((int)$us_id), "Не удалось получить данные пользователя");
	}
	
	/**
	 * Возвращает данные всех пользователей
	 *
	 * @return array
	 */
	public function getAllUsers()
	{
		$sql = "SELECT *  
				FROM 
			`#__mod_user`
				WHERE 
			`us_role`<>'".User::ROLE_DELETE."'";

		return parent::sqlToArray($sql, 'us_id', 'Не удалось получить данные пользователя');
	}
	
	/**
	 * Возвращает данные пользователей
	 *
	 * @param int $ls 
	 * @param int $lf
	 * @return string
	 */
	public function getUsers($ls = 0, $lf = -1)
	{
		$sql = "SELECT `u`.*,  COUNT(`a`.`ad_id`) AS `ad_count`
				FROM 
			`#__mod_user` AS `u` 
				LEFT JOIN
			`#__mod_board_ad` AS `a`
				ON (`u`.`us_id`=`a`.`us_id`)
				GROUP BY `u`.`us_id`
				ORDER BY `u`.`us_id` ASC"; 
		$sql .= $lf > 0 ? " LIMIT ".$ls.",".$lf : "";

		return parent::sqlToArray($sql,'us_id', 'Не удалось получить данные пользователя');
	}
	
	/**
	 * Добавляет пользователя в БД
	 *
	 * @param string $us_name
	 * @param string $us_password
	 * @param string $us_email
	 */
	public function addUser($us_name = NULL, $us_password = NULL, $us_email = NULL)
	{
		$sql = "INSERT INTO  
			`#__mod_user`
			(`us_name`, 
			 `us_password`, 
			 `us_email`, 
			 `us_role`) 
				VALUES
			('".mysql_real_escape_string($us_name)."', 
			 '".$this -> _formedPassword($us_password)."', 
			 '".mysql_real_escape_string($us_email)."',
			 '".User::ROLE_USER."')";
		
		$this -> DB -> setQuery($sql,"Во время регистрации возникла ошибка");
	}
	
	/**
	 * Обновляет данные пользователя
	 *
	 * @param int $us_id
	 * @param string $us_name
	 * @param string $us_password
	 * @param string $us_email
	 * @param string $us_role
	 */
	public function updateUserDataByUsId($us_id = 0, $us_name = NULL, $us_password = NULL, $us_email = NULL, $us_role = NULL)
	{
		$sql = "UPDATE 
			`#__mod_user`
				SET
			`us_name`='".mysql_real_escape_string($us_name)."', ";
		
		$sql .= $us_password ? "`us_password`='".$this -> _formedPassword($us_password)."', " : "";
		$sql .= $us_role ? "`us_role`='".$us_role."', " : "";
		
		
		$sql .= "`us_email`='".mysql_real_escape_string($us_email)."' 
				WHERE 
			`us_id`='".((int)$us_id)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось обновить данные пользователя");
	}	
	
	/**
	 * Изменяет активность пользователя
	 *
	 * @param int $us_id
	 * @param int $active Активный пользователь или нет, 0-бан, 1-активный
	 */
	public function updateUserActiveByUsId($us_id = 0, $active = 0)
	{
		$sql = "UPDATE 
			`#__mod_user`
				SET
			`us_role`='".($active == 0 ? User::ROLE_BANNED : User::ROLE_USER)."'
				WHERE 
			`us_id`='".((int)$us_id)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось изменить состояние активности пользователя");
	}
	
	/**
	 * Обновляет пароль пользователя по почтовому ящику
	 *
	 * @param string $us_email
	 * @param string $us_password
	 */
	public function updateUserPasswordByEmail($us_email = NULL, $us_password = NULL)
	{
		$sql = "UPDATE 
			`#__mod_user`
				SET
			`us_password`='".$this -> _formedPassword($us_password)."' 
				WHERE 
			`us_email`='".mysql_real_escape_string($us_email)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось обновить пароль пользователя");
	}
	
	/**
	 * Удаляет пользователя
	 *
	 * @param int $us_id id пользователя
	 */
	public function updateDeleteUserById($us_id = 0)
	{
		$sql = "UPDATE `#__mod_user`
				SET 
			`us_role`='".User::ROLE_DELETE."'
				WHERE 
			`us_id`='".((int)$us_id)."'";
		
		$this -> DB -> setQuery($sql,"Не удалось удалить пользователя");
	}
	
	/**
	 * Возвращает количество зарегистрированных пользователей
	 *
	 * @return int
	 */
	public function countUsers()
	{
		$sql = "SELECT `us_id` 
				FROM 
			`#__mod_user`";
				
		return $this -> DB -> setQuery($sql,"Не удалось определить количество зарегистрированных пользователей","getCount");
	}
	
	/**
	 * Проверяет существования логина в БД
	 *
	 * @param string $us_email E-mail
	 * @return bool
	 */
	public function isExistsEmail($us_email = NULL)
	{
		$UserData = $this -> getUserByEmail($us_email);
		
		$count = 1;
		try
		{
			CheckData::existsDataObject($UserData);
		}
		catch (Exception_CheckData $e)
		{
			$count = 0;
		}

		return $count;
	}
	
	/**
	 * Проверяет существования пользователяы в БД
	 *
	 * @param int $us_id
	 * @return bool
	 */
	public function isExistsId($us_id = 0)
	{
		$UserData = $this -> getUserById($us_id);
		
		$count = 1;
		try
		{
			CheckData::existsDataObject($UserData);
		}
		catch (Exception_CheckData $e)
		{
			$count = 0;
		}

		return $count;
	}
	
	//===========================================================
	// CHECKED METHODS
	//===========================================================
	
	/**
	 * Проверяет, находится ли имя в черном списке имен
	 *
	 * @param string $name имя
	 */
	public static function isBlackName($name = NULL)
	{
		return in_array($name, include_once('./files/db/models/users/blacknames.php'));
	}
	
   	/********************************************************************************************************************/
   	/************************************************* PRIVATE METHODS **************************************************/
   	/********************************************************************************************************************/
   	
   	/**
   	 * Выполняет формирование пароля
   	 * @param $us_password
   	 */
   	private function _formedPassword($us_password = NULL)
   	{
   		return md5(self::SALT.mysql_real_escape_string($us_password).self::SALT);
	}
}