<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Сервис работы с доской объявлений
 */

class Services_Board_Service extends Guard_Base
{
	public function __construct()
	{
		if(isset($_GET['ser']) && $_GET['ser'] == "board/show_ad")
		{
			$count = isset($_GET['count']) ? (int)$_GET['count'] : 1;
			
			$DB = Factory::getModel() -> DB;
			
			$Result = $DB -> setQuery("
				SELECT `ad_id`, `ad_title`
					FROM 
				`#__mod_board_ad` 
					WHERE 
				`ad_is_lock`=1
					AND
				`ad_is_cron`=1
				ORDER BY RAND()
				LIMIT ".$count,
				'Не удалось получить ID объявлений для публикации'
			);
			
			$ad_id_ar = array();
			$ads_ar = array();
			while($Data = $DB -> getObject($Result))
			{
				$ad_id_ar[$Data -> ad_id] = $Data -> ad_id;
				$ads_ar[$Data -> ad_id] = $Data;
			}
			
			if(sizeof($ad_id_ar) > 0)
			{
				$Result = $DB -> setQuery("
						UPDATE
					`#__mod_board_ad` 
						SET
					`ad_is_cron`=0,
					`ad_is_lock`=0
						WHERE 
					`ad_id`IN (".join(',', $ad_id_ar).")",
					'Не удалось опубликовать объявления'
				);
			}
			//Получаем конфигурационные данные
			$Config = Registry::get("Config");			
			
			$body  = 'Публикация шуток на сайте "'.$Config -> site -> title.'" ['.URL::getHost().']<br>';
			$body .= 'Дата: '.date(Str::dateDTS).'<br>';
			$body .= 'Опубликованы следующие объявления:';
			$body .= '<ul>';
			foreach ($ads_ar as $Ad)
			{
				$body .= '<li>'.Helper_HTML::anchor(URL::getHost().'/index.php?mod=board&go=ad&ad_id='.$Ad -> ad_id, $Ad -> ad_title).'</li>';
			}
			$body .= '</ul>';
			$body .= 'Опубликовано <b>'.sizeof($ad_id_ar).'</b> объявлени.';

			Mail::sendMail(
				NULL,
				$Config -> emails -> noreply, 
				$Config -> contacts -> admin, 
				$Config -> contacts -> email, 
				'Публикация объявлений на сайте "'.$Config -> site -> title.'" ['.URL::getHost().'], '.date(Str::dateDTS),
				$body
			);
			
			//Удаляем данные кэша
			CacheFile::instance() -> clean();
			exit;
		}
		else if(isset($_GET['ser']) && $_GET['ser'] == "board/delete_old_services")
		{
			$DB = Factory::getModel() -> DB;
			
			$DB -> setQuery("
				UPDATE 
					`#__mod_board_ad` 
				SET
				`ad_vip_date` = 0
					WHERE 
				`ad_vip_date` < ".time()
			);
			
			$DB -> setQuery("
				UPDATE 
					`#__mod_board_ad` 
				SET
				`ad_style_date` = 0,
				`ad_style` = ''
					WHERE 
				`ad_style_date` < ".time()
			);
			
			$DB -> setQuery("
				UPDATE 
					`#__mod_board_ad` 
				SET
				`ad_topin_date` = 0
					WHERE 
				`ad_topin_date` < ".time()
			);
			
			exit;
		}
	}
}