<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Сервис - Крон, сбор логфайлов 
 */

class Services_CronLog_Service
{
	public function __construct()
	{
		if(!isset($_GET['ser']) || $_GET['ser'] != "cronlog"){return;}
		
		//Инициализация объектов
		$Config = Registry::get('Config');
		$Mail = new Mail();
		
		$Mail -> setFromUser(NULL, $Config -> emails -> noreply);
		$Mail -> setSubject("Сбор лог-файлов кроном (".Str::dateDTS().")");
		$Mail -> addAddress($Config -> contacts -> email,$Config -> contacts -> admin);
		
		
		$doing = array(
			"./files/.logs/errors.log",
			"./files/.logs/".Log::FILE_440,
			"./files/.logs/".Log::FILE_500,
			"./files/.logs/".Log::FILE_AJAX,
			"./files/.logs/".Log::FILE_DB,
			"./files/.logs/".Log::FILE_EXCEPTION,
			"./files/.logs/".Log::FILE_MESSAGE,
			"./files/.logs/".Log::FILE_PRIVILEGES,
		);
		$count_logs = 0;
		foreach($doing as $file)
		{
			if(is_file($file))
			{
				$count_logs++;
				$Mail -> attachFile($file);
			}
		}
		
		$body  = "<h4>Выполнен регулярный сбор данных с сайта ".Helper_HTML::anchor($Config -> site -> host,$Config -> site -> host)."</h4>";
		$body .= "<p>";
		$body .= "Дата: ".date("Y.m.d H:i:s")."<br>";
		if($count_logs)
		{
			$body .= "С сайта собрано $count_logs лог-файл(ов).<br>";
			$body .= "После отправки письма, лог-файлы были удалены.";
		}
		else
		{
			$body .= "Не один файл не прикреплен.";
		}
		$body .= "</p>";
		$body .= "<p><i>Перейти на сайт ".Helper_HTML::anchor($Config -> site -> host,$Config -> site -> host)."</i></p>";
		
		$Mail -> setBody($body);
		
		if($count_logs)
		{
			if($Mail -> send())
			{
				foreach($doing as $file)
				{
					if(is_file($file))
					{
						unlink($file);
					}
				}
			}
		}
		exit;
	}
}