<?php defined("MOMENT_BOARD") or die("Access denied");
/**
 * @package MomentBoard v2.0
 * @copyright (c) guardeon.biz
 * @link http://guardeon.biz/
 * @author Pavel <support@guardeon.biz>
 * @desc Сервис - RSS лента последних объявлений 
 */

class Services_RssBoard_Service extends Guard_Base
{
	/**
	 * Ключ группы кэширования
	 *
	 */
	const CATCH_GROUP = 'ser_rssboard';
	
	public function __construct()
	{
		$Config =& Registry::get('Config');
		if(isset($_GET['ser']) && $_GET['ser'] == "board.rss")
		{
			//Установка данных
			$cat_id = Request::getGet("cat_id","int",FALSE);
			
			//Получаем данные кэширования
			$Cache = CacheFile::instance();
			//Ключ кэширования
			$cache_key = __METHOD__.($cat_id ? $cat_id : '');
			//Получаем данные кэша
			$cache_data = $Cache -> get($cache_key, Str::DATE_DAY, Services_RssBoard_Service::CATCH_GROUP);
			
			//Если нужно, кэшируем данные
			if ($cache_data == FALSE)
			{
				//Массив рубрик объявлений
				$ad_ar = array();
				//Формируем название рубрики
				$cat_title = '';
				
				if($cat_id)
				{
					//Получаем название рубрики для последующей вставки в заголовок RSS ленты
					$CategoryData = parent::getModel("Category","Board") -> getCategoryById($cat_id);
					
			/*===========================================================================================================/
			/*						Код взят со метода Modules_Board_Controllers_Index::viewcatAction() 				*/
			/*-------------------------------------------------[НАЧАЛО]-------------------------------------------------*/
					//Получаем данные всех категорий и формируем с них дерево
					$cat_ar = parent::getModel("Category","Board") -> prepCategory("getCategory");
					
					//Получаем часть дерева, для формирования подрубрик
					$cat_for_ad_ar = Category::getTreeByDepth($cat_ar,$cat_id,1000);
							
					//Переформировываем массив категорий для получения по ним объявлений
					$cat_fad_ar = parent::getLib("General","Board") -> prepareCatData($cat_for_ad_ar);
					$cat_fad_ar[$cat_id] = $cat_id;
					
					//Получаем объявления рубрики
					$ad_ar = parent::getModel("Ad","Board") -> getAdByCatArLimit($cat_fad_ar,0,50);
			/*-------------------------------------------------[КОНЕЦ]-------------------------------------------------*/
			/*=========================================================================================================*/
					if(isset($CategoryData -> cat_title))
					{
						//Формируем название рубрики
						$cat_title = ", рубрика - ".$CategoryData -> cat_title;
					}
				}
				else
				{
					//Получаем полседние объявления
					$ad_ar = parent::getModel("Ad","Board") -> getAdByLimitUnlock(0,50);
				}
	
				//Создаем RSS ленту
				$Rss = new RSSCreator("Доска объявлений - ".$Config -> site -> title.$cat_title, URL::site(), $Config -> site -> description);
				
				if(sizeof($ad_ar) > 0)
				{
					foreach($ad_ar as $Ad)
					{
						$Rss -> setItem($Ad -> ad_title, URL::site('index.php?mod=board&go=ad&ad_id='.$Ad -> ad_id, $Ad -> ad_title),(Str::strlen($Ad -> ad_text) > 200 ? nl2br(Str::substr($Ad -> ad_text, 0, 200)).'...' : nl2br($Ad -> ad_text)));
					}
				}
				$cache_data = $Rss -> getRss();
				//Кэшируем данные
				$Cache -> set($cache_data, $cache_key, Services_RssBoard_Service::CATCH_GROUP);
			}
			
			header("content-type: application/rss+xml");
			//header("Content-Type: application/xml");
			echo $cache_data;
			die;
		}
		Site::addSkinVar("style", "<link rel=\"alternate\" href=\"".$Config -> site -> host."/index.php?ser=board.rss\" type=\"application/rss+xml\" title=\"".$this -> XMLData['title']."\">\n");
	}
}